$chip(6502)
$paginate

;
;
; This file contains variables that reside in auxilliary memory.
; Refer to "auxseg.inc" to determine the address ranges for the
; segments used.
;
;

frame	 %macro   pointer,color,x_os,y_os,flag
	 db	  x_os
	 db	  y_os
	 db	  color
	 db	  flag
	 dw	  pointer
	 %endm

	%include  auxseg.inc
	%include  colorext.inc

	 extern   BORBUT1R
	 extern   BORHED1R
	 extern   BORBUT2R
	 extern   BORHED2R
	 extern   BORBUT1L
	 extern   BORBUT2L
	 extern   BORHED2L
	 extern   BORHED1L
	 extern   RAYBUT2R
	 extern   RAYBUT1R
	 extern   RAYHED3R
	 extern   RAYHED1R
	 extern   RAYBUT3L
	 extern   RAYBUT2L
	 extern   RAYBUT1L
	 extern   RAYHED3L
	 extern   RAYHED1L
	 extern   RAYBUT3R
	 extern   STINGER1
	 extern   STINGER2
	 extern   STINGER3
	 extern   STINGER4
	 extern   MANOWAR1
	 extern   MANOWAR2
	 extern   MANOWAR3
	 extern   MANOWAR4
	 extern   HOPPER1L
	 extern   HOPPER2L
	 extern   HOPPER3L
	 extern   HOPPER4L
	 extern   HOPPER1R
	 extern   HOPPER2R
	 extern   HOPPER3R
	 extern   HOPPER4R
	 extern   HOPFRNT1
	 extern   HOPFRNT2



	 public   table_rooms,table_bits,characterindex
	 public   characterdataaux,characterdatamain

	 public   table_onevaluememorywrite

	 public   borrght1,borrght2,borleft1,borleft2

	public	table_sprite_poses

	 public   grd_table,table_arrows,room_creature_status_table
	 public   currently_active_beasties,special_creature_init_data
	 public   creature_image_block
	 public   norm,invert,null


norm	equ	$e6
invert	equ	$c6
null	equ	0



	 seg	  aux_common_data


;
; referenced by sarrow (arrowlog.asm)
;
table_arrows
	db	163,022,163,040,163,062,163,083,163,104,163,124,163,145

;
; referenced by room (roomperc.asm)
;
table_rooms
	db	0,0,0,0,0,0,0,0,0,0,0,0,$f0
table_bits
	db	1,2,4,8,16,32,64,128

table_sprite_poses
	 db	  1,4,2,2,2,3,1,4,1,4

table_onevaluememorywrite  ds		     7

;
; referenced by digits (digits.asm)
;

CharacterIndex
	db	0,10,20,30,40,50,60,70,80,90
	db	100,110,120,130,140,150

CharacterDataAux
	db	$00,$3f 	;0
	db	$70,$7c
	db	$70,$43
	db	$70,$40
	db	$00,$3f

	db	$00,$03 	;1
	db	$00,$03
	db	$00,$03
	db	$00,$03
	db	$00,$3f

	db	$70,$3f 	;2
	db	$00,$40
	db	$00,$3f
	db	$70,$00
	db	$70,$7f

	db	$70,$3f 	;3
	db	$00,$40
	db	$70,$3f
	db	$00,$40
	db	$70,$3f

	db	$70,$40 	;4
	db	$70,$40
	db	$70,$7f
	db	$00,$40
	db	$00,$40

	db	$70,$7f 	;5
	db	$70,$00
	db	$70,$3f
	db	$00,$40
	db	$70,$3f

	db	$00,$3f 	;6
	db	$70,$00
	db	$70,$3f
	db	$70,$40
	db	$00,$3f

	db	$70,$7f 	;7
	db	$00,$40
	db	$00,$3c
	db	$00,$03
	db	$00,$03

	db	$00,$3f 	;8
	db	$70,$40
	db	$00,$3f
	db	$70,$40
	db	$00,$3f

	db	$00,$1b 	;green bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$67 	;purple bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$03 	;black bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$47 	;blue bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

CharacterDataMain
	db	$7f,$00 	;0
	db	$01,$03
	db	$61,$03
	db	$1f,$03
	db	$7f,$00

	db	$60,$00 	;1
	db	$7e,$00
	db	$60,$00
	db	$60,$00
	db	$7e,$00

	db	$7f,$00 	;2
	db	$00,$03
	db	$7f,$00
	db	$01,$00
	db	$7f,$03

	db	$7f,$00 	;3
	db	$00,$03
	db	$7f,$00
	db	$00,$03
	db	$7f,$00

	db	$01,$03 	;4
	db	$01,$03
	db	$7f,$03
	db	$00,$03
	db	$00,$03

	db	$7f,$03 	;5
	db	$01,$00
	db	$7f,$00
	db	$00,$03
	db	$7f,$00

	db	$7e,$00 	;6
	db	$01,$00
	db	$ff,$00
	db	$01,$03
	db	$7f,$00

	db	$7f,$03 	;7
	db	$00,$03
	db	$00,$00
	db	$60,$00
	db	$60,$00

	db	$7f,$00 	;8
	db	$01,$03
	db	$7f,$00
	db	$01,$03
	db	$7f,$00

	db	$00,$33 	;green bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$4c 	;purple bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$00 	;black bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff

	db	$00,$08 	;blue bar
	db	$01,$01
	db	$ff,$ff
	db	$ff,$ff
	db	$ff,$ff


grdinit_data	  proc
;
; referenced by grdinit (grdinit.asm)
;
;
;	 current_guard_flag/first entry in grd_table:
;	 (logical 1 = true)
;
;					       7 6 5 4 3 2 1 0
;* guard alive ------------------------------- X
;* vertical guard ------------------------------ X
;  don't care ------------------------------------ X
;  active shot ------------------------------------- X
;* starting room ------------------------------------- X X
;  current guard room ------------------------------------ X X
;
; *=pertains to first field in GRD_TABLE
;
;
..alive  equ	  $80
..vert	 equ	  $40
..horz	 equ	  $00
..rm1	 equ	  $00
..rm2	 equ	  $04
..rm3	 equ	  $08

grd_table
	 db	  ..alive OR ..vert OR ..rm1,42,41,$ff,$47+20,$40
	 db	  ..alive OR ..horz OR ..rm1,45,43,$ff,$1b+20,$59
	 db	  ..alive OR ..horz OR ..rm2,59,60,$ff,$74+20,$41
	 db	  ..alive OR ..horz OR ..rm2,44,58,$ff,$65+20,$71
	 db	  ..alive OR ..horz OR ..rm2,61,64,$ff,$74+20,$81
	 db	  ..alive OR ..horz OR ..rm2,54,55, 65,$46+20,$39
	 db	  ..alive OR ..horz OR ..rm2,62,63,$ff,$74+20,$41
	 db	  ..alive OR ..vert OR ..rm1,68,67, 66,$46+20,$40
	 db	  ..alive OR ..horz OR ..rm1,71,69,$ff,$1a+20,$2d
	 db	  ..alive OR ..horz OR ..rm1,57,70,$ff,$1a+20,$41
	 db	  ..alive OR ..horz OR ..rm1,53,56,$ff,$1a+20,$41
	 db	  ..alive OR ..vert OR ..rm2,50,46,$ff,$70+20,$80
	 db	  ..alive OR ..horz OR ..rm1,48,47,$ff,$44+20,$81
	 db	  ..alive OR ..horz OR ..rm1,52,51,$ff,$1a+20,$81
	 db	  ..alive OR ..horz OR ..rm1,75,74,$ff,$1a+20,$81
	 db	  ..alive OR ..horz OR ..rm1,73,72,$ff,$1a+20,$81
	 db	  ..alive OR ..horz OR ..rm1,79,82,$ff,$1a+20,$71
	 db	  ..alive OR ..vert OR ..rm1,84,83,$ff,$48+20,$40
	 db	  ..alive OR ..vert OR ..rm1,81,78, 77,$55+20,$40
	 db	  ..alive OR ..vert OR ..rm1,95,89,$ff,$54+20,$40
	 db	  ..alive OR ..horz OR ..rm2,88,87,$ff,$74+20,$31
	 db	  ..alive OR ..horz OR ..rm1,86,85,$ff,$1a+20,$41
	 db	  ..alive OR ..vert OR ..rm1,91,90,$ff,$46+20,$40
	 db	  ..alive OR ..horz OR ..rm1,93,92,$ff,$1a+20,$81
	 db	  ..alive OR ..horz OR ..rm1,97,96,$ff,$1a+20,$79
	 db	  ..alive OR ..vert OR ..rm3,98,99,100,$74+20,$71


grdinit_data	  endproc

room_creature_status_table
	 ds	  100

special_creature_init_data
	 ds	  3

currently_active_beasties
	 ds	  1

borleft1
	 frame	  borhed1l,orange,-10,-20,norm
	 frame	  borbut1l,orange,  1,-20,norm

borleft2
	 frame	  borhed2l,orange,-10,-20,norm
	 frame	  borbut2l,orange,  1,-20,norm

borrght1
	 frame	  borhed1r,orange,000,-20,norm
	 frame	  borbut1r,orange,-11,-20,norm

borrght2
	 frame	  borhed2r,orange,000,-20,norm
	 frame	  borbut2r,orange,-11,-20,norm


; addition of creatures  4-29-88

manowar_frame1
	frame	manowar1,white,0,-21,norm
manowar_frame2
	frame	manowar2,white,0,-21,norm
manowar_frame3
	frame	manowar3,white,0,-21,norm
manowar_frame4
	frame	manowar4,white,0,-21,norm

stinger_frame1
	frame	stinger1,green,0,-18,norm
stinger_frame2
	frame	stinger2,green,0,-18,norm
stinger_frame3
	frame	stinger3,green,0,-18,norm
stinger_frame4
	frame	stinger4,green,0,-18,norm

hopper_right_frame1
	frame	hopper1r,orange,0,-30,norm
hopper_right_frame2
	frame	hopper2r,orange,0,-31,norm
hopper_right_frame3
	frame	hopper3r,orange,0,-29,norm
hopper_right_frame4
	frame	hopper4r,orange,0,-30,norm
hopper_left_frame1
	frame	hopper1l,orange,0,-30,norm
hopper_left_frame2
	frame	hopper2l,orange,0,-31,norm
hopper_left_frame3
	frame	hopper3l,orange,0,-29,norm
hopper_left_frame4
	frame	hopper4l,orange,0,-30,norm
hopper_front_frame1
	frame	hopfrnt1,orange,0,-26,norm
hopper_front_frame2
	frame	hopfrnt2,orange,0,-27,norm

ray_right_frame1
	frame	rayhed1r,gray_2,0,-18,norm
	frame	raybut1r,gray_2,-11,-19,norm
ray_right_frame2
	frame	rayhed3r,gray_2,0,-23,norm
	frame	raybut2r,gray_2,-11,-24,norm
ray_right_frame3
	frame	rayhed3r,gray_2,0,-23,norm
	frame	raybut3r,gray_2,-12,-27,norm
ray_left_frame1
	frame	rayhed1l,gray_2,-12,-18,norm
	frame	raybut1l,gray_2,0,-19,norm
ray_left_frame2
	frame	rayhed3l,gray_2,-11,-23,norm
	frame	raybut2l,gray_2,0,-24,norm
ray_left_frame3
	frame	rayhed3l,gray_2,-11,-23,norm
	frame	raybut3l,gray_2,0,-27,norm

  ;	  seg	  frametab_data
creature_image_block
	dw	stinger_frame1			;0
	dw	stinger_frame2
	dw	stinger_frame3
	dw	stinger_frame4

	dw	manowar_frame1			;4
	dw	manowar_frame2
	dw	manowar_frame3
	dw	manowar_frame4

	dw	hopper_right_frame1		;8
	dw	hopper_right_frame2
	dw	hopper_right_frame3
	dw	hopper_right_frame4
	dw	hopper_left_frame1		;12
	dw	hopper_left_frame2
	dw	hopper_left_frame3
	dw	hopper_left_frame4
	dw	hopper_front_frame1		;16
	dw	hopper_front_frame2

	dw	ray_right_frame1		;18
	dw	ray_right_frame2
	dw	ray_right_frame3
	dw	ray_left_frame1 		;21
	dw	ray_left_frame2
	dw	ray_left_frame3

	dw	borleft1			;24
	dw	borleft2
	dw	borrght1			;26
	dw	borrght2


	 end
