$chip(6502)
$paginate

;	 defseg  maincode
;	 defseg  maindata
;	THIS IS THE LOGIC FOR IMPLEMENTING THE CREATURE BAR
;
;  INSERT EXTERN AND PUBLIC HERE.......
	PUBLic	bar
	public	end_game, creature_flag
	EXTERN	creature_number,HEADFLAG, FACING, hero_x,die_i
	EXTERN	hero_y, CHECKBACKGROUND
	EXTERN	COLUMN, scan, arrow_position, digits
	extern	jumpto,prmsec,stamp,wr_main,rd_main,setroom_b,page1
	extern	sarrow, eraseorview	,panel2
	extern	bot_parts, creature_table   ,call_sprite_routine
	extern	setbeastie,beastie_flag,test_borer_release
	extern	test_hopper_release ,hero_death_flag
	extern	headflip,game_start			     ;kam 5-9-88

	%include macro.inc
	%include prmseg.inc
;
;  CONVERT NAMES GIVEN HERE TO THOSE USED IN EXTERNAL PROGRAMS!!!!!!!!!
;	COLUMN,ROW,X HERO POSITION,Y HERO POSITION,bot_parts
;	HEADFLAG,HERO FACING,BACKGROUND CHECK,end_game

	seg	maincode
bar	proc

	lda	creature_number
	cmp	#3
	beq	..continue0.1		;skip flag reset if ray chosen
	lda	beastie_flag
	bne	..continue0.1
	sta	creature_flag		;reset flags, creature used up
	sta	creature_number

..continue0.1
	lda	arrow_position		;get creature number
	sta	..temp
	lbeq	..end_game		;end game
	cmp	#6
	lbeq	change_hero		;hero form change
	tax
	lda	creature_table,x       ;number of creatures available
	lbeq	..exit1 		 ;    none


	lda	creature_flag		;creature already selected
	and	#$c0
	lbne	..exit1 		 ;yes

	lda	headflag		;hero state
	beq	..continue1.1		;droid
	cpx	#3			;we are a bot, are we selecting ray
	lbne	..exit1 		 ;   no

..continue1
	txa
	and	#01
	bne	..continue2		;creature sits on head (or ray)

;interface to use rich's background checking routines (beastie)
	cpx	#2
	bne	..here1
	lda	#$10			;get proper value if borer
	sta	beastie_flag
	jsr	test_borer_release
	jmp	..continue3
..here1
	stx	beastie_flag		;test for hopper
	jsr	test_hopper_release
..continue3
	bcc	..leave
	jsr	setbeastie		;set up sprite block
	jsr	call_sprite_routine	;put sprites to screen
	jmp	..continue4
..leave
	lda	#0
	sta	beastie_flag
	jmp	..exit1
;interface done
..continue1.1
	lda	bot_parts
	cmp	#7
	beq	..continue1
	cpx	#3
	bne	..continue1
	jmp	..exit1

; this is the end of the condition checker to determine
; if a creature is to be selected
;


..continue4
..continue2
	ldx	..temp
	stx	creature_number
	ldy	creature_table,x
	dey				;dec number of monsters you have
	tya
	sta	creature_table,x
	lda	#$c0
	sta	creature_flag		;set flags for creature chosen

	lda	#0
	sta	eraseorview
	long	prmsec,digits
;	 jsr	 digits 		 ;redraw digits

	lda	creature_number 	;put creature on screen
	cmp	#3			;(unless its a ray)
	beq	..exit1
	and	#1
	beq	..exit1 		;hopper,borer (already done)

	lda	creature_number 	;major kam mod	4-28-88 **********
	cmp	#1
	bne	..next100
	lda	#2
	jmp	..here2
..next100
	lda	#1
..here2
	sta	beastie_flag
	jsr	setbeastie
	jsr	call_sprite_routine	;display creature
	jmp	..exit1

change_hero
	lda	bot_parts		;does hero have all bot parts
	cmp	#7
	bne	..exit1
	lda	creature_flag		;creature released during this use of panel
	bmi	..exit1

	lda	#$ff
	sta	headflip
	long	prmsec,panel2	      ;restamp panel2
	sec
	jmp	..exit2

..end_game
	ldx	#$ff			;by suicide
	txs
	stx	hero_death_flag
	sta	rd_main
	sta	wr_main
	jmp	game_start

end_game
	 lda	#$ff			;by death
	 sta	hero_death_flag
	 jmp	 die_i		      ;end the game

..exit1 lda	creature_flag		;remove flag for this use of panel
	and	#$40
	sta	creature_flag
	clc
..exit2 rts

	seg   maindata
; **** data storage for this routine ***

creature_flag
	ds	1
;creature_number
;	 ds	 1
..temp	ds	1

bar	endproc

	end


