$chip(6502)
$paginate
$allpublic
$erronly


	 %include prmseg.inc
	 %include zpext.asm
	 %include colorext.inc
	 %include macro.inc

	 extern   hero_x,hero_y,headflag,facing,checkbackground
	 extern   column,scan,prim,null,norm,invert,spr_9,hopfrnt1
	 extern   wr_aux,rd_aux,wr_main,rd_main,beastie_flag
	 extern   borleft1,borleft2,borrght1,borrght2,spr_8
	 extern   speaker,prmsec,stamp
	 extern   current_room
	 extern  fist_animation_flag,current_room,beastie_flag
	 extern   displaystampedstuff,prmsec
	 extern   fist_pose
	 extern   center_body_part_flag,center_body_part_gone

	 extern   borer_seq,borer_facing,borer_frame,borer_x,borer_y
	 extern   chewed_wall_frame,boring_flag,hopper_x,hopper_y
	 extern   hopper_frame

	 seg	  maincode

test_borer_release	   proc

;
; routine to test if borer should be released.
;
; A,X,Y,P - scrambled
;
; carry flag indicates successful release (c=1=released)
;
	 lda	  headflag
	 lbne	  ..not_released

	 lda	  hero_y
	 sta	  borer_y

	 lda	  facing
	 beq	  ..test_left_facing

..test_right_facing
	 lda	  #$01
	 sta	  borer_facing

	 lda	  hero_x
	 cmp	  #138
	 lbcs	  ..not_released
	 clc
	 adc	  #7
	 sta	  temp1
	 bne	  ..check_for_ground

..test_left_facing
	 sta	  borer_facing

	 lda	  hero_x
	 cmp	  #46
	 bcc	  ..not_released
	 sec
	 sbc	  #12
	 sta	  temp1


..check_for_ground
	 ldx	  borer_facing
	 beq	  ..check_for_ground_left

..check_for_ground_right
	 clc
	 adc	  #15
	 sta	  column
	 lda	  borer_y
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..init_borer_stuff
	 jmp	  ..not_released

..check_for_ground_left
	 sec
	 sbc	  #12
	 sta	  column
	 lda	  borer_y
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..init_borer_stuff
	 jmp	  ..not_released



..init_borer_stuff
	 lda	  #$00
	 sta	  borer_frame

	 lda	  #$03
	 sta	  borer_wait

	 lda	  temp1

	 ldx	  borer_facing
	 beq	  ..init_left_borer

..init_right_borer
	 clc
	 adc	  #09
	 jmp	  ..store_borer_x

..init_left_borer
	 sec
	 sbc	  #6

..store_borer_x
	 sta	  borer_x

	 ldx	  #$ff
	 stx	  chewed_wall_frame
	 inx
	 stx	  boring_flag

	 sec
	 bcs	  ..exit

..not_released
	 clc

..exit
	 rts

test_borer_release	   endproc





test_hopper_release	   proc
;
; routine to test if hopper should be released.
;
; A,X,Y,P - scrambled
;
; carry flag indicates successful release (c=1=released)
;
	 lda	  headflag
	 lbne	  ..not_released

	 lda	  facing
	 beq	  ..test_left_facing

..test_right_facing
	 lda	  hero_x
	 cmp	  #147

	 bcc	  ..IHateBranchRangeErrors			;23-Apr-88  HES
	 jmp	  ..not_released				;23-Apr-88  HES
..IHateBranchRangeErrors					;23-Apr-88  HES

	 clc
	 adc	  #7
	 sta	  temp1
	 bne	  ..check_for_ground

..test_left_facing
	 lda	  hero_x
	 cmp	  #38
	 bcc	  ..not_released
	 sec
	 sbc	  #12
	 sta	  temp1


..check_for_ground
	 sta	  column
	 lda	  hero_y
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 beq	  ..not_released

	 lda	  temp1
	 clc
	 adc	  #2
	 sta	  column
	 lda	  hero_y
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 beq	  ..not_released


..init_hopper_stuff
	 lda	  temp1
	 sec
	 sbc	  #$03
	 sta	  hopper_x

	 lda	  hero_y
	 sec
	 sbc	  #26
	 sta	  hopper_y

init_hopper_sprite
	 lda	  #$00
	 sta	  hopper_frame

	 sta	  wr_aux

	 lda	  hopper_x
	 sta	  spr_9
	 lda	  hopper_y
	 sta	  spr_9+1

	 lda	  #low hopfrnt1
	 sta	  spr_9+4
	 lda	  #high hopfrnt1
	 sta	  spr_9+5

	 sta	  wr_main


	 sec
	 bcs	  ..exit

..not_released
	 clc

..exit
	 rts

test_hopper_release	endproc



hopper_hop	  proc
;
; routine to make released hopper hop & animate
; also determines if fist should be opened.
;
; A,X,P - scrambled
;
;
	 inc	  hopper_frame
	 lda	  hopper_frame

;***************************************** kam mod 5-12-88
	ldx	current_room
	cpx	#8
	bne	..kamnope
	ldx	hopper_x
	cpx	#$67
	bcc	..kamnope
	cpx	#$69
	bcs	..kamnope
	cmp	#18
	bne	..kamnope
	ldx	fist_pose
	stx	fist_animation_flag
	bne	..kamyep
	ldx	center_body_part_flag
	bne	..kamyep
	ldx	center_body_part_gone
	beq	..kamnope
..kamyep
	dec	hopper_frame
	ldx	#0
	stx	beastie_flag
	jmp	..itsok
..kamnope
;*****************************************

	 cmp	  #33
	 bcc	  ..itsok
	 lda	  #$00
	 sta	  hopper_frame

..itsok
	 rts

hopper_hop	  endproc



borer_move	  proc
;
; move & animate active released borer
;
; A,X,Y,P - scrambled
;
;
	 dec	  borer_wait
	 lbpl	   ..exit
	 lda	  #$02
	 sta	  borer_wait

	 lda	  borer_x
	 ldx	  borer_facing
	 lbeq	  ..ck_left_of_borer

..ck_right_of_borer
	 cmp	  #$a9
	 lbcs	  ..kill_the_borer

	 ldx	  boring_flag
	 beq	  ..setup_check_right
	 lbmi	  ..do_chew
	 jmp	  ..no_borer_wall


..ck_left_of_borer
	 cmp	  #$0b
	 lbcc	  ..kill_the_borer

	 ldx	  boring_flag
	 beq	  ..setup_check_left
	 lbmi	  ..do_chew
	 jmp	  ..no_borer_wall



..setup_check_right
	 lda	  #$18			     ;op code for CLC
	 sta	  SMC11
	 lda	  #$7D			     ;op code for ADC nn,x
	 sta	  SMC02
	 bne	  ..coin_ck_loop1_setup


..setup_check_left
	 lda	  #$38			     ;op code for SEC
	 sta	  SMC11
	 lda	  #$FD			     ;op code for SBC nn,x
	 sta	  SMC02


..coin_ck_loop1_setup
	 ldx	  #$03
..coin_ck_loop1
	 lda	  borer_x
SMC11	 clc				     ;<----!!!!! SELF MOD !!!!!
SMC02	 adc	  ..coin_ck_offset_table,x   ;<----!!!!! SELF MOD !!!!!
	 sta	  column
	 lda	  borer_y
	 sta	  scan
	 txa
	 pha
	 jsr	  coin_ck
	 tay
	 pla
	 tax
	 cpy	  #$20
	 bne	  ..ck_for_borer_wall
	 dex
	 bpl	  ..coin_ck_loop1
	 jmp	  ..reverse_gears

..ck_for_borer_wall
	 lda	  borer_facing
	 beq	  ..ck_for_wall_left

..ck_for_wall_right
	 lda	  #$18			     ;op code for CLC
	 sta	  SMC03
	 lda	  #$69			     ;op code for ADC #n
	 sta	  SMC04
	 bne	  ..do_ck_for_wall

..ck_for_wall_left
	 lda	  #$38			     ;op code for SEC
	 sta	  SMC03
	 lda	  #$E9			     ;op code for SBC #n
	 sta	  SMC04



..do_ck_for_wall
	 lda	  borer_x
SMC03	 clc		   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!
SMC04	 adc	  #9	   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!
	 sta	  column
	 lda	  borer_y
	 sec
	 sbc	  #$08
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$c0
	 lbne	  ..no_borer_wall


	 lda	  #$03
	 sta	  SMC13+1
	 lda	  #$02
	 sta	  SMC15+1
	 lda	  #$00
	 sta	  SMC16+1

	 lda	  current_room
	 cmp	  #2
	 beq	  ..wall_at_screen_edge_setup
	 cmp	  #20
	 beq	  ..wall_at_screen_edge_setup
	 cmp	  #30
	 beq	  ..wall_at_screen_edge_setup
	 cmp	  #31
	 bne	  ..normal_wall_setup

..wall_at_screen_edge_setup
	 lda	  #$02
	 sta	  SMC14+1
	 lda	  borer_facing
	 beq	  ..special_setup_left
	 lda	  #$01
	 sta	  SMC15+1
	 sta	  SMC16+1
	 bne	  ..init_borer_wall_left

..special_setup_left
	 lda	  #$04
	 sta	  SMC13+1
	 bne	  ..init_borer_wall_left

..normal_wall_setup
	 lda	  #$03
	 sta	  SMC14+1


..init_borer_wall_left
	 lda	  #$ff
	 sta	  boring_flag

	 lda	  #$00
	 sta	  ..section_number

	 lda	  borer_wall_left_edge

	 ldx	  borer_facing
	 bne	  ..init_borer_wall_right

	 ldx	  #low(..chewed_walls_left)
	 stx	  SMC05+1
	 ldx	  #high(..chewed_walls_left)
	 stx	  SMC05+2

	 ldx	  #$38			     ;op code for SEC
	 stx	  SMC06
	 stx	  SMC12
	 ldx	  #$E9			     ;op code for SBC #n
	 stx	  SMC07
	 stx	  SMC13

	 clc
	 adc	  #7
	 jmp	  ..store_wall_coord_x

..init_borer_wall_right
	 ldx	  #low(..chewed_walls_right)
	 stx	  SMC05+1
	 ldx	  #high(..chewed_walls_right)
	 stx	  SMC05+2

	 ldx	  #$18			     ;op code for CLC
	 stx	  SMC06
	 stx	  SMC12
	 ldx	  #$69			     ;op code for ADC #n
	 stx	  SMC07
	 stx	  SMC13

..store_wall_coord_x
	 sta	  ..chewing_x






..do_chew
	 ldx	  chewed_wall_frame
	 bpl	  ..keep_chewing
	 ldx	  #$01

..keep_chewing
SMC05	 lda	  ..chewed_walls_left,x      ;<---- !!!! SELF MOD !!!!
	 sta	  prim

	 inx
	 cpx	  #$03
	 bcc	  ..store_wall_number
	 ldx	  #$00
..store_wall_number
	 stx	  chewed_wall_frame

	 cpx	  #$01
	 bne	  ..after_section_update

	 inc	  ..section_number
	 ldx	  ..section_number
SMC14	 cpx	  #$03
	 bcc	  ..still_chewing

SMC16	 lda	  #$01
	 sta	  boring_flag
	 jmp	  ..keep_going


..still_chewing
	 lda	  ..chewing_x

SMC15	 cpx	  #$02
	 bne	  ..normal_section

SMC12	 sec		   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!
SMC13	 sbc	  #$03	   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!
	 jmp	  ..store_chewing_x

..normal_section
SMC06	 sec		   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!
SMC07	 sbc	  #$04	   ;<---------!!!!!!!! SELF MODIFYING !!!!!!!!

..store_chewing_x
	 sta	  ..chewing_x

..after_section_update
	 lda	  ..chewing_x
	 sta	  column

	 lda	  borer_y
	 clc
	 adc	  #$04
	 and	  #$f8
	 sec
	 sbc	  #32
	 sta	  scan

	 jsr	  call_stamper
	 lda	  scan
	 sec
	 sbc	  #$05
	 sta	  scan
	 long	  prmsec,displaystampedstuff

	 jmp	  ..keep_going





..reverse_gears
	 lda	  borer_facing
	 eor	  #$01
	 sta	  borer_facing


..no_borer_wall
	 lda	  borer_x
	 ldx	  borer_facing
	 bne	  ..ck_right_coord

..ck_left_coord
	 cmp	  #$26
	 bcs	  ..keep_going
	 lda	  #$02
	 sta	  SMC08+1
	 sta	  SMC09+1
	 bne	  ..ck_edge

..ck_right_coord
	 cmp	  #$8e
	 bcc	  ..keep_going
	 lda	  #$9c
	 sta	  SMC08+1
	 sta	  SMC09+1

..ck_edge
SMC08	 lda	  #$9c	   ;<------------ !!!!!! SELF MODIFYING !!!!!!
	 sta	  column
	 lda	  borer_y
	 sec
	 sbc	  #4
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$c0
	 beq	  ..keep_going
	 cmp	  #$20
	 bne	  ..turn_around

SMC09	 lda	  #$9c	   ;<------------ !!!!!! SELF MODIFYING !!!!!!
	 sta	  column
	 lda	  borer_y
	 sec
	 sbc	  #12
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$c0
	 beq	  ..keep_going
	 cmp	  #$20
	 bne	  ..turn_around
	 beq	  ..keep_going


..turn_around
	 lda	  borer_facing
	 eor	  #$01
	 sta	  borer_facing


..keep_going
	 lda	  borer_frame
	 eor	  #$01
	 sta	  borer_frame
	 beq	  ..exit
	 lda	  borer_facing
	 beq	  ..move_borer_left

..move_borer_right
	 inc	  borer_x
	 inc	  borer_x
	 jmp	  ..exit

..move_borer_left
	 dec	  borer_x
	 dec	  borer_x
	 jmp	  ..exit

..kill_the_borer
	 lda	  #$00
	 sta	  beastie_flag
	 sta	  boring_flag
	 sta	  wr_aux
	 sta	  spr_8+3
	 sta	  spr_9+3
	 sta	  wr_main

..exit
	 rts

	 seg	  maindata

borer_wait	  ds	   1

..chewed_walls_right
	 db	  39,41,43

..chewed_walls_left
	 db	  40,42,43

..chew_timer	  ds	   1

borer_wall_left_edge	   ds		     1
..chewing_x	  ds	   1
..section_number  ds	   1

..coin_ck_offset_table
	 db	  12,15,16,19

	 seg	  maincode

borer_move	  endproc


coin_ck  proc
	 long	  prmsec,CheckBackground      ;23-Apr-88  HES
	 rts
coin_ck  endproc

call_stamper	  proc
	 long	  prmsec,stamp
	 rts
call_stamper	  endproc


	 end
