$chip(6502)
$paginate
$allpublic

	 %include secseg.inc
	 %include macro.inc

	 extern   boltphase,currently_active_beasties,rd_aux,rd_main
	 extern   current_guard_flag,domain_tab,facing,sec_tdbl1
	 extern   guard_death,free_stingman_x,free_stingman_y,bolt_x
	 extern   bolt_y,guard_x,guard_y,headflag,grd_pntr,wr_aux
	 extern   wr_main,sec_temp1,fuse_y_offset
	 extern   fuse_command_flag,current_fuse_flag,disp_fuse

	 extern   click,tone,noise

	 seg	  graph

bolthit  proc
;
; routine to check to see if the bolt coinciding with a "hittable" ob-
; ject.
;
; A,X,Y,P - scrambled
;
; !!!!!!!!! current_room MUST BE PASSED in the "X" register !!!!!!!!!
;
	 stx	  ..current_room

	 lda	  headflag
	 lbeq	  ..exit

	 lda	  boltphase
	 lbmi	  ..exit

	 sta	  rd_aux
	 lda	  currently_active_beasties
	 sta	  rd_main

	 and	  #%00001000
	 sta	  ..type_of_check

	 lda	  current_guard_flag
	 and	  #$03
	 tay
	 lda	  domain_tab,y
	 cmp	  ..current_room
	 bne	  ..ck_for_reactor_room

	 lda	  #%10000000		     ;indicate guard present
	 ora	  ..type_of_check
	 sta	  ..type_of_check

..ck_for_reactor_room
	 lda	  ..current_room
	 cmp	  #100
	 lbne	  ..ck_for_something_to_hit
	 lda	  #$40
	 ora	  ..type_of_check
	 sta	  ..type_of_check


..ck_for_something_to_hit
	 lda	  #$c8
	 and	  ..type_of_check
	 lbeq	  ..exit




	 ldy	  #22+3
	 lda	  facing
	 cmp	  #$02
	 beq	  ..it_is_vertical

..its_not_vertical
	 ldy	  #20+3

..it_is_vertical
	 ldx	  #5+3

..store_ranges
	 stx	  ..horz_range
	 sty	  ..vert_range

	 bit	  ..type_of_check
	 bmi	  ..itsa_guard
	 lbvs	  ..ck_for_fuses

..itsa_manowar
	 lda	  free_stingman_x
	 clc
	 adc	  #$05
	 sec
	 sbc	  bolt_x
	 bpl	  ..ck_x_manowar
	 eor	  #$ff
	 tax
	 inx
	 txa
..ck_x_manowar
	 cmp	  ..horz_range
	 lbcs	  ..exit

	 lda	  free_stingman_y
	 clc
	 adc	  #$0a
	 sec
	 sbc	  bolt_y
	 bpl	  ..ck_y_manowar
	 eor	  #$ff
	 tax
	 inx
	 txa
..ck_y_manowar
	 cmp	  ..vert_range
	 lbcs	  ..exit

	 lda	  #$64
	 sta	  manowar_stun_flag

	 lbne	  ..exit


..itsa_guard
	 lda	  facing
	 cmp	  #$02
	 beq	  ..ck_for_fuses

	 bit	  current_guard_flag
	 bpl	  ..ck_for_fuses

	 lda	  guard_y
	 sec
	 sbc	  bolt_y
	 bpl	  ..ck_y_guard
	 eor	  #$ff
	 tax
	 inx
	 txa
..ck_y_guard
	 cmp	  ..vert_range
	 bcs	  ..ck_for_fuses

	 lda	  guard_x
	 sec
	 sbc	  bolt_x
	 bpl	  ..ck_x_guard
	 eor	  #$ff
	 tax
	 inx
	 txa
..ck_x_guard
	 cmp	  ..horz_range
	 bcs	  ..ck_for_fuses

	 lda	  grd_pntr
	 sta	  sec_tdbl1
	 lda	  grd_pntr+1
	 sta	  sec_tdbl1+1

	 ldy	  #$00
	 sta	  rd_aux
	 sta	  wr_aux
	 lda	  (sec_tdbl1),y
	 and	  #$7f
	 sta	  (sec_tdbl1),y
	 sta	  rd_main
	 sta	  wr_main

	 lda	  #$11
	 sta	  guard_death

	 lda	  current_guard_flag
	 and	  #$7f
	 sta	  current_guard_flag

	 lda	  #$ff
	 sta	  boltphase

	 bit	  ..type_of_check
	 bvc	  ..exit


..ck_for_fuses
	 bit	  ..type_of_check
	 bvc	  ..exit

;
; check for fuse hit here
;

	 lda	  boltphase
	 bmi	  ..exit
	 beq	  ..exit

	 lda	  current_fuse_flag
	 sta	  sec_temp1

	 ldx	  #$02
..ck_for_fuse_hit_loop
	 lsr	  sec_temp1
	 bcc	  ..fuse_hit_loop

	 lda	  ..fuse_x_tab,x
	 sec
	 sbc	  bolt_x
	 bpl	  ..ck_x_fuse
	 eor	  #$ff
	 tay
	 iny
	 tya
..ck_x_fuse
	 cmp	  #08
	 bcs	  ..fuse_hit_loop

	 lda	  #fuse_y_offset+8
	 sec
	 sbc	  bolt_y
	 bmi	  ..fuse_hit_loop
	 cmp	  #12
	 bcs	  ..fuse_hit_loop
;
; he hit the fuse !!
;

	 lda	  #$ff
	 sta	  boltphase

	 lda	  ..fuse_flag_tab,x
	 tay
	 ora	  #$80
	 sta	  fuse_command_flag

	 tya
	 eor	  current_fuse_flag
	 sta	  current_fuse_flag

	 ldx	  #$50
	 ldy	  #$30
	 jsr	  noise

	 jmp	  ..exit		     ;one at a time !!


..fuse_hit_loop
	 dex
	 bpl	  ..ck_for_fuse_hit_loop

..exit
	 rts


***********************************************

..fuse_x_tab	  db	   102,74,46
..fuse_flag_tab   db	   4,2,1

..current_room	  ds	   1

..horz_range	  ds	   1
..vert_range	  ds	   1

..type_of_check   ds	   1

manowar_stun_flag ds	   1

bolthit  endproc

	 end
