$chip(6502)
$paginate

	extern	leg_parts_here_table,call_random
	extern	stop_checking,current_room_second,leg_rooms
	extern	leg_parts_here_table,leg_offset,leg_x_position_table
	extern	leg_y_position_table,spr_1,pink,leg_parts_address
	extern	hero_y,hero_x,bot_parts,panel1,panelcopy
	extern	wr_aux,wr_main,old_game

	public	init_legs,check_legs,grab_legs

	%include	secseg.inc

	seg	graph

init_legs	proc
;
; logic for initializing body parts
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	lda	old_game
	beq	..exit			;short game
	jsr	call_random
	sta	..rand
	jsr	call_random
	sta	..rand+1

	ldx	#0
	ldy	#2
..next2
	dey
	lda	..rand,y
	cmp	#85
	bcc	..next1
	inx
	cmp	#171
	bcc	..next1
	inx
..next1

	lda	legflag,y
	sta	leg_parts_here_table,x
	ldx	#3
	cpy	#0
	bne	..next2
..exit
	rts

legflag db	127,255
..rand	ds	2

init_legs	endproc


check_legs	proc

	ldx	#0
	stx	stop_checking
	lda	current_room_second
..loop
	cmp	leg_rooms,x
	beq	..yes
	inx				;were in a leg room
	cpx	#6
	bne	..loop
	jmp	..nope			;not a leg room

..yes
	lda	leg_parts_here_table,x
	beq	..nope			;no leg in here

	stx	leg_offset
	sta	wr_aux
	lda	leg_x_position_table,x
	sta	spr_1+18
	lda	leg_y_position_table,x
	sta	spr_1+19
	lda	#pink
	sta	spr_1+20
	lda	#$e6
	sta	spr_1+21
	ldy	#0
	lda	leg_parts_here_table,x
	bmi	..next
	ldy	#2
..next
	lda	leg_parts_address,y
	sta	spr_1+22
	lda	leg_parts_address+1,y
	sta	spr_1+23
	sta	wr_main
	lda	#$ff
	sta	stop_checking
..nope
	rts

check_legs	endproc


grab_legs	proc

	lda	stop_checking
	beq	..exit
	ldx	leg_offset
	lda	leg_parts_here_table,x
	beq	..exit			;dont check

	lda	hero_y
	sec
	sbc	leg_y_position_table,x
	bcc	..exit
	cmp	#40
	bcs	..exit			;wrong y-coordinate
	lda	hero_x
	sec
	sbc	leg_x_position_table,x
	bcc	..exit
	cmp	#14
	bcs	..exit

	lda	leg_parts_here_table,x
	tay
	lda	#0
	sta	leg_parts_here_table,x
	sta	wr_aux
	sta	spr_1+21
	sta	wr_main
	lda	#4			;left leg
	cpy	#128
	bcc	..next
	lda	#2			;right leg
..next
	ora	bot_parts
	sta	bot_parts
	clc
	jsr	panel1			;draw new panel
	sec
	jsr	panelcopy		;show new panel
..exit
	rts

grab_legs	endproc
	end

