$chip(6502)
$paginate
$allpublic

	 %include prmseg.inc
	 %INCLUDE ZPEXT.ASM
	 %include macro.inc

	 seg	  lookatdk

	 extern   currently_active_beasties,room_creature_status_table
	 extern   current_room,special_creature_init_data
	 extern   wr_aux,wr_main,rd_aux,rd_main,prmsec
	 extern   init_stinger_or_manowar,init_hopper
	 extern   init_free_borer,freeray_init

room_beastie_init proc
;
; driver routine for calling appropriate un-captured creature init.
; routines.
;
; A,X,Y,P - scrambled
;
;
	 ldx	  current_room
	 cpx	  #41
	 lbcs	  ..nobody_in_there

	 lda	  this_room_beastie_status
	 and	  #$f8
	 lbeq	  ..nobody_in_there

	 sta	  rd_aux

	 and	  room_creature_status_table,x
	 bne	  ..somebodys_in_here

	 sta	  rd_main

	 jmp	  ..nobody_in_there


..somebodys_in_here
	 sta	  ..temp_beasties

	 sta	  wr_aux

	 sta	  currently_active_beasties

	 lda	  $c083    ;!!!!!!!! SET $D000 BANK 2 !!!!!!!!!!
	 lda	  $c083

	 ldy	  #$2
..sp_creature_data_loop
	 lda	  (tdbl2),y
	 sta	  special_creature_init_data,y
	 dey
	 bpl	  ..sp_creature_data_loop

	 lda	  $c08b    ;!!!!!!!! SET $D000 BANK 1 !!!!!!!!!!
	 lda	  $c08b

	 sta	  rd_main
	 sta	  wr_main

	 ldx	  #$04
..init_beastie_loop
	 asl	  ..temp_beasties
	 bcc	  ..this_beastie_done

	 txa
	 asl	  a
	 tay
	 lda	  ..vector_table,y
	 sta	  SMC01+1
	 lda	  ..vector_table+1,y
	 sta	  SMC01+6

	 txa
	 pha

SMC01	 long	  prmsec,$ffff ;<------!!!!!!!! SELF MODIFYING !!!!!!!!

	 pla
	 tax

..this_beastie_done
	 dex
	 bpl	  ..init_beastie_loop
	 bmi	  ..exit

..nobody_in_there
	 lda	  #$00
	 sta	  wr_aux
	 sta	  currently_active_beasties

..exit
	 sta	  rd_main
	 sta	  wr_main

	 rts

*****************************************************

	 seg	  maindata

..vector_table
	 dw	  init_stinger_or_manowar    ;man-o-war
	 dw	  init_free_borer	     ;big borer
	 dw	  freeray_init		     ;ray
	 dw	  init_hopper		     ;rock hopper
	 dw	  init_stinger_or_manowar    ;stinger

this_room_beastie_status
	 ds	  1

..temp_beasties
	 ds	  1

room_beastie_init endproc

	 end
