$CHIP(6502)
$PAGINATE
$ERRONLY
$allpublic


	 %INCLUDE prmseg.inc
	 %INCLUDE MACRO.inc
	 %INCLUDE EXTERN.ASM
	 %INCLUDE ZPEXT.ASM

	 SEG	  lookatdk



	 EXTERN   CLEAR
	 EXTERN   RD_OS_TAB
	EXTERN	CURRENT_ROOM,sethero

	EXTERN	setroom,hero_x,hero_y,set_room_pointer

	 extern   invert_flag,invert

	 extern   last_seq_index


check_next_room   proc
;
; subroutine CHECK_NEXT_ROOM: (RTU)
;	 This subroutine performs several functions, the first being
;	 to determine if there is a room in the direction passed.
;	 If there is, it will then check to see if the hero needs
;	 to be offset because of the new room not meeting squarely
;	 with the old one. If the hero needs to be offset, the
;	 routine checks to see if in being offset the hero would be
;	 placed off of the screen. If he will, the routine exits
;	 with the appropriate code, otherwise the new room is dis-
;	 played and the hero is offset in the appropriate direction
;	 so that he will be ready to continue on his merry way.
;	 (So what if my comments sound like code, programmers
;	 were meant to write code, not comments for someone else
;	 to read JUST because they can't read the code. The
;	 function performed by the code should be intuitively
;	 obvious to the most casual observer...RIGHT?)
;
;	 The following condition codes apply upon return:
;
;		  BEQ	   no_room_adjacent or bad_offset
;			   (bad_offset meaning that there is a room
;			   in that direction, but to display it and
;			   offset the hero would put the hero off of
;			   the screen)
;
;		  BNE	   everything_be_otay
;			   (new room is up, and hero has been offset
;			   appropriately and displayed)
;
;
;
;	 The room that the hero is in is passed in CURRENT_ROOM.
;	 The direction to check for is passed in the Y register in
;	 the folloowing manner:
;
;	 0	  -	   check to the right
;	 1	  -	   check to the left
;	 2	  -	   check down
;	 3	  -	   check up
;
;
;			  THE ROUTINE STARTS HERE.



	LDA	CURRENT_ROOM		     ;fetch the pointer

	jsr	set_room_pointer

	ldx	$c083
	ldx	$c083

	LDA	(TDBL1),Y		     ;if there is no room in

	ldx	$c08b
	ldx	$c08b

	CMP	CURRENT_ROOM		     ;the direction that we
	BNE	CHECK_COORDS		     ;are checking for, the
	RTS				     ;the room currently occ-
					     ;upied.




CHECK_COORDS
	STA	NEW_ROOM
	STY	UDLR			     ;Offset the hero.
	LDX	OS_COORD_TAB,Y		     ;(If he was moving left
	TYA				     ;and encountered the left
	AND	#$02			     ;edge of the screen, he
	BEQ	.01			     ;needs to appear on the
	STX	hero_y			     ;right edge of the newly
	lda	  invert_flag
	cmp	  #invert
	bne	  .02
	lda	  hero_y
	sbc	  #30
	sta	  hero_y
	jmp	.02			     ;displayed screen)
.01					     ;This does it for all dir-
	STX	hero_x			     ;ections of movement.
.02


	LDA	NEW_ROOM		     ;Now we need to see if
					     ;he needs to be offset
	jsr	set_room_pointer	     ;in the other direction
					     ;due the new room not
	clc				     ;meeting squarely with the
	lda	#$04			     ;old room.
	adc	tdbl1
	sta	tdbl1
	lda	#$00
	adc	tdbl1+1
	sta	tdbl1+1

	LDY	#$00

	ldx	$c083
	ldx	$c083

	LDA	(TDBL1),Y

	ldx	$c08b
	ldx	$c08b

	TAX
	AND	#$20			     ;meet sqaurely ?
	BEQ	$+5			     ;nope, calculate offsets
	JMP	DISP_NEW_ROOM		     ;yep, so just display.


	LDY	UDLR			     ;determine if we need to

	ldx	$c083
	ldx	$c083

	LDA	(TDBL1),Y		     ;increase a coord or

	ldx	$c08b
	ldx	$c08b

	CMP	#$00
	BMI	DECREASE_COORD		     ;decrease a coord

	CPY	#$02			     ;which coord do we in-
	BCS	INC_X_POS		     ;crease ?

	AND	#$1F			     ;here is where we increase
	ASL	A			     ;the hero's Y coord.
	ASL	A
	ASL	A
	CLC
	ADC	hero_y			     ;check to see if he'd be
	CMP	os_coord_tab+3			;off of the screen
	BCC	$+5
	JMP	EXIT_COORD_OS		     ;he'd be off screen
	STA	hero_y
	JMP	DISP_NEW_ROOM

INC_X_POS
	AND	#$1F

	STA	TEMP1
	ASL	A
	ASL	A
	STA	TEMP2
	LDA	TEMP1
	ASL	A
	CLC
	ADC	TEMP1
	ADC	TEMP2
	ROR	A

	CLC
	ADC	hero_x
	CMP	os_coord_tab+1
	BCS	EXIT_COORD_OS
	STA	hero_x
	JMP	DISP_NEW_ROOM

DECREASE_COORD
	CPY	#$02
	BCS	DEC_X_POS

	AND	#$1F
	ASL	A
	ASL	A
	ASL	A
	STA	TEMP1
	LDA	hero_y

; This is a patch added by HES 27-Feb-88 to fix a slight bug.
	cmp	TEMP1			;Is his present coord less
	bcc	EXIT_COORD_OS		; than what we're subtracting?
;					;If so, exit.
	SEC
	SBC	TEMP1
;	BMI	EXIT_COORD_OS		;HES  (Replaced by above stuff.)
	STA	hero_y
	JMP	DISP_NEW_ROOM

DEC_X_POS
	AND	#$1F

	STA	TEMP1
	ASL	A
	ASL	A
	STA	TEMP2
	LDA	TEMP1
	ASL	A
	CLC
	ADC	TEMP1
	ADC	TEMP2
	ROR	A

	STA	TEMP1
	LDA	hero_x
	SEC
	SBC	TEMP1
	cmp	os_coord_tab+1
	bcs	exit_coord_os
	STA	hero_x

DISP_NEW_ROOM
	LDA	NEW_ROOM
	STA	CURRENT_ROOM
	JSR	setroom

	ldy	last_seq_index
	JSR	sethero

	LDA	#$7f
	RTS

EXIT_COORD_OS

	LDA	#$00
	RTS


	 seg	  maindata

;			    R	L   D	U
;coord_tab	   db	     6 ,131, 4 ,164

os_coord_tab	  db	   20, 164, 3, 162    ;180=bottom scan line of
					     ;play area

new_room ds	  1
udlr	 ds	  1

check_next_room   endproc

	 END
