$chip(6502)
$paginate

**********************************************
*					     *
*					     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	workon, wr_aux, wr_main, rd_main, rd_aux
	EXTERN	masktb

	 extern   creature_number,current_room_second,headflag
	 extern   grd_table

	PUBLIC	clear

	SEG	graph

clear	PROC
;
; clear the inactive double hi-res screen
;
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

**********************************************
*					     *
* PATCH to kill the robot guard if the	     *
* following conditions are met: 	     *
*					     *
*	 1) hero is in room 41 (decimal)     *
*	 2) guard is alive		     *
*	 3) hero is in bot form 	     *
*	 4) manta ray is actively protecting *
*	    sparks			     *


	 lda	  current_room_second
	 cmp	  #41
	 bne	  ..no_kill_i

	 sta	  rd_aux
	 bit	  grd_table
	 sta	  rd_main
	 bpl	  ..no_kill_i

	 lda	  headflag
	 cmp	  #$05
	 bne	  ..no_kill_i

	 lda	  creature_number
	 cmp	  #$03
	 bne	  ..no_kill_i

;
; KILL IT !!!!!!!
;

	 sta	  rd_aux
	 sta	  wr_aux
	 lda	  grd_table
	 and	  #$7f
	 sta	  grd_table
	 sta	  rd_main
	 sta	  wr_main



..no_kill_i
*					     *
**********************************************


	lda	workon
	sta	..scr1+2
	sta	..scr2+2

	lda	#$60
	sta	..loop1+2
	sta	..loop2+2

	move	..loop3+2,#high(masktb)

	sta	wr_aux

	ldx	#$20
	lda	#$ff
	ldy	#0

..loop3 sta	$ff00,y 	;erase mask
	iny
	iny
	bne	..loop3
	inc	..loop3+2
	dex
	bne	..loop3

	ldx	#$20
	lda	#0
	tay

..loop1 sta	$ff00,y
..scr1	sta	$ff00,y
	iny
	bne	..loop1
	inc	..loop1+2
	inc	..scr1+2
	dex
	bne	..loop1

	sta	wr_main

	ldx	#$20

..loop2 sta	$ff00,y
..scr2	sta	$ff00,y
	iny
	bne	..loop2
	inc	..loop2+2
	inc	..scr2+2
	dex
	bne	..loop2

	sta	rd_main
here	rts

clear	ENDPROC

	END

