$chip(6502)
$paginate

	%include secseg.inc

;	 EXTERN  state,dfall
	EXTERN	source,dest,ptr,tmp,tmp1,tmp2	,eraseorview
	EXTERN	scan,column,colt,pixt,scanlo,scanhi
	EXTERN	rd_main,rd_aux,wr_main,wr_aux,ram_rd,ram_wr
	extern	energy_level, room_percent, creature_number, creature_table
	extern	characterindex,characterdatamain,characterdataaux

	public	digits, room_bars, energy_bars, printnum
	public	printbarlevel


	SEG	graph

digits	proc

;**** highlight number of creatures left ****
	lda	#5
	sta	..count
;	 lda	 eraseorview
;	 sta	 eorv
      ; sta	modification+1
..branch2
	lda	creature_number 	;normal or inverse digit
	cmp	..count
	clc				;normal
	bne	..branch1
	sec				;inverse
..branch1
	ldx	..count 		;get position for placement on screen
	ldy	table_digits2,x 	;and data byte
	lda	creature_table,x
	sta	..temp
	lda	table_digits1,x
	tax
	lda	..temp
	jsr	printnum		;print data byte
	dec	..count
	bne	..branch2
	rts

	seg   graph
; data area for this routine
..temp
	ds	1
..count
	ds	1
table_digits1
	db	0,$2c,$32,$38,$3e,$44		    ;x-pos
table_digits2
	db	0,123,123,123,123,123		    ;y-pos

	seg   graph
digits	endproc

energy_room_bars	proc
energy_bars
	ldx	#$3f
	stx	..mod99+1
	lda	energy_level
	sta	..temp+3
	jmp	..cont
room_bars
	ldx	#$41
	stx	..mod99+1
	lda	room_percent
	sta	..temp+3
..cont
	; y register carries the color code
	sty	..temp
	ldy	#$7d
	sty	..temp+2
	ldx	#0
	lda	..temp+3
	lsr	a
	lsr	a
	sta	..temp+1		;divide by four to get # of bars
	beq	..continue2
..continue1
	dey
	sty	..temp+2
..mod99 ldx	#$3f		 ;<<<<-----self mod<<<<<<	;x_pos
	lda	..temp			;color
	jsr	printbarlevel
	ldy	..temp+2
	dec	..temp+1
	bne	..continue1		;loop until all energy displayed
..continue2
	lda	#$0b
	sta	..temp			;new color
	lda	#1
	sta	..temp+1		;set for one pass thru loop
	cpy	#$63
	bne	..continue1		;more blanks to display
	rts

	seg   graph
;data area for this routine
..temp	ds	4

energy_room_bars	endproc



	seg   graph
print_stuff		proc
printnum

	jsr	..save_this_stuff

	ldy	..Ycoord		;Get the Y-coord.
	lda	..Byte			;Get the low nybble...
	and	#$0f
	jsr	PrintDigit		;...and print it.
	jsr	..restore_this_stuff
	rts

PrintDigit
	sty	..ScanLine		;Save the scan line.
	sta	..Digit 		;Save the digit.
	lda	#0			;Init the row count.
	sta	..Row

..Loop
	sta	rd_aux
	sta	wr_main
	ldy	..ScanLine
	lda	scanlo,y		;Set up tmp, Dest,
	sta	tmp			; and Ptr to point
	sta	dest			; to where on the
	sta	ptr			; screen we want
	lda	scanhi,y		; to write.
	ora	#$20
	sta	tmp+1			;tmp -> Screen #1
	ora	#$40
	sta	ptr+1			;Ptr -> Erase Screen.
	and	#$DF
	sta	dest+1			;Dest -> Screen #2.

	ldx	..Digit 		;Find the offset into the
	lda	CharacterIndex,x	; def'n data for this
	clc				; digit and add on the
	adc	..Row			; offset for the row
	adc	..Row			; we're on.
	tax

	sta	rd_main 		;* kam 4-26-88
	lda	#$ff
	bit	eraseorview
	sta	rd_aux			;* kam 4-26-88
	sta	wr_aux			;Write out the image
	lda	..inverse_flag		;* kam patch 3-31-88
	beq	..inv1			;*
	lda	CharacterDataAux,x	;*
	eor	#$ff			;*
	jmp	..inv2			;*
..inv1
	lda	CharacterDataAux,x	; to Aux memory.
..inv2
	ldy	..Xcoord
	bvs	..here1
	sta	(tmp),y
	sta	(dest),y
;	 bvc	 ..here2
..here1
	sta	(ptr),y
..here2
	iny
	lda	..inverse_flag		;*
	beq	..inv3			;*
	lda	CharacterDataAux+1,x	;*
	eor	#$ff			;*
	jmp	..inv4			;*
..inv3
	lda	CharacterDataAux+1,x
..inv4
	bvs	..here3
	sta	(tmp),y
	sta	(dest),y
;	 bvc	 ..here4
..here3
	sta	(ptr),y
..here4
	dey

	sta	wr_main 		;Write out the image
	lda	..inverse_flag		;*
	beq	..inv5			;*
	lda	CharacterDataMain,x	;*
	eor	#$ff			;*
	jmp	..inv6			;*
..inv5
	lda	CharacterDataMain,x	; to Main memory.
..inv6
	bvs	..here5
	sta	(tmp),y
	sta	(dest),y
;	 bvc	 ..here6
..here5
	sta	(ptr),y
..here6
	iny
	lda	..inverse_flag		;*
	beq	..inv7			;*
	lda	CharacterDataMain+1,x	;*
	eor	#$ff			;*
	jmp	..inv8			;*
..inv7
	lda	CharacterDataMain+1,x
..inv8
	bvs	..here7
	sta	(tmp),y
	sta	(dest),y
;	 bvc	 ..here8
..here7
	sta	(ptr),y
..here8
	inc	..ScanLine		;Goto the next scan line.
	inc	..Row			;Goto the next row.
	ldy	..Row
modification
	cpy	#5			;Are we done with 5 rows?
	bcs	..inv9			;Loop back if no.
	jmp	..loop			;* #5 gets changed while running
..inv9
	rts




	seg   graph
printbarlevel

	jsr	..save_this_stuff

	ldy	..Ycoord		;Get the Y-coord.
	lda	..Byte			;Get the low nybble...
	and	#$0f
	jsr	Printbar		;...and print it.
	jsr	..restore_this_stuff
	rts

Printbar
	sty	..ScanLine		;Save the scan line.
	sta	..Digit 		;Save the digit.
 ;	 lda	 #0			 ;Init the row count.
;	 sta	 ..Row

	sta	rd_aux
	sta	wr_main
	ldy	..ScanLine
	lda	scanlo,y		;Set up tmp, Dest,
	sta	tmp			; and Ptr to point
	sta	dest			; to where on the
	sta	ptr			; screen we want
	lda	scanhi,y		; to write.
	ora	#$20
	sta	tmp+1			;tmp -> Screen #1
	ora	#$40
	sta	ptr+1			;Ptr -> Erase Screen.
	and	#$DF
	sta	dest+1			;Dest -> Screen #2.

	ldx	..Digit 		;Find the offset into the
	lda	CharacterIndex,x	; def'n data for this
       ;clc				; digit and add on the
       ;adc	..Row			; offset for the row
       ;adc	..Row			; we're on.
	tax

	sta	rd_main 		;* kam 4-26-88
	lda	#$ff
	bit	eraseorview
	sta	rd_aux			;* kam 4-26-88
	sta	wr_aux			;Write out the image
	lda	CharacterDataAux+1,x	  ; to Aux memory.

	ldy	..Xcoord
	bvs	..here100
	sta	(tmp),y
	sta	(dest),y
;	bvc	..here101
..here100
	sta	(ptr),y
..here101
       ;iny
       ;lda	CharacterDataAux+1,x

       ;sta	(tmp),y
       ;sta	(dest),y
       ;sta	(ptr),y
       ;dey

	sta	wr_main 		;Write out the image
       ;lda	CharacterDataMain,x	;*
       ;sta	(tmp),y
       ;sta	(dest),y
       ;sta	(ptr),y
       ;iny
	lda	CharacterDataMain+1,x
	bvs	..here102
	sta	(tmp),y
	sta	(dest),y
 ;	bvc	..here103
..here102
	sta	(ptr),y
..here103
	rts


..save_this_stuff
	sta	rd_main
	sta	..Byte			;Save byte to print.
	stx	..Xcoord		;Save X-coord.
	sty	..Ycoord		;Save Y-coord.
	lda	#0			;*
	ror	a			;*
	sta	..inverse_flag		;*
	lda	ptr			;save the variables we will change
	sta	..OldPtr
	lda	ptr+1
	sta	..OldPtr+1
	lda	tmp
	sta	..oldtmp
	lda	tmp+1
	sta	..oldtmp+1
	lda	dest
	sta	..olddest
	lda	dest+1
	sta	..olddest+1

	lda	ram_rd		;See which memory is enabled
	sta	..Old_rd	; and save this info.
	lda	ram_wr
	sta	..Old_wr
	rts

..restore_this_stuff
	sta	rd_main 	;Restore the banks to the way they were.
	ldx	..Old_rd
	bpl	..label1
	sta	rd_aux
..label1
	sta	wr_main
	ldx	..Old_wr
	bpl	..label2
	sta	wr_aux
..label2

	lda	..OldPtr+1		;Restore variables.
	sta	ptr+1
	lda	..OldPtr
	sta	ptr
	lda	..oldtmp
	sta	tmp
	lda	..oldtmp+1
	sta	tmp+1
	lda	..olddest
	sta	dest
	lda	..olddest+1
	sta	dest+1

	rts

..Byte		db	0
..Xcoord	db	0
..Ycoord	db	0
..ScanLine	db	0
..Digit 	db	0
..Row		db	0
..oldtmp	dw	0
..olddest	dw	0
..OldPtr	dw	0
..Old_rd	db	0
..Old_wr	db	0
..inverse_flag	db	0		;*


print_stuff		endproc
	 END
