$CHIP(6502)
$PAGINATE
$allpublic
;
;
; animation frame definitions
;
;

	 %INCLUDE prmseg.inc
	 %include colorext.inc


	 extern   DROIDC_L
	 extern   DROIDC_LF
	 extern   DROIDC_F
	 extern   DROIDC_RF
	 extern   DROIDC_R
	 extern   DROIDP_L
	 extern   DROIDP_R
	 extern   DROIDP_C0
	 extern   DROIDP_C1
	 extern   DROIDP_C2
	 extern   DROIDP_C3
	 extern   DROIDSH_L
	 extern   DROIDSH_C
	 extern   DROIDSH_R
	 extern   BOTC_L
	 extern   BOTC_LF
	 extern   BOTC_F
	 extern   BOTC_RF
	 extern   BOTC_R
	 extern   BOTBOD
	 extern   LEG1_L
	 extern   LEG2_L
	 extern   LEG3_L
	 extern   LEG4_L
	 extern   LEG1_R
	 extern   LEG2_R
	 extern   LEG3_R
	 extern   LEG4_R
	 extern   SQLEGSH_L
	 extern   SQLEGSL_L
	 extern   SQLEGLH_L
	 extern   SQLEGLL_L
	 extern   SQLEGSH_R
	 extern   SQLEGSL_R
	 extern   SQLEGLH_R
	 extern   SQLEGLL_R
	 extern   XFORM1A_L
	 extern   XFORM2A_L
	 extern   XFORM3A_L
	 extern   XFORM4_L
	 extern   XFORM5_L
	 extern   XFORM1A_R
	 extern   XFORM2A_R
	 extern   XFORM3A_R
	 extern   XFORM4_R
	 extern   XFORM5_R
	 extern   XFORM2B
	 extern   XFORM3B
	 extern   EYE0
	 extern   BOTSHOTL
	 extern   BOTSHOTU
	 extern   BOTSHOTR
	 extern   NETFLT1R
	 extern   NETFLT2R
	 extern   NETFLT3R
	 extern   NETFLT4R
	 extern   NETFLT5R
	 extern   NETEMG4R
	 extern   NETOPN1R
	 extern   NETOPN2R
	 extern   NETEMG1L
	 extern   NETEMG2L
	 extern   NETEMG3L
	 extern   NETEMG3R
	 extern   NETEMG1R
	 extern   NETCLO4R
	 extern   NETEMG2R
	 extern   NETCLO1
	 extern   NETCLO0
	 extern   NETCLO4L
	 extern   NETCLO3
	 extern   NETCLO2
	 extern   NETOPNL
	 extern   NETOPNR
	 extern   NETFLT1L
	 extern   NETFLT2L
	 extern   NETFLT3L
	 extern   NETFLT4L
	 extern   NETFLT5L
	 extern   NETEMG4L
	 extern   NETOPN1L
	 extern   NETOPN2L
	 extern   GRD__LF
	 extern   GRDLLFF
	 extern   GRDFFL
	 extern   GRDF
	 extern   GRDLLFR
	 extern   GRD__LR
	 extern   GRD__RR
	 extern   GRD__RF
	 extern   GRDRRFF
	 extern   GRDRRFR
	 extern   GRDFFR
	 extern   GRDTOPCP
	 extern   GRDBOTCP
	 extern   GRDSHOTL
	 extern   GRDSHOTR
	 extern   BORBUT1R
	 extern   BORHED1R
	 extern   BORBUT2R
	 extern   BORHED2R
	 extern   BORBUT1L
	 extern   BORBUT2L
	 extern   BORHED2L
	 extern   BORHED1L
	 extern   RAYBUT2R
	 extern   RAYBUT1R
	 extern   RAYHED3R
	 extern   RAYHED1R
	 extern   RAYBUT3L
	 extern   RAYBUT2L
	 extern   RAYBUT1L
	 extern   RAYHED3L
	 extern   RAYHED1L
	 extern   RAYBUT3R
	 extern   STINGER1
	 extern   STINGER2
	 extern   STINGER3
	 extern   STINGER4
	 extern   MANOWAR1
	 extern   MANOWAR2
	 extern   MANOWAR3
	 extern   MANOWAR4
	 extern   HOPPER1L
	 extern   HOPPER2L
	 extern   HOPPER3L
	 extern   HOPPER4L
	 extern   HOPPER1R
	 extern   HOPPER2R
	 extern   HOPPER3R
	 extern   HOPPER4R
	 extern   HOPFRNT1
	 extern   HOPFRNT2
	 extern   ARROW
	 extern   SPRTGAM
	 extern   SPRTEOVE
	 extern   SPRTR
	 extern   SPRTREA
	 extern   SPRTCTOR
	 extern   SPRTOFF

	 extern   norm,invert,null

frame	 %macro   pointer,color,x_os,y_os,flag
	 db	  x_os
	 db	  y_os
	 db	  color
	 db	  flag
	 dw	  pointer
	 %endm

	 seg	  maincode

***************************************
*				      *
*				      *
*      droid frame definitions	      *
*				      *
*				      *
***************************************

;
;
;standing left, turning from left to right, standing right
;
;

dr_stand
	 frame	  eye0,orange,-8,-27,norm    ;eye in leftmost position
	 frame	  droidc_l,white,-8,-39,norm ;droid cap
	 frame	  droidsh_c,magenta,-8,-19,norm ;shoulder
	 frame	  droidp_c0,white,-8,-21,norm ;pedestal

;
;
;leaning left, leaning right
;
;

dr_lean_l
	 frame	  eye0,orange,-10,-27,norm    ;eye in leftmost position
	 frame	  droidc_l,white,-10,-39,norm ;droid cap
	 frame	  droidsh_l,magenta,-8,-21,norm
	 frame	  droidp_l,white,-8,-21,norm

dr_lean_r
	 frame	  eye0,orange,-6,-27,norm     ;eye in leftmost position
	 frame	  droidc_r,white,-6,-39,norm  ;droid cap
	 frame	  droidsh_r,magenta,-8,-21,norm
	 frame	  droidp_r,white,-8,-21,norm

;
;
;squatting frames: left, right (from highest to lowest - 1 thru 3)
;not including the full height standing image
;
;

dr_sq1
	 frame	  eye0,orange,-8,-25,norm    ;eye in leftmost position
	 frame	  droidc_l,white,-8,-37,norm ;droid cap
	 frame	  droidsh_c,magenta,-8,-17,norm ;shoulder
	 frame	  droidp_c1,white,-8,-19,norm

dr_sq2
	 frame	  eye0,orange,-8,-23,norm    ;eye in leftmost position
	 frame	  droidc_l,white,-8,-35,norm ;droid cap
	 frame	  droidsh_c,magenta,-8,-15,norm ;shoulder
	 frame	  droidp_c2,white,-8,-17,norm

dr_sq3
	 frame	  eye0,orange,-8,-21,norm    ;eye in leftmost position
	 frame	  droidc_l,white,-8,-33,norm ;droid cap
	 frame	  droidsh_c,magenta,-8,-13,norm ;shoulder
	 frame	  droidp_c3,white,-8,-15,norm



***************************************
*				      *
*				      *
*	bot frame definitions	      *
*				      *
*				      *
***************************************


bot_walk1
	 frame	  botbod,magenta,-6,-20,norm  ;bot body
	 frame	  botc_l,white,-6,-29,norm    ;bot cap
	 frame	  leg1_l,pink,-16,-21,norm    ;left leg
	 frame	  leg2_r,pink,2,-21,norm      ;right leg

bot_walk2
	 frame	  botbod,magenta,-6,-19,norm	;bot body
	 frame	  botc_l,white,-6,-28,norm	;bot cap
	 frame	  leg4_l,pink,-16,-20,norm	  ;left leg
	 frame	  leg3_r,pink,2,-20,norm	;right leg

bot_walk3
	 frame	  botbod,magenta,-6,-19,norm	;bot body
	 frame	  botc_l,white,-6,-28,norm	;bot cap
	 frame	  leg3_l,pink,-16,-20,norm	  ;left leg
	 frame	  leg4_r,pink,2,-20,norm	;right leg

bot_walk4
	 frame	  botbod,magenta,-6,-20,norm	;bot body
	 frame	  botc_l,white,-6,-29,norm	;bot cap
	 frame	  leg2_l,pink,-16,-21,norm	  ;left leg
	 frame	  leg1_r,pink,2,-21,norm	;right leg


bot_squat1_l
	 frame	  botbod,magenta,-6,-16,norm	;bot body
	 frame	  botc_l,white,-6,-25,norm	;bot cap
	 frame	  sqlegsh_l,pink,-16,-17,norm
	 frame	  sqleglh_r,pink,2,-17,norm

bot_squat2_l
	 frame	  botbod,magenta,-6,-14,norm	;bot body
	 frame	  botc_l,white,-6,-23,norm	;bot cap
	 frame	  sqlegsl_l,pink,-16,-15,norm
	 frame	  sqlegll_r,pink,2,-15,norm

bot_squat1_r
	 frame	  botbod,magenta,-6,-16,norm	;bot body
	 frame	  botc_l,white,-6,-25,norm	;bot cap
	 frame	  sqleglh_l,pink,-16,-17,norm
	 frame	  sqlegsh_r,pink,2,-17,norm

bot_squat2_r
	 frame	  botbod,magenta,-6,-14,norm	;bot body
	 frame	  botc_l,white,-6,-23,norm	;bot cap
	 frame	  sqlegll_l,pink,-16,-15,norm
	 frame	  sqlegsl_r,pink,2,-15,norm




trans1
	 frame	  droidp_c3,white,-8,-15,norm	;-7
	 frame	  xform1a_l,white,-8,-30,norm	;-7
	 frame	  droidsh_c,magenta,-8,-13,norm ;-7
	 frame	  0,0,0,0,null

trans2
	 frame	  xform2b,white,-8,-22,norm	;-7
	 frame	  xform2a_l,white,-8,-30,norm	;-7
	 frame	  0,0,0,0,null
	 frame	  0,0,0,0,null

trans3
	 frame	  xform2b,white,-8,-22,norm	;-6
	 frame	  xform2a_l,white,-8,-30,norm	;-6
	 frame	  leg1_l,pink,-18,-21,norm	;-16
	 frame	  leg1_r,pink,2,-21,norm	;4

trans4
	 frame	  xform3b,white,-8,-26,norm	;-6
	 frame	  xform3a_l,white,-7,-30,norm	;-5
	 frame	  leg2_l,pink,-18,-21,norm	;-16
	 frame	  leg2_r,pink,2,-21,norm	;4

trans5
	 frame	  0,0,0,0,null
	 frame	  xform4_l,white,-8,-28,norm	;-6
	 frame	  leg3_l,pink,-18,-20,norm	;-16
	 frame	  leg3_r,pink,2,-20,norm	;4

trans6
	 frame	  0,0,0,0,null
	 frame	  xform5_l,white,-8,-28,norm	;-6
	 frame	  leg3_l,pink,-18,-20,norm	;leg4_l, -16
	 frame	  leg3_r,pink,2,-20,norm	;4





****************************
*			   *
*			   *
* Guard frame definitions  *
*			   *
*			   *
****************************




grdcap	 %macro
	 frame	  grdtopcp,magenta, -6,-20,norm
	 frame	  grdbotcp,magenta, -7,+10,norm
	 %endm




grd_f0
	 grdcap
	 frame	  grd__lf,white, -11,-09,norm
	 frame	  grd__lr,white,003,-09,norm

grd_f1
	 grdcap
	 frame	  grdllff,white,-11,-09,norm
	 frame	  grdllfr,white,003,-09,norm

grd_f2
	 grdcap
	 frame	  grdffl,white, -6,-09,norm
	 frame	  0,0,0,0,null

grd_f3
	 grdcap
	 frame	  grdf,white, -5,-09,norm
	 frame	  0,0,0,0,null

grd_f4
	 grdcap
	 frame	  grdffr,white, -5,-09,norm
	 frame	  0,0,0,0,null

grd_f5
	 grdcap
	 frame	  grdrrff,white,-00,-09,norm
	 frame	  grdrrfr,white, -6,-09,norm

grd_f6
	 grdcap
	 frame	  grd__rf,white,  0,-09,norm
	 frame	  grd__rr,white, -8,-09,norm







NetImageBlock
	dw netemg1r		;0
	dw netemg2r		;1
	dw netemg3r		;2
	dw netemg4r		;3

    dw netflt1r 		;4
    dw netflt2r 		;5
    dw netflt3r 		;6
    dw netflt4r 		;7
    dw netflt5r 		;8

    dw netopn1r 		;9
    dw netopn2r 		;A

    dw netclo4r 		;B
    dw netclo4l 		;C
    dw netclo3			;D
    dw netclo2			;E
    dw netclo1			;F
    dw netclo0			;10

    dw netopnl			;11
    dw netopnr			;12
    dw netemg4l
    dw netopn1l
    dw netopn2l


	 END

