$chip(6502)
$paginate


	 %include secseg.inc

	extern	call_random,special_creature_init_data
	extern	rd_aux,rd_main,wr_aux,wr_main,creature_image_block
	extern	  spr_1

	public	freeray_init,freeray_iterative
	public	  ray_x_pos,ray_y_pos

	seg	graph

leftmargin    equ     $28
rightmargin   equ     $90


freeray_init	proc
;
; free (pre-captured) ray logic
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	sta	rd_aux
	lda	special_creature_init_data+1
	sec
	sbc	#29
	sta	ray_y_pos		;ray y position
..random1
	sta	rd_main
	jsr	call_random
	and	#$5f
	clc
	adc	#leftmargin
	sta	ray_x_pos		;get number between $28  and $90

	ldx	#0
	stx	..whichframe		;left frames
	stx	..animation_offset
	jsr	call_random
	sta	..rightorleft		;initial ray direction
	cmp	#128
	bpl	..continue1
	inc	..whichframe		;right frames
..continue1
	lda	#08
	sta	..raymovedelay
	lda	#0
	sta	..raypose
	lda	#08
	sta	..rayframechangedelay	;init needed data
	jmp	..init			;put data into sprite block


freeray_iterative

;	 dec	 ..raymovedelay
;	 beq	 ..checkframe
;	 bpl	 ..continue2
;	 lda	 #08
;	 sta	 ..raymovedelay 	 ;reset delay
..continue2
	lda	..rightorleft
	bpl	..right 		;move right
..left
	dec	ray_x_pos
	lda	..flip
	eor	#$ff
	sta	..flip
	bne	..rayskip1
	dec	ray_x_pos
..rayskip1
	lda	ray_x_pos
	cmp	#leftmargin
	bcs	..checkframe		;not at boundary
	sta	..rightorleft		;change direction
	lda	..whichframe
	eor	#1
	sta	..whichframe		;change frame sets
	jmp	..init

..right
	inc	ray_x_pos
	lda	..flip
	eor	#$ff
	sta	..flip
	bne	..rayskip2
	inc	ray_x_pos
..rayskip2
	lda	ray_x_pos
	cmp	#rightmargin
	bcc	..checkframe		;not at boundary
	sta	..rightorleft		;change direction
	lda	..whichframe
	eor	#1
	sta	..whichframe		;change frame sets
	jmp	..init

..checkframe
	sta	rd_aux
	sta	wr_aux
	dec	..rayframechangedelay
	bne	..putsprite
	lda	#08
	sta	..rayframechangedelay	;reset delay
	lda	..animation_offset
	clc
	adc	#12
	sta	..animation_offset	;update animation offset

	inc	..raypose
	lda	..raypose
	cmp	..raymaxpose
	bcc	..putsprite
;done only when a new frame is shown
	lda	#0
	sta	..raypose		;reset pose counter
	sta	..animation_offset	;reset
..init
	sta	rd_aux
	sta	wr_aux
	ldx	..whichframe		;0 or 1
	lda	..frameoffset,x 	;init pointer to frame data
	sta	..offset		;pointer to frame data pointer
;					;done only if pose is reset

..putsprite
	ldy	..offset
	lda	creature_image_block,y
	sta	ray_indirect
	lda	creature_image_block+1,y
	sta	ray_indirect+1			;indirect pointer to data

	ldy	..animation_offset
	lda	(ray_indirect),y
	clc
	adc	ray_x_pos
	sta	spr_1+24
	iny
	lda	(ray_indirect),y
	clc
	adc	ray_y_pos
	sta	spr_1+25
	iny

	ldx	#26
..continue3
	lda	(ray_indirect),y
	sta	spr_1,x
	iny
	inx
	cpx	#36
	bne	..continue3
;	 sty	 ..animation_offset

	tya
	sec
	sbc	#6
	tay
	lda	(ray_indirect),y
	clc
	adc	ray_x_pos
	sta	spr_1+30
	iny
	lda	(ray_indirect),y
	clc
	adc	ray_y_pos
	sta	spr_1+31		;put data to sprite block

..exit
	sta	rd_main
	sta	wr_main
	rts

;local data used by this routine
ray_x_pos	ds	1
ray_y_pos	ds	1


..whichframe	ds	1	;0=left 1=right
..rightorleft	ds	1	;plus=right minus=left
..raypose	ds	1
..raymaxpose	db	3
..rayframechangedelay
		ds	1
..raymovedelay	ds	1
..frameoffset	db	42	;offset to ray left data
		db	36	;offset to ray right data
..offset	ds	1	;holds above data
..animation_offset
		ds	1
..flip		db	0

	 seg	  zpglobal
ray_indirect	  ds	   2
	 seg	  graph

freeray_init	endproc
	end

