$chip(6502)
$paginate
$allpublic

	 %include secseg.inc
	 %include macro.inc

	 seg	  graph

	 extern   rd_aux,rd_main,wr_aux,wr_main
	 extern   sec_tdbl1,sec_tdbl2

	 extern   scanlo,scanhi

	 extern   fuse_command_flag

fuse_y_offset	  equ	   51


disp_fuse	  proc
;
; routine to display or remove selected fuses
;
; A,X,Y,P - scrambled
;
; fuse_command_flag denotes which fuses and how those fuses are tyo be
; affected:
;
;					     7 6 5 4 3 2 1 0
; display (0)/remove (1) fuses		     X
; don't care                                   X X X X
; which fuse (reverse order)			       X X X
;
;
;
	 bit	  fuse_command_flag
	 bpl	  ..display_fuses

..remove_fuses
	 lda	  #$00
	 sta	  ..smc01+1
	 sta	  ..smc02+1
	 sta	  ..smc03+1
	 sta	  ..smc04+1
	 lda	  #$70
	 sta	  ..smc05+1
	 bne	  ..do_fuse_processing

..display_fuses
	 lda	  #$22
	 sta	  ..smc01+1
	 lda	  #$04
	 sta	  ..smc02+1
	 lda	  #$44
	 sta	  ..smc03+1
	 lda	  #$11
	 sta	  ..smc04+1
	 lda	  #$08
	 sta	  ..smc05+1




..do_fuse_processing
	 lda	  fuse_command_flag
	 and	  #$07
	 lbeq	  ..exit

	 sta	  ..temp_flag

	 lda	  #$00
	 sta	  ..fuse_number
	 sta	  ..fuse_x_offset


..do_fuse_loop
	 lsr	  ..temp_flag
	 lbcc	  ..do_loop_logic

	 lda	  #$00
	 sta	  ..fuse_scan

..fuse_scanline_loop
	 lda	  #fuse_y_offset
	 clc
	 adc	  ..fuse_scan
	 tax

	 sta	  rd_aux

	 lda	  scanlo,x
	 sta	  sec_tdbl1
	 sta	  sec_tdbl2
	 lda	  scanhi,x
	 ora	  #$20
	 sta	  sec_tdbl1+1
	 eor	  #$60
	 sta	  sec_tdbl2+1

	 sta	  rd_main


	 sta	  wr_aux

	 lda	  #07
	 clc
	 adc	  ..fuse_x_offset
	 tay

..smc01  lda	  #$22
	 sta	  (sec_tdbl1),y
	 sta	  (sec_tdbl2),y

	 sta	  wr_main

	 lda	  ..fuse_scan
	 cmp	  #$01
	 beq	  ..thisones44

..smc02  lda	  #$04
	 bne	  ..store_it_1

..thisones44
..smc03  lda	  #$44

..store_it_1
	 sta	  (sec_tdbl1),y
	 sta	  (sec_tdbl2),y


	 lda	  ..fuse_scan
	 cmp	  #$01
	 bne	  ..do_scan_loop_logic

	 lda	  #06
	 clc
	 adc	  ..fuse_x_offset
	 tay

..smc04  lda	  #$11
	 sta	  (sec_tdbl1),y
	 sta	  (sec_tdbl2),y

	 sta	  wr_aux

	 lda	  #08
	 clc
	 adc	  ..fuse_x_offset
	 tay

..smc05  lda	  #$08
	 sta	  (sec_tdbl1),y
	 sta	  (sec_tdbl2),y

	 sta	  wr_main

..do_scan_loop_logic
	 ldx	  ..fuse_scan
	 inx
	 cpx	  #$03
	 bcs	  ..do_loop_logic
	 stx	  ..fuse_scan
	 jmp	  ..fuse_scanline_loop



..do_loop_logic
	 ldx	  ..fuse_number
	 inx
	 cpx	  #$03
	 bcs	  ..exit
	 stx	  ..fuse_number
	 lda	  #8
	 clc
	 adc	  ..fuse_x_offset
	 sta	  ..fuse_x_offset
	 jmp	  ..do_fuse_loop


..exit
	 rts

..temp_flag	  ds	   1
..fuse_number	  ds	   1
..fuse_x_offset   ds	   1
..fuse_y_offset   ds	   1
..fuse_scan	  ds	   1

disp_fuse	  endproc

	 end
