$CHIP(6502)
$PAGINATE
$ERRONLY

	 %INCLUDE prmseg.inc
	 %INCLUDE MACRO.inc
	 %include zpext.asm

	 SEG	  maincode

	 PUBLIC   gameinit

	 extern prmsec,clear,set_dhires,current_room
	 extern setroom,wait_fire,hero_x,hero_y,state
	 extern display,workon,page1,erbuff,randomize
	 extern wr_aux,wr_main,stat_i,eye_counter
	 extern facing,headflag,panel_flag,norm,invert_flag
	 extern grd_table,domain_tab,current_guard_flag
	 extern guard_facing,beastie_flag,sting_man_frame
	 extern table_rooms,y_init,x_right_1,x_right_2,y_top,y_bottom
	 extern energy_level,monster_number,bot_parts,clock_lo,game
	 extern creature_table,room_creature_status_table,gate_on

	EXTERN	Options 					;23-Apr-88  HES

	 extern   game,creature_flag,table_onevaluememorywrite
	 extern   drain_state,sign_flag,sparks_gone_flag,spark_level
	 extern   hero_death_flag,clock_flag,options,spr_1

	 extern   soundflag

	 extern   rd_main,rd_aux

	 extern   current_fuse_flag,fuse_command_flag

	extern	fist_animation_flag,center_body_part_flag
	extern	fist_delay,fist_pose,cbp_delay,center_body_part_gone
	 extern   rd_main,rd_aux,fist_y_pos,clock_everything_flag
	extern	leg_parts_here_table,old_game

gameinit PROC
;
;
; initialize all game dependant variables
;
; A,X,Y,P - scrambled
;

	long	prmsec,clear
	lda	workon
	eor	#$60
	sta	workon
	ldx	display
	sta	page1,x
	txa
	eor	#1
	sta	display


	long	prmsec,clear
	lda	workon
	eor	#$60
	sta	workon
	ldx	display
	sta	page1,x
	txa
	eor	#1
	sta	display

	sta	wr_aux
	lda	#$01
	sta	erbuff+3
	sta	erbuff+$43
	sta	wr_main

	long	prmsec,SET_DHIRES

	LDA	#101
	STA	CURRENT_ROOM
	JSR	setroom
	jsr	randomize

	long	prmsec,Options					;23-Apr-88  HES
	lda	  game
	sta	  ..gamelen

*************************************************************

	lda	#0			;init game variables
	sta	creature_table+6
	sta	sparks_gone_flag
	sta	clock_flag

	sta	wr_aux
	tax
..loop10				;which rooms seen
	sta	table_rooms,x
	inx
	cpx	#12
	bne	..loop10
	lda	#$f0
	sta	table_rooms,x
	sta	wr_main

	lda	#$c5			;init x,y parameters
	sta	y_init			;for caged creatures
	lda	#78
	sta	x_right_1
	lda	#78
	sta	x_right_2
	lda	#$bc
	sta	y_top
	lda	#$c9
	sta	y_bottom

	lda	#2
	sta	sign_flag		;set sign to traverse screen twice

	lda	#100
	sta	energy_level		;begining energy
	sta	drain_state		;not being drained

	lda	#$28
	sta	fist_y_pos

	lda	#$80			;turn laser gates on
	ldx	#0
..gates
	sta	gate_on,x
	inx
	cpx	#5
	bcc	..gates


	ldx	#0			;legs flag table
  txa
..legs
	sta	leg_parts_here_table,x
  inx
  cpx	  #6
	bne	..legs

	sta	fist_animation_flag
	sta	center_body_part_flag
	sta	center_body_part_gone
	sta	clock_everything_flag
	sta	fist_pose
	lda	#2
	sta	fist_delay
	sta	cbp_delay


	lda	#5			;init monster number
	sta	monster_number		;bot_parts, time
	sta	spark_level
	lda	#7
	sta	bot_parts
	lda	#0
	sta	clock_lo
	sta	creature_flag
	lda	#$20
	sta	clock_lo+1

	lda	game
	sta	old_game
	beq	..skip5
	lda	#$04
	sta	fist_pose
	ldx	#0			;init creature_table for display
	stx	bot_parts
	lda	#$30
	sta	clock_lo+1
	txa
..loop11
	sta	creature_table,x
	inx
	cpx	#6
	bcc	..loop11
..skip5
	lda	#1
	sta	game			;init game length

	sta	wr_aux
	ldx	#7				;init memory write table
..loop100
	lda	..table_data-1,x
	sta	table_onevaluememorywrite-1,x
	dex
	bne	..loop100

	lda	#$af			;init the sign sprites x-position
	sta	spr_1+18		;#1
	lda	#$bd
	sta	spr_1+24		;#2
	lda	#$cb
	sta	spr_1+30		;#3
	sta	wr_main

********************************************************

	 lda	  #low stat_i
	 sta	  state
	 lda	  #high stat_i
	 sta	  state+1


	 ldx	  #$00
	 stx	  soundflag
	 stx	  headflag
	 stx	  eye_counter
	 stx	  panel_flag
	 stx	  current_guard_flag
	 stx	  guard_facing
	 stx	  beastie_flag
	 stx	  sting_man_frame
	 stx	  fuse_command_flag
	 stx	  hero_death_flag
	 dex
	 stx	  domain_tab+0
	 stx	  domain_tab+1
	 stx	  domain_tab+2

	 lda	  #norm
	 sta	  invert_flag

	 lda	  #low grd_table
	 sta	  tdbl1
	 lda	  #high grd_table
	 sta	  tdbl1+1

	 ldx	  #25
	 ldy	  #$00

	 sta	  wr_aux
	 sta	  rd_aux

..grd_reincarnate_loop
	 lda	  #$80
	 ora	  (tdbl1),y
	 sta	  (tdbl1),y

	 tya
	 clc
	 adc	  #$06
	 tay

	 dex
	 bpl	  ..grd_reincarnate_loop

	 sta	  wr_main
	 sta	  rd_main


	 sta	  wr_aux
	 ldx	  #99
	 lda	  #$f8
..init_creature_loop
	 sta	  room_creature_status_table,x
	 dex
	 bpl	  ..init_creature_loop
	 sta	  wr_main

	 lda	  #$07
	 sta	  current_fuse_flag

	 lda	  #$04
	 sta	  facing

	 lda	  ..gamelen
	 beq	  ..set_for_short

	 lda	  #$0c
	 ldx	  #$76
	 ldy	  #$90
	 bne	  ..do_it

..set_for_short
	 lda	  #$10
	 ldx	  #$45
	 ldy	  #$30


..do_it
	stx	 hero_x
	sty	 hero_y
	STA	CURRENT_ROOM
	JSR	setroom

	 rts

..table_data	  db	   $7e,$7e,$50,$d0,0,0,40
..gamelen	  ds	   1

gameinit ENDPROC

	 END
