$chip(6502)
$paginate

	extern	laser,gate_table,current_room_second,gate_room
	extern	gate_flag,gate_on,gate_x

	public	gates,gate_flag_2

	%include	secseg.inc

	seg	graph

gates	proc
;
; laser and magnetic gate init. routine
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	ldx	#0
	stx	gate_room
	lda	current_room_second
	cmp	#$2d
	beq	..red
	cmp	#$37
	beq	..green
	inx
	cmp	#$30
	beq	..red
	cmp	#$2e
	beq	..green
	inx
	cmp	#$34
	beq	..red
	cmp	#$4e
	beq	..green
	inx
	cmp	#$46
	beq	..red
	cmp	#$51
	beq	..green
	inx
	cmp	#$59
	beq	..green
	sta	gate_room
	sta	gate_flag
	rts				;this room doesnt have any gates

..red
	ldy	#0
	sty	gate_flag
	sty	gate_flag_2
	cmp	#$30
	beq	..next
	cmp	#$46
	beq	..next
	lda	#$40
	sta	gate_flag_2
..next
	stx	gate_x
	lda	data_magnets,x
	sta	gate_table		;starting column
	clc
	adc	#6
	sta	gate_table+1		;ending column
	lda	#0
	ldx	gate_flag_2
	beq	..next1
	lda	#2
..next1
	sta	gate_table+2		;color
	lda	#$04
	sta	gate_table+3		;scan line
	jsr	laser
	lda	#$0c			;second set of scan lines
	sta	gate_table+3
	jsr	laser
	rts

..green
	lda	#$ff
	sta	gate_flag
	stx	gate_x
	lda	gate_on,x
	sta	..temp
	lda	#$ff
	bit	..temp
	bvs	..done			;gate turned off
	bne	..xyz123
	lda	..temp
	ora	#$40			;gate just failed
	sta	gate_on,x
..xyz123
	lda	data_lasers,x
	sta	gate_table		;starting column
	clc
	adc	#8
	sta	gate_table+1		;ending column
	ldy	current_room_second
	cpy	#$2e
	beq	..next4 		;shifted laser
	ldy	#18
	lda	gate_on,x
	and	#$bf
	bmi	..next3
	beq	..next5
	dec	gate_on,x
	ldy	#0
	beq	..next3
..next5
	ldy	#36
	bne	..next3
..next4
	ldy	#20
	lda	gate_on,x
	and	#$bf
	bmi	..next6
	beq	..next7
	dec	gate_on,x
	ldy	#2
	bne	..next6
..next7
	ldy	#36
..next6
..next3
	sty	gate_table+2		;color
	lda	#$04
	sta	gate_table+3		;scan line
	jsr	laser
..done
	rts

data_lasers
	db	$1c,$1b,$14,$0c,$14
data_magnets
	db	$11,$08,$1d,$1a
gate_flag_2	ds	1
..temp	ds	1

gates	endproc
	end



