$chip(6502)
$paginate
$allpublic



	 %include prmseg.inc
	 %include zpext.asm

	 seg	  maincode

	 extern   current_room,grd_table
	 extern   wr_aux,wr_main,rd_aux,rd_main
	 extern   domain_tab,grd_pntr
	 extern   guard_x,guard_y,current_guard_flag
	 extern   guard_death

guard_vert_speed  equ	   8
guard_horz_speed  equ	   7
guard_shot_speed  equ	   12


grdinit  proc
;
; initialize a guard
;
; A,X,Y,P - scrambled
;
	 ldx	  #$ff
	 stx	  guard_shot_x
	 stx	  guard_shot_y
	 inx
	 stx	  guard_shot_delta_x

	 lda	  current_room		     ;is hero in the citadel ?
	 cmp	  #41
	 bcs	  ..check_domain	     ;yep

	 jmp	  ..clear_domain	     ;clear domain table & exit


..check_domain
	 lda	  current_guard_flag	     ;clear the "shot flying"
	 and	  #$ef			     ;flag
	 sta	  current_guard_flag

	 ldx	  #$02

..current_active_lp
	 lda	  domain_tab,x
	 bmi	  ..curr_act_log
	 cmp	  current_room
	 beq	  ..in_his_domain

..curr_act_log
	 dex
	 bpl	  ..current_active_lp
	 bmi	  ..check_for_new_guard


..in_his_domain
	 jmp	  ..exit


..check_for_new_guard
	 ldx	  #25			     ;check guards 0 - 25

	 lda	  #low grd_table	     ;init guard table
	 sta	  tdbl1 		     ;pointer
	 lda	  #high grd_table
	 sta	  tdbl1+1

..grd_srch_outer_lp
	 ldy	  #$01


..grd_srch_inner_lp
	 sta	  rd_aux
	 lda	  (tdbl1),y		     ;fetch a guard room num.
	 sta	  rd_main
	 cmp	  current_room		     ;are we in a guard room ?
	 beq	  ..found_him		     ;yep, he's hating life
	 iny
	 cpy	  #$04			     ;end of list ?
	 bcc	  ..grd_srch_inner_lp	     ;nope

..next_guard
	 dex
	 bmi	  ..clear_domain	     ;not a guard room

	 clc				     ;point to next guard
	 lda	  tdbl1
	 adc	  #$06
	 sta	  tdbl1
	 bcc	  ..grd_srch_outer_lp
	 inc	  tdbl1+1
	 bcs	  ..grd_srch_outer_lp

*********************************************

..found_him
	 lda	  tdbl1
	 sta	  grd_pntr
	 lda	  tdbl1+1
	 sta	  grd_pntr+1

	 lda	  #$ff
	 sta	  guard_death

	 ldy	  #$05
	 sta	  rd_aux
	 lda	  (tdbl1),y
	 sta	  rd_main
	 sta	  guard_y
	 dey
	 sta	  rd_aux
	 lda	  (tdbl1),y
	 sta	  rd_main
	 sta	  guard_x
	 dey

..build_domain_tab
	 sta	  rd_aux
	 lda	  (tdbl1),y
	 sta	  rd_main
	 sta	  domain_tab-1,y
	 dey
	 bne	  ..build_domain_tab

	 sta	  rd_aux
	 lda	  (tdbl1),y		     ;fetch flags
	 sta	  rd_main
	 sta	  temp1
	 and	  #$30
	 lsr	  a
	 lsr	  a
	 ora	  temp1
	 sta	  current_guard_flag

	 lda	  #guard_horz_speed
	 sta	  guard_delta_x
	 lda	  #guard_vert_speed
	 sta	  guard_delta_y

	 lda	  current_guard_flag
	 sta	  temp1
	 and	  #$c0
	 lsr	  a
	 lsr	  a
	 ora	  temp1
	 sta	  current_guard_flag

	 jmp	  ..exit


..clear_domain
	 ldx	  #$ff			     ;clear the domain table
	 stx	  domain_tab+0
	 stx	  domain_tab+1
	 stx	  domain_tab+2
	 inx
	 stx	  current_guard_flag	     ;disable guard logic flag

..exit
	 rts

*********************************************
	 seg	  maindata

;
;	 current_guard_flag/first entry in grd_table:
;	 (logical 1 = true)
;
;					       7 6 5 4 3 2 1 0
;* guard alive ------------------------------- X
;* vertical guard ------------------------------ X
;  don't care ------------------------------------ X
;  active shot ------------------------------------- X
;* starting room ------------------------------------- X X
;  current guard room ------------------------------------ X X
;
; *=pertains to first field in GRD_TABLE
;
;
guard_delta_x		   ds		     1
guard_delta_y		   ds		     1
guard_facing		   ds		     1
guard_shot_x		   ds		     1
guard_shot_y		   ds		     1
guard_shot_delta_x	   ds		     1

grdinit  endproc

	 end
