$CHIP(6502)
$PAGINATE

	 %INCLUDE prmseg.inc
	 %INCLUDE ZPEXT.ASM
	 %include macro.inc

	extern	guard_vert_speed,current_guard_flag,guard_delta_x
	extern	guard_horz_speed,guard_delta_y,guard_x,guard_y
	extern	domain_tab,hero_x,hero_y,guard_facing
	extern	guard_shot_x,guard_shot_y,guard_shot_delta_x
	extern	current_room,spr_3,spr_4,spr_5,spr_6,spr_7
	extern	grd_f0,grd_f1,grd_f2,grd_f3,grd_f4
	extern	grd_f5,grd_f6,rd_aux,wr_aux,invert_flag,invert
	extern	rd_main,wr_main,guard_shot_speed,norm,invert,null
	extern	grdshotl,grdshotr,speaker
	extern	  guard_death
	extern	  click,tone,noise
	extern	  prmsec
	extern	  drain_state_3

	 public   grditer

	 seg	  maincode

;
; ITERATIVE GUARD LOGIC
;
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;
grditer  proc

..guard_tos	  equ	   42		     ;Top Of Screen
..guard_bos	  equ	   150		     ;Bottom Of Screen
..guard_left_edge equ	   44		     ;left edge of screen
..guard_right_edge equ	   135		     ;right edge of screen



orange	 equ	  $03
green	 equ	  $06
purple	 equ	  $09


..grd_iter
	 lda	  current_room
	 cmp	  #41
	 bcs	  ..ck_for_guard_in_citadel
	 jmp	  ..exit

..ck_for_guard_in_citadel
	 lda	  current_guard_flag
	 bmi	  ..do_guard
	 jmp	  ..no_guard

..do_guard
	 bit	  current_guard_flag
	 bvc	  ..horizontal

..vertical
	 clc
	 lda	  guard_delta_y
	 adc	  guard_y
	 sta	  guard_y


	 bit	  guard_delta_y
	 bmi	  ..ck_top

	 cmp	  #..guard_bos		     ;bottom of play area
	 bcc	  ..legal_y
	 cmp	  #$e0
	 bcc	  ..ck_bottom
..legal_y
	 jmp	  ..ck_for_guard_display

..ck_bottom
	 lda	  current_guard_flag
	 and	  #$03
	 cmp	  #$02
	 beq	  ..change_y_dir

	 tax
	 inx

	 lda	  domain_tab,x
	 cmp	  #$ff
	 beq	  ..change_y_dir

..next_room_down
	 stx	  temp1
	 lda	  current_guard_flag
	 and	  #$fc
	 ora	  temp1
	 sta	  current_guard_flag

	 lda	  #$f0			     ;set guard @ very top edge
	 sta	  guard_y

	 jmp	  ..ck_for_guard_display


..ck_top
	 tay
	 lda	  current_guard_flag
	 and	  #$03
	 beq	  ..ck_top_room_tos

	 cpy	  #200
	 bcs	  ..ck_off_top
	 jmp	  ..ck_for_guard_display

..ck_off_top
	 cpy	  #$f0
	 bcc	  ..off_top
	 jmp	  ..ck_for_guard_display

..ck_top_room_tos
	 cpy	  #..guard_tos		     ;top of play area
	 bcc	  ..change_y_dir
	 jmp	  ..ck_for_guard_display



..off_top
	 tax
	 dex

	 stx	  temp1
	 lda	  current_guard_flag
	 and	  #$fc
	 ora	  temp1
	 sta	  current_guard_flag

	 lda	  #..guard_bos
	 sta	  guard_y

	 jmp	  ..ck_for_guard_display


..change_y_dir
	 sec
	 lda	  #$00
	 sbc	  guard_delta_y
	 sta	  guard_delta_y
	 jmp	  ..ck_for_guard_display







..horizontal
	 clc
	 lda	  guard_delta_x
	 adc	  guard_x
	 sta	  guard_x

	 bit	  guard_delta_x
	 bpl	  ..ck_right_edge

..ck_left_edge
	 tay
	 lda	  current_guard_flag
	 and	  #$03
	 beq	  ..ck_left_room_edge

	 cpy	  #200
	 bcs	  ..ck_off_left
	 jmp	  ..vertical_tracking

..ck_off_left
	 cpy	  #$f0
	 bcc	  ..off_left
	 jmp	  ..vertical_tracking

..ck_left_room_edge
	 cpy	  #..guard_left_edge	     ;top of play area
	 bcc	  ..change_x_dir
	 jmp	  ..vertical_tracking

..off_left
	 tax
	 dex
	 stx	  temp1
	 lda	  current_guard_flag
	 and	  #$fc
	 ora	  temp1
	 sta	  current_guard_flag

	 lda	  #160			     ;set guard @ far right
	 sta	  guard_x

	 jmp	  ..vertical_tracking



..ck_right_edge
	 cmp	  #..guard_right_edge
	 bcc	  ..vertical_tracking

	 lda	  current_guard_flag
	 and	  #$03
	 cmp	  #$02
	 beq	  ..change_x_dir

	 tax
	 inx

	 lda	  domain_tab,x
	 cmp	  #$ff
	 beq	  ..change_x_dir

	 lda	  guard_x
	 cmp	  #175
	 bcc	  ..vertical_tracking

	 stx	  temp1
	 lda	  current_guard_flag
	 and	  #$fc
	 ora	  temp1
	 sta	  current_guard_flag

	 lda	  #$00			     ;set guard @ far left
	 sta	  guard_x

	 jmp	  ..vertical_tracking



..change_x_dir
	 sec
	 lda	  #$00
	 sbc	  guard_delta_x
	 sta	  guard_delta_x


..vertical_tracking
	 lda	  hero_y
	 ldx	  invert_flag
	 cpx	  #invert
	 beq	  ..upsidwn

	 sec
	 sbc	  #10
	 jmp	  ..ck_for_adjust

..upsidwn
	 clc
	 adc	  #11

..ck_for_adjust
	 tay

	 sec
	 sbc	  guard_y
	 beq	  ..ck_for_guard_display

	 sta	  temp1
	 bcs	  ..pos
	 lda	  #$00
	 tax
	 sec
	 sbc	  temp1
	 stx	  temp1
..pos
	 cmp	  #guard_vert_speed
	 bcs	  ..adjust

	 sty	  guard_y
	 jmp	  ..ck_for_guard_display

..adjust
	 lda	  temp1
	 beq	  ..guard_is_low

	 clc
	 lda	  #guard_vert_speed
	 adc	  guard_y
	 cmp	  #..guard_bos
	 bcs	  ..ck_for_guard_display
	 sta	  guard_y
	 jmp	  ..ck_for_guard_display

..guard_is_low
	 sec
	 lda	  guard_y
	 sbc	  #guard_vert_speed
	 sta	  guard_y




..ck_for_guard_display
	 lda	  current_guard_flag
	 bmi	  ..brp1
	 jmp	  ..no_guard
..brp1
	 and	  #$03
	 tax
	 lda	  domain_tab,x
	 cmp	  current_room
	 beq	  ..ck_for_spin
	 jmp	  ..no_guard



;
; guard is present on the screen
;



..ck_for_spin
	 lda	  guard_x
	 cmp	  hero_x
	 bcc	  ..guard_is_left

	 lda	  guard_facing		     ;
	 beq	  ..set_guard_color
	 dec	  guard_facing
	 jmp	  ..set_guard_color

..guard_is_left
	 lda	  guard_facing
	 cmp	  #6
	 beq	  ..set_guard_color
	 inc	  guard_facing





..set_guard_color
	 lda	  current_room
	 cmp	  #89
	 bcc	  ..normal_color
	 lda	  #purple
	 bne	  ..store_color

..normal_color
	 bit	  current_guard_flag
	 bvs	  ..set_vert_color

	 lda	  #orange
	 jmp	  ..store_color

..set_vert_color
	 lda	  #green

..store_color
	 sta	  guard_color




..display_guard
	 lda	  guard_y
	 clc
	 adc	  #$20
	 cmp	  #..guard_bos+$20
	 bcs	  ..after_display_guard

	 lda	  #low ..grd_images
	 sta	  grdseq
	 lda	  #high ..grd_images
	 sta	  grdseq+1

	 lda	  guard_facing
	 asl	  a
	 tay
	 jsr	  setgrd

..after_display_guard
	 jmp	  ..do_guard_shot_stuff


..no_guard
	 ldx	  guard_death
	 dex
	 bmi	  ..normal_no_guard
	 stx	  guard_death
	 sta	  wr_aux
	 stx	  spr_4+2
	 stx	  spr_5+2
	 stx	  spr_6+2
	 stx	  spr_7+2
	 sta	  wr_main
	 jmp	  ..do_guard_shot_stuff

..normal_no_guard
	 lda	  #$00
	 sta	  wr_aux
	 sta	  spr_4+3
	 sta	  spr_5+3
	 sta	  spr_6+3
	 sta	  spr_7+3
	 sta	  wr_main





..do_guard_shot_stuff
	 sta	  wr_aux
	 lda	  #null
	 sta	  spr_3+3
	 sta	  wr_main

	 lda	  #$10
	 bit	  current_guard_flag
	 bne	  ..shot_display_logic

..fire_logic
	 lbpl	  ..exit

	 sta	  wr_aux
	 lda	  #null
	 sta	  spr_3+3
	 sta	  wr_main

	 lda	  current_guard_flag
	 and	  #$03
	 tax
	 lda	  domain_tab,x
	 cmp	  current_room
	 bne	  ..exit

..ck_fire_logic
	 jsr	  ..ck_for_guard_fire
	 bcc	  ..exit

..shot_display_logic
	 jsr	  ..ck_for_shot_display
	 jsr	  ..do_flying_shot


..exit
	 rts




************************************


..ck_for_guard_fire
	 lda	  invert_flag
	 cmp	  #invert
	 beq	  ..upsidown_fire

	 sec
	 lda	  hero_y
	 sbc	  #8
	 jmp	  ..subtract_range

..upsidown_fire
	 clc
	 lda	  hero_y
	 adc	  #$08+$10		     ;!!!!!!!!

..subtract_range
	 sec
	 sbc	  guard_y
	 bmi	  ..not_fired
	 cmp	  #$10
	 bcs	  ..not_fired



	 lda	  hero_x
	 sec
	 sbc	  guard_x
	 bcc	  ..guard_is_right

	 cmp	  #12
	 bcc	  ..not_fired

	 lda	  guard_facing
	 cmp	  #$06
	 bne	  ..not_fired

..shoot_to_the_right
	 lda	  current_guard_flag
	 ora	  #$10
	 sta	  current_guard_flag

	 lda	  guard_x
	 clc
	 adc	  #$10
	 sta	  guard_shot_x
	 lda	  guard_y
	 sec
	 sbc	  #$03
	 sta	  guard_shot_y
	 lda	  #low guard_shot_speed
	 sta	  guard_shot_delta_x
	 jmp	  ..fired



..guard_is_right
	 cmp	  #$fa
	 bcs	  ..not_fired

	 lda	  guard_facing
	 bne	  ..not_fired

..shoot_to_the_left
	 lda	  guard_x
	 sec
	 sbc	  #10
	 cmp	  #151
	 bcs	  ..not_fired

	 sta	  guard_shot_x
	 lda	  guard_y
	 sec
	 sbc	  #$03
	 sta	  guard_shot_y
	 lda	  #low -guard_shot_speed
	 sta	  guard_shot_delta_x

	 lda	  current_guard_flag
	 ora	  #$10
	 sta	  current_guard_flag

..fired
	 sec
	 bcs	  ..fire_exit

..not_fired
	 clc

..fire_exit
	 rts


************************************




*************************************


..ck_for_shot_display
	sta	wr_aux

	lda	#$10
	bit	current_guard_flag
	bne	..display_shot
	lda	#null
	sta	spr_3+3
	beq	..display_shot_done


..display_shot
	lda	guard_shot_x
	sec
	sbc	#8
	sta	spr_3+0

	lda	guard_shot_y
	sta	spr_3+1

	lda	#$0f
	sta	spr_3+2

	lda	#norm
	sta	spr_3+3

	bit	guard_shot_delta_x
	bmi	..moving_left

	lda	#low grdshotr
	sta	spr_3+4
	lda	#high grdshotr
	sta	spr_3+5
	jmp	..display_shot_done

..moving_left
	lda	#low grdshotl
	sta	spr_3+4
	lda	#high grdshotl
	sta	spr_3+5

..display_shot_done
	 sta	wr_main

	 rts


*************************************




******************************************


..do_flying_shot
	 lda	  hero_x
	 sec
	 sbc	  guard_shot_x
	 bpl	  ..pos2

	 sta	  temp1
	 lda	  #$00
	 sec
	 sbc	  temp1

..pos2
	 cmp	  # (guard_shot_speed/2)+2
	 bcs	  ..ck_for_shot_off_screen



	 lda	  invert_flag
	 cmp	  #invert
	 beq	  ..upsidown_hit

	 lda	  hero_y
	 clc
	 adc	  #$03
	 sec
	 sbc	  guard_shot_y
	 bmi	  ..ck_for_shot_off_screen
	 bpl	  ..ck_hit_range_y


..upsidown_hit
	 lda	  guard_shot_y
	 clc
	 adc	  #$03
	 sec
	 sbc	  hero_y
	 bmi	  ..ck_for_shot_off_screen

..ck_hit_range_y
	 cmp	  #25
	 bcs	  ..ck_for_shot_off_screen


;
; he got hit !!!!!!!
;
	 ldx	  #$20
	 ldy	  #$30
	 long	  prmsec,noise

	 lda	  #$07
	 bit	  current_guard_flag
	 bvs	  ..vert_guard_shot_hit

	 lda	  #$01
..vert_guard_shot_hit
	 sta	  drain_state_3

	 jmp	  ..disable_shot


..ck_for_shot_off_screen
	 lda	  guard_shot_x
	 cmp	  #21
	 bcc	  ..disable_shot
	 cmp	  #151
	 bcc	  ..shot_flight_done

..disable_shot
	 lda	  current_guard_flag
	 and	  #$ef
	 sta	  current_guard_flag

..shot_flight_done
	 lda	  guard_shot_x
	 clc
	 adc	  guard_shot_delta_x
	 sta	  guard_shot_x

	 rts


******************************************



	 seg	  maindata

..grd_images
	 dw	  grd_f0
	 dw	  grd_f1
	 dw	  grd_f2
	 dw	  grd_f3
	 dw	  grd_f4
	 dw	  grd_f5
	 dw	  grd_f6

grditer  endproc



	 seg	  maincode

setgrd	PROC

	lda	(grdseq),y
	sta	grdimg
	iny
	lda	(grdseq),y
	sta	grdimg+1

	lda	guard_color
	ldy	#14
	sta	(grdimg),y
	ldy	#20
	sta	(grdimg),y

	sta	rd_aux
	sta	wr_aux

	ldy	#23

..loop
	lda	(grdimg),y	;high pointer
	sta	spr_4,y
	dey
	lda	(grdimg),y	;low pointer
	sta	spr_4,y
	dey

	lda	(grdimg),y	;flag
	sta	spr_4,y
	dey
	cmp	#$e6

	lda	(grdimg),y	;color
	sta	spr_4,y
	dey

	sta	rd_main
	lda	guard_y        ;ypos
	sta	rd_aux
	bcc	..updwn

	clc
	adc	(grdimg),y
	jmp	..skp66

..updwn sec
	sbc	(grdimg),y

..skp66 sta	spr_4,y
	dey

	lda	(grdimg),y	;xpos
	clc
	sta	rd_main
	adc	guard_x
	sta	rd_aux

	cmp	#$a0			     ;rtu
	bcc	..itsok 		     ;rtu
					     ;rtu
	lda	#$00			     ;rtu
					     ;rtu
..itsok 				     ;rtu
	sta	spr_4,y
	dey

	bpl	..loop

	sta	rd_main
	sta	wr_main

	rts

	seg	zpglobal

grdseq	 ds	  2
grdimg	 ds	  2
guard_color	  ds	   1

setgrd	ENDPROC



	 END

