$chip(6502)
$paginate

	extern	gate_table,scanlo,scanhi,gate_flag
	extern	rd_aux,rd_main,wr_aux,wr_main,gate_flag_2

	public	laser

	%include  secseg.inc
	%include  macro.inc

	seg	graph

laser	proc
;
; laser gates logic
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	lda	gate_table+0
	sta	..mod1+1
	lda	gate_table+1
	sta	..mod4+1		;columns

	ldy	gate_table+3
	sty	..temp
	ldx	#8
	stx	..count 		;number of scan lines to do
..loop2
	sta	rd_aux
	lda	scanlo,y
	sta	..mod2+1
	sta	..mod3+1
	sta	..mod5+1
	sta	..mod6+1
	sta	..mod7+1
	sta	..mod8+1
	lda	scanhi,y
	ora	#$20
	sta	..mod3+2
	sta	..mod2+2
	sta	..mod5+2
	sta	..mod6+2
	sta	..mod7+2
	sta	..mod8+2
	sta	rd_main 		;row addresses

	ldy	gate_table+2		;color offset

..mod1	ldx	#$ff		;<<<<---- self mod
..loop1
	sta	wr_aux
	lda	color_table,y
..mod2	sta	$aabb,x 	;<<<<---- self mod
	iny
	sta	wr_main
	lda	color_table,y
..mod3	sta	$aabb,x 	;<<<<---- self mod
	iny

	inx
..mod4	cpx	#$ff		;<<<<---- self mod
	bne	..loop1

	lda	gate_flag
	bne	..skipthis		;not a magnetic gate
	lda	#$ff
	bit	gate_flag_2
	sta	wr_main
	lda	#$11
	bvc	..mod6
	lda	#$44
..mod6	sta	$aabb,x 	;<<<<---- self mod
	sta	wr_aux
	lda	#$08
	bvc	..mod5
	lda	#$22
..mod5	sta	$aabb,x 	;<<<<---- self mod
	inx
	lda	#$e2
	bvc	..mod7
	lda	#$f8
..mod7	sta	$aabb,x 	;<<<<---- self mod
	txa
	sec
	sbc	#$07
	tax
	lda	#$ff
	bit	gate_flag_2
	lda	#$0f
	bvc	..mod8
	lda	#$3f
..mod8	sta	$aabb,x 	;<<<<---- self mod
..skipthis
	sta	wr_main

	ldy	..temp
	iny
	sty	..temp
	dec	..count
	lbne	..loop2

	rts


..count ds	1
..temp	ds	1
..temp2 ds	1

color_table
	db	$08,$11,$22,$44,$08,$11,$22,$44 	;magenta
	db	$08,$11,$22,$44,$08,$11,$22,$44 	;magenta
	db	$08,$11 				;shift magenta
	db	$66,$4c,$19,$33,$66,$4c,$19,$33 	;green
	db	$66,$4c,$19,$33,$66,$4c,$19,$33 	;green
	db	$66,$4c 				;shift green
	db	$00,$00,$00,$00,$00,$00,$00,$00 	;black
	db	$00,$00,$00,$00,$00,$00,$00,$00 	;black
	db	$00,$00 				;shift black

laser	endproc
	end

