$CHIP(6502)
$PAGINATE
;
;
;
;
; !!!!!!!!!!!!!!!!!!!!!!!!    MAIN LOOP     !!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;
;
;

	 %INCLUDE prmseg.inc
	 %INCLUDE MACRO.inc
	 %INCLUDE EXTERN.ASM
	 %INCLUDE ZPEXT.ASM

	 PUBLIC   MAIN,go_on,eye_counter,game_start,call_the_sprite_routine

	 extern   gameinit,proginit
	 EXTERN   SET_DHIRES,CLEAR
	 EXTERN   RD_OS_TAB,stick
	EXTERN	CURRENT_ROOM,hopper_hop
	EXTERN	page1, page2

	extern	state
	EXTERN	sprtab, stamp, setroom
	EXTERN	wr_main, wr_aux, rd_main, rd_aux
	EXTERN	draw, erasp, prmsec
	EXTERN	page1, page2
	EXTERN	display, workon, headflag,panel_flag
	EXTERN	dr5, dr6, dr7, dr8, sp_flag,sp_poin,sp_xpos
	extern	  grditer, spr_10,spr_11,sting_man_frame
	extern	last_key,beastie_flag,test_hopper_release,borer_frame
	extern	test_borer_release,borer_facing,setbeastie
	extern	  borer_move

	EXTERN	NetManager,BoltManager			;HES  11-Apr-88
	EXTERN	NetPhase,BoltPhase			;HES  11-Apr-88
	EXTERN	WinningScreen				;HES  11-Apr-88

	 extern creature_flag,creature_number,timer,movefist,gates

	extern	setroom ,turnbackflag,invert_flag
	extern	invert,trbck_i,creature_table

	 extern   free_beasties

	 extern   netcatch,bolthit,setroom

	 extern   click,tone,noise

	 extern   drain_state,drain_state_3

	 extern   disp_fuse,fuse_command_flag,current_fuse_flag

	 extern   hero_death_flag

	extern	grab_legs,init_legs
	extern	sparks_end_1


	 seg	  init_vec

	 dw	  main


	 SEG	  maincode



MAIN	 PROC

	 jsr	  proginit		     ;joycal, etc.

GAME_START
	 jsr	  gameinit		     ;cls, title screen, etc.
	 long	 prmsec,init_legs		 ;scatter body parts




	lda	#$ff					;HES  11-Apr-88
	sta	NetPhase				;HES  11-Apr-88
	sta	BoltPhase				;HES  11-Apr-88
	sta	  ..noise_delay
	sta	  ..noise_freq

MAIN_LOOP_TOP
	 lda	  current_fuse_flag
	 bne	  ..not_game_end
	 ldx	  #$ff
	 txs

	 sta	 page2
	 move	 display,#0
	 move	 workon,#$20
	 long	 prmsec,clear
	 sta	 page1

	 long	  prmsec,winningscreen

	 sta	  rd_main
	 sta	  wr_main

	 ldx	  #$00
..wait_loop_1
	 ldy	  #$00
..wait_loop_2
	 jsr	  ..wait_sub
	 dey
	 bne	  ..wait_loop_2
	 dex
	 bne	  ..wait_loop_1

	 jmp	  game_start

..wait_sub
	 jsr	  $+3
	 jsr	  $+3
	 rts

..not_game_end
	 lda	  current_room
	 cmp	  #95
	 bcc	  ..no_reactor_noise

	 dec	  ..noise_delay
	 bpl	  ..no_reactor_noise

	 sec
	 sbc	  #95
	 sta	  temp1

	 lda	  #05
	 sec
	 sbc	  temp1
	 asl	  a
	 sta	  ..noise_delay

	 lda	  ..noise_freq
	 eor	  #$ff
	 sta	  ..noise_freq
	 beq	  ..hi_freq
	 ldy	  #$80
	 bmi	  ..set_freq
..hi_freq
	 ldy	  #$20
..set_freq
	 ldx	  #$30
	 long	  prmsec,noise

..no_reactor_noise








	 long	  prmsec,stick

;	 lda	  last_key
;	cmp	#'R'
;	bne	..no_suprises

;	 cmp	  #' '
;	 beq	  ..clear_beasties
;	 cmp	  #'S'
;	 beq	  ..set_stinger
;	 cmp	  #'F'
;	 beq	  ..toggle_borer_facing
;	 cmp	 #'T'
;	 beq	 ..add_ray
;	 cmp	  #'H'
;	 beq	  ..set_hopper
;	 cmp	  #'B'
;	 beq	  ..set_borer
;	 cmp	  #'W'
;	 lbne	  ..no_suprises
;
;
;..set_manowar
;	  lda	   #$02
;	  sta	   beastie_flag
;	  lbne	   ..no_suprises
;
;
;..set_hopper
;	  jsr	   test_hopper_release
;	  bcs	   ..activate_hopper
;	  lda	   #$00
;	  beq	   ..store_flag
;
;..activate_hopper
;	  lda	   #$04
;	  bne	   ..store_flag
;
;..add_ray
;	 ldy	 creature_table+3
;	 iny
;	 sty	 creature_table+3
;   jmp      ..no_suprises
;
;
;
;..set_borer
;	  jsr	   test_borer_release
;	  bcs	   ..activate_borer
;	  lda	   #$00
;	  beq	   ..store_flag
;
;..activate_borer
;	  lda	   #$10
;
;..store_flag
;	  sta	   beastie_flag
;	  jmp	   ..no_suprises
;
;
;..toggle_borer_facing
;	  lda	   borer_facing
;	  eor	   #$01
;	  sta	   borer_facing
;	  jmp	   ..no_suprises
;
;
;..set_stinger
;	  lda	   #$01
;	  sta	   beastie_flag
;	  bne	   ..no_suprises
;
;..clear_beasties
;	  lda	   #$00
;	  sta	   beastie_flag
;	 jmp	 ..no_suprises
;
;..change_room
;	 long	 prmsec,stick
;	 lda	 last_key
;	 ora	 #$20
;	 cmp	 #48
;	 bcc	 ..change_room
;	 cmp	 #58
;	 bcc	 ..change1
;	 cmp	 #65
;	 bcc	 ..change_room
;	 cmp	 #71
;	 bcs	 ..change_room
;	 sec
;	 sbc	 #7
;..change1
;	 sec
;	 sbc	 #48
;	 asl	 a
;	 asl	 a
;	 asl	 a
;	 asl	 a
;	 sta	 current_room
;	 ldx	 #0
;..countdown1
;	 ldy	 #0
;..countdown2
;	 dey
;	 bne	 ..countdown2
;	 dex
;	 bne	 ..countdown1
;..change_room_2
;	 long	 prmsec,stick
;	 lda	 last_key
;	 ora	 #$20
;	 cmp	 #48
;	 bcc	 ..change_room_2
;	 cmp	 #58
;	 bcc	 ..change2
;	 cmp	 #65
;	 bcc	 ..change_room_2
;	 cmp	 #71
;	 bcs	 ..change_room_2
;	 sec
;	 sbc	 #7
;..change2
;	 sec
;	 sbc	 #48
;	 ora	 current_room
;	 sta	 current_room
;	 jsr	 setroom
;
;

..no_suprises
	sta	rd_main 					;23-Apr-88  HES
	sta	wr_main 					;23-Apr-88  HES

	ldx	display
	sta	page1,x
	txa
	eor	#1
	sta	display
	lda	workon
	eor	#$60
	sta	workon

	jmp	(state)


go_on
	long	prmsec,NetManager				;23-Apr-88  HES

*********************************
*				*
* pass current room to netcatch *
* in the "X" register		*

	 ldx	  current_room
	long	prmsec,netcatch

*				*
*********************************

	long	prmsec,BoltManager				;23-Apr-88  HES

*********************************
*				*
* pass current room to bolthit	*
* in the "X" register		*

	 ldx	  current_room
	long	prmsec,bolthit

*				*
*********************************

	jsr	 setbeastie
	jsr	 grditer
	long	  prmsec,free_beasties
	jsr	  timer
	lda	  #$ff
	sta	  drain_state
	sta	  drain_state_3
	long	prmsec,movefist
	lda	turnbackflag
	beq	..skipturnback
	lda	#0
	sta	turnbackflag
	lda	invert_flag
	cmp	#invert
	lbne	trbck_i 	;sparks gone, turn to droid
	jmp	sparks_end_1	;bot fall to ground
..skipturnback

	long	prmsec,grab_legs


	 lda	  beastie_flag
	 tax
	 and	  #$04
	 beq	  ..ck_head_beasties
	 jsr	  hopper_hop
	 jmp	  ..droid_eye

..ck_head_beasties
	 txa
	 and	  #$03
	 beq	  ..ck_for_borer

	 dec	  sting_man_frame
	 bpl	  ..droid_eye
	 lda	  #$03
	 sta	  sting_man_frame
	 jmp	  ..droid_eye

..ck_for_borer
	 txa
	 and	  #$10
	 beq	  ..droid_eye

	 jsr	  borer_move

..droid_eye
	lda	headflag
	bne	..skip1
	lda	panel_flag
	bne	..skip1

	lda	eye_counter
	lsr	a
	sta	rd_aux
	sta	wr_aux
	clc
	adc	spr_11
	cmp	#$a0
	bcc	..itsok
	lda	#$00

..itsok
	sta	spr_10
	sta	rd_main
	sta	wr_main

..skip2 dec	eye_counter
	bpl	..skip1

	move	eye_counter,#16

..skip1

	 jsr	  call_the_sprite_routine

	 long	  prmsec,gates

	 lda	  current_room
	 cmp	  #100
	 bne	  ..no_fuses

	 lda	  fuse_command_flag
	 bpl	  ..do_fuses
	 long	  prmsec,disp_fuse
..do_fuses
	 lda	  current_fuse_flag
	 sta	  fuse_command_flag
	 long	  prmsec,disp_fuse
	 lda	  #$00
	 sta	  fuse_command_flag
..no_fuses


	JMP	MAIN_LOOP_TOP

call_the_sprite_routine
	seg	  maincode
	long	prmsec,erasp
	long	prmsec,draw
	rts

..noise_delay	  ds	   1
..noise_freq	  ds	   1

	seg	zpglobal
eye_counter
	ds	1

main	 endproc

	 END
