$chip(6502)
$paginate

	extern	fist_animation_flag,fist_delay,fist_pose,scan
	extern	fist_table,column,prim,stamp,panelcopy
	extern	center_body_part_flag,cbp_delay,rd_aux,rd_main
	extern	wr_aux,wr_main,spr_1,center_body_part_gone
	extern	hero_x,hero_y,panel1,displaystampedstuff
	extern	botbod,bot_parts,fist_sprite_table
	extern	current_room_second,fist_y_pos,botbod_y_pos

	public	movefist

	%include	secseg.inc

	seg	graph

movefist	proc
;
; logic for animating the fist
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	lda	fist_animation_flag
	beq	..part2
	dec	fist_delay
	bne	..part2
	lda	#2
	sta	fist_delay
;reset if player has exited the room
	lda	current_room_second
	cmp	#8
	beq	..keepgoing
	lda	#4
	sta	fist_pose
	lda	#0
	sta	fist_animation_flag
	lda	#$28
	sta	fist_y_pos
	jmp	..done

..keepgoing
	dec	fist_pose
	lda	fist_pose
	asl	a
	tax
	lda	#$10
	sta	scan
	lda	fist_table,x
	sta	column
	lda	fist_table+1,x
	sta	prim
	jsr	stamp
	jsr	displaystampedstuff
	;put hopper sprite in proper location
	lda	fist_pose
	asl	a
	tax
	lda	fist_sprite_table,x
	ldy	fist_sprite_table+1,x
	sta	wr_aux
	sta	spr_1+48
	sty	spr_1+49
	sta	wr_main

	lda	fist_pose
	bne	..part2
	sta	..botbod_y
	sta	fist_animation_flag
	sta	..botbod_y
	eor	#$ff
	sta	center_body_part_flag

..part2
	lda	center_body_part_flag
	beq	..part3
	dec	cbp_delay
	bne	..part3
	lda	#4
	sta	cbp_delay
	sta	wr_aux
	lda	#$e6
	sta	spr_1+21
	ldx	..botbod_y
	lda	botbod_y_pos,x
	inx
	stx	..botbod_y
	sta	spr_1+19
	sta	wr_main
	cmp	#136		;floor level
	bcc	..part3
	lda	#0
	sta	center_body_part_flag
	eor	#$ff
	sta	center_body_part_gone

..part3
	lda	center_body_part_gone
	beq	..done
;skip if not in fist room (8)
	lda	current_room_second
	cmp	#8
	bne	..done

	lda	hero_y
	cmp	#144		;hero level
	bcc	..done
	lda	hero_x
	cmp	#$69		;x range
	bcc	..done
	cmp	#$76		;x range
	bcs	..done
	lda	#0
	sta	wr_aux
	sta	spr_1+21	;turn off sprite
	sta	wr_main
	lda	#1
	ora	bot_parts
	sta	bot_parts
	jsr	panel1
	sec
	jsr	panelcopy
	lda	#0
	sta	center_body_part_gone

..done
	rts

..botbod_y	ds	1

movefist	endproc
	end


