$chip(6502)
$paginate
$allpublic

	 %include secseg.inc
	 %include macro.inc

	 seg	  graph

	 extern   currently_active_beasties
	 extern   free_hopper_x,free_hopper_y
	 extern   free_stingman_x,free_stingman_y
	 extern   free_borer_x,free_borer_y,borer_offset,borer_lure_flag
	 extern   ray_x_pos,ray_y_pos
	 extern   creature_table
	 extern   rd_main,wr_main,rd_aux,wr_aux
	 extern   net_x,net_y,netphase
	 extern   sec_tdbl1,sec_tdbl2

	 extern   spr_1,beastie_flag,room_creature_status_table

	 extern   manowar_stun_flag

netcatch	  proc
;
; A,Y,P - nothing passed
;
; !!!!!!!!!!  current room MUST BE PASSED in the "X" register !!!!!!!!!
; (it's used elsewhere also)
;
;
; A,X,Y,P - scrambled
;
	 cpx	  #41
	 lbcs	  ..exit
	 stx	  ..current_room

	 lda	  netphase
	 cmp	  #$04
	 lbne	  ..exit

	 sta	  rd_aux
	 lda	  currently_active_beasties
	 sta	  rd_main
	 and	  #$f8
	 lbeq	  ..nobody_in_there

..somebodys_in_here
	 sta	  ..temp_beasties

	 ldx	  #$04
..which_beastie_loop
	 asl	  ..temp_beasties
	 lbcc	  ..this_beastie_done

	 cpx	  #$01
	 bne	  ..not_the_borer
	 bit	  borer_lure_flag
	 lbpl	  ..this_beastie_done

..not_the_borer
	 txa
	 asl	  a
	 tay

	 lda	  ..coord_addr_low,y
	 sta	  sec_tdbl1
	 lda	  ..coord_addr_hi,y
	 sta	  sec_tdbl1+1

	 lda	  ..coord_addr_low+1,y
	 sta	  sec_tdbl2
	 lda	  ..coord_addr_hi+1,y
	 sta	  sec_tdbl2+1


	 ldy	  #$00

	 lda	  (sec_tdbl1),y
	 clc
	 adc	  ..x_os_tab,x
	 cpx	  #$01
	 bne	  ..just_store_it
	 clc
	 adc	  borer_offset
..just_store_it
	 sta	  ..x_coord

	 lda	  (sec_tdbl2),y
	 clc
	 adc	  ..y_os_tab,x
	 sta	  ..y_coord


	 lda	  net_y
	 sec
	 sbc	  ..y_coord
	 bmi	  ..this_beastie_done

	 cmp	  #05			    ;!!! y range !!!
	 bcs	  ..this_beastie_done



	 lda	  net_x
	 sec
	 sbc	  ..x_coord
	 bpl	  ..ck_x_range
	 eor	  #$ff
	 clc
	 adc	  #$01
..ck_x_range
	 cmp	  ..x_range_tab,x
	 bcs	  ..this_beastie_done

	 lda	  creature_table+1,x
	 cmp	  #$08
	 bcs	  ..this_beastie_done
	 inc	  creature_table+1,x

	 lda	  #$05
	 sta	  netphase

	 txa
	 pha
	 asl	  a
	 tay

	 lda	  #$00
	 ldx	  ..creature_sprite,y
	 sta	  wr_aux
	 sta	  spr_1+3,x
	 ldx	  ..creature_sprite+1,y
	 beq	  ..only_one_sprite
	 sta	  spr_1+3,x

..only_one_sprite
	 sta	  wr_main

	 pla
	 pha
	 tax

	 lda	  ..creature_mask,x
	 tay

	 and	  beastie_flag
	 sta	  beastie_flag

	 sta	  rd_aux
	 sta	  wr_aux

	 tya
	 and	  currently_active_beasties
	 sta	  currently_active_beasties

	 tya
	 ldx	  ..current_room
	 and	  room_creature_status_table,x
	 sta	  room_creature_status_table,x

	 sta	  rd_main
	 sta	  wr_main

	 pla
	 tax


..this_beastie_done
	 dex
	 bne	  ..ck_for_end_of_loop
	 bit	  manowar_stun_flag
	 bmi	  ..this_beastie_done

..ck_for_end_of_loop
	 lbpl	  ..which_beastie_loop
	 bmi	  ..exit


..nobody_in_there
..exit
	 rts

*****************************************************

..temp_beasties
	 ds	  1

..current_room	  ds	   1

..x_coord	  ds	   1
..y_coord	  ds	   1


..coord_addr_low
	 db	  low(free_stingman_x),low(free_stingman_y)
	 db	  low(free_borer_x),low(free_borer_y)
	 db	  low(ray_x_pos),low(ray_y_pos)
	 db	  low(free_hopper_x),low(free_hopper_y)
	 db	  low(free_stingman_x),low(free_stingman_y)

..coord_addr_hi
	 db	  high(free_stingman_x),high(free_stingman_y)
	 db	  high(free_borer_x),high(free_borer_y)
	 db	  high(ray_x_pos),high(ray_y_pos)
	 db	  high(free_hopper_x),high(free_hopper_y)
	 db	  high(free_stingman_x),high(free_stingman_y)

..x_os_tab
	 db	  6			     ;man-o-war
	 db	  8			     ;borer
	 db	  0			     ;ray
	 db	  0			     ;hopper
	 db	  6			     ;stinger

..y_os_tab
	 db	  -6			     ;man-o-war
	 db	  -6			     ;borer
	 db	  -28			     ;ray
	 db	  -40			     ;hopper
	 db	  -6			     ;stinger

..x_range_tab
	 db	  3			     ;man-o-war
	 db	  3			     ;borer
	 db	  2			     ;ray
	 db	  3			     ;hopper
	 db	  3			     ;stinger

..creature_sprite
	 db	  6*6,0*6		     ;man-o-war
	 db	  5*6,0*6		     ;borer
	 db	  5*6,4*6		     ;ray
	 db	  5*6,0*6		     ;hopper
	 db	  6*6,0*6		     ;stinger

..creature_mask
	 db	  %11110000		     ;man-o-war
	 db	  %11101000		     ;borer
	 db	  %11011000		     ;ray
	 db	  %10111000		     ;hopper
	 db	  %01111000		     ;stinger




netcatch	  endproc

	 end
