$CHIP(6502)
$PAGINATE
;$ERRONLY

	 %include macro.inc
	 %INCLUDE prmseg.inc
	 %INCLUDE ZPEXT.inc

	 SEG	  lookatdk

         PUBLIC   ROOM_UNPK,CURRENT_ROOM

	 EXTERN   RD_OS_TAB,title_room,borer_wall_left_edge
	 EXTERN   STAMP, prim, scan, column,this_room_beastie_status
	 EXTERN   jumpto, prmsec,set_room_pointer,room_beastie_init
	 extern   wr_aux,wr_main,rd_aux,rd_main
;
; room "unpacker": given a room number to display, this routine will read
; the room data table and pass primitive numbers & coords to the stamping
; routine to construct a room
;
; Room number is passed in CURRENT_ROOM.
;
; Primitive number is passed in the byte variable PRIM,
; x coordinate is passed in COLUMN, and
; y coordinate is passed in a byte variable called SCAN .
;

ROOM_UNPK	  PROC


;
; POINT TO THE PRIMITIVE FLAG DATA
;

	LDA	CURRENT_ROOM

	CMP	#101
	BNE	..NORML
	LDA	#LOW title_room
	STA	TDBL1
	LDA	#HIGH title_room
	STA	TDBL1+1
	JMP	..GET_RM_DAT

..NORML

	jsr	set_room_pointer


;
; GET THE FLAG THAT INDICATES VEG OR METAL & THE FLAG TO DETERMINE CORRECT
; OFFSET FOR UNPACK FLAGS AND OTHER DATA
;
..GET_RM_DAT
	lda	$c083			     ;set $d000 bank 2
	lda	$c083

	LDY	#$04
	LDA	(TDBL1),Y
	STA	VEG_OR_MET

	LDA	#$20
	BIT	VEG_OR_MET
	BNE	$+6
	LDA	#$08
	BNE	$+4

	LDA	#$05

	STA	PRIM_OS



;
; POINT TO THE PRIMITIVE COUNT AND COORDINATE DATA
;

	CLC
	ADC	#$03
	ADC	TDBL1
	STA	TDBL2
	LDA	TDBL1+1
	ADC	#$00
	STA	TDBL2+1


	LDX	#$00

MAIN_UNPK_LP
	STX	FLAG_BYTE_COUNT 	;SAVE LOOP COUNT

	TXA				;NEXT PRIM FLAG BYTE=(INDEX+8)
	CLC
	ADC	PRIM_OS
	TAY

	LDA	(TDBL1),Y
	STA	UNPK_FLAGS

	cpx	#$02
	bne	..notlastbyte
	sta	wr_aux
	sta	this_room_beastie_status
	sta	wr_main
..notlastbyte

	LDX	#$00
UNPK_SH_LP
	STX	FLAG_BIT_COUNT
	ROR	UNPK_FLAGS		;ROTATE A FLAG BIT OUT
	BCC	UNPK_LOOP_LOGIC

	LDA	FLAG_BYTE_COUNT 	;BE SURE THAT WE DON'T TRY TO UNPACK..
	CMP	#$02			;FOR CREATURE OR UNDEFINED DATA.
	lbcc	UNPK_OK_1
	BIT	VEG_OR_MET
	BVC	CK_VEG
	CPX	#$06
	BCC	UNPK_OK_1
	BCS	UNPK_LOOP_LOGIC
CK_VEG
	CPX	#$03
	BCC	UNPK_OK_1

UNPK_LOOP_LOGIC
	INX				;BIT SHIFT LOOP LOGIC
	CPX	#$08			;8 BITS
	BCC	UNPK_SH_LP

	LDX	FLAG_BYTE_COUNT 	;MAIN LOOP LOGIC
	INX
	CPX	#$03			;3 BYTES WORTH OF FLAGS
	BCC	MAIN_UNPK_LP

	lda	  $c08b 		     ;set $d000 bank 1
	lda	  $c08b

	 lda	  current_room
	 cmp	  #101
	 bne	  ..normal

	 ldx	  #103			     ;n*3.5
	 stx	  column
	 ldy	  #40
	 sty	  scan
	 lda	  #37
	 sta	  prim

	move	jumpto,#low(stamp)
	move	jumpto+1,#high(stamp)
	JSR	prmsec


	 ldx	  #88			     ;n*3.5
	 stx	  column
	 ldy	  #48
	 sty	  scan
	 lda	  #38
	 sta	  prim

	move	jumpto,#low(stamp)
	move	jumpto+1,#high(stamp)
	JSR	prmsec


	 ldx	  #42			     ;n*3.5
	 stx	  column
	 ldy	  #88
	 sty	  scan
	 lda	  #74
	 sta	  prim

	move	jumpto,#low(stamp)
	move	jumpto+1,#high(stamp)
	JSR	prmsec

	 jmp	  ..exit


..normal
	jsr	  room_beastie_init

..exit
	RTS


UNPK_OK_1
	BIT	VEG_OR_MET		;VEG OR METAL ?
	BVC	UNPK_VEG

	LDA	#19			;METAL, SO OFFSET BY 19 DECIMAL
	BNE	UNPK_GET_PRIM

UNPK_VEG
	LDA	#$00			;VEG, SO NO OFFSET

UNPK_GET_PRIM
	STA	TEMP1			;SAVE THE OFFSET

	LDA	FLAG_BYTE_COUNT 	;INDEX*8+FLAG_BIT_COUNT+OFFSET
	ASL	A
	ASL	A
	ASL	A
	CLC
	ADC	TEMP1
	ADC	FLAG_BIT_COUNT

	TAX

	LDA	PRIMTAB,X
	STA	PRIM

;
; NOW FIND OUT HOW MANY TIMES THIS PRIMITIVE MUST BE STAMPED
;

	LDY	#$00
	STY	PRIMCNT 		;ZERO THE COUNT

	LDA	(TDBL2),Y
	ASL	A
	ROL	PRIMCNT
	ASL	A
	ROL	PRIMCNT
	INY
	LDA	(TDBL2),Y
	AND	#$E0
	LSR	A
	LSR	A
	LSR	A
	ORA	PRIMCNT
	STA	PRIMCNT

UNPK_COORD_LP
	LDY	#$01
;
; GET COORDS
;
	LDA	(TDBL2),Y
	AND	#$1F
	STA	SCAN
	DEY
	LDA	(TDBL2),Y
	AND	#$3F
	STA	TEMP1
;
; CONVERT THE X COORD
;

	ASL	A
	ASL	A
	STA	COLUMN
	LDA	TEMP1
	ASL	A
	CLC
	ADC	TEMP1
	ADC	COLUMN
	ROR	A
	STA	COLUMN
	BCC	AROUND_SC_INC
	LDA	CURRENT_ROOM
	CMP	#98
	BNE	DO_SC_INC
	LDA	PRIM
	CMP	#20
	BEQ	AROUND_SC_INC
DO_SC_INC
	INC	COLUMN
AROUND_SC_INC

	bit	  veg_or_met
	bvc	  ..set_wall_for_veg

	lda	  flag_byte_count
	cmp	  #$01
	bne	  ..notaborerwall
	lda	  flag_bit_count
	cmp	  #$07
	bne	  ..notaborerwall
	beq	  ..set_borer_wall

..set_wall_for_veg
	lda	  flag_byte_count
	bne	  ..notaborerwall
	lda	  flag_bit_count
	bne	  ..notaborerwall

..set_borer_wall
	lda	  column
	sta	  borer_wall_left_edge
..notaborerwall


;
; NOW CONVERT Y COORDS TO SCAN LINES
;
	ASL	SCAN
	ASL	SCAN
	ASL	SCAN

;
; NOW GO STAMP THE THING
;
;	 lda	   scan
;	 cmp	   #160
;	 bcc	   ..normal_prim
;	 sec
;	 sbc	 #$04
;	 sta	 scan
;..normal_prim


	LDA	PRIM
	LDX	COLUMN
	LDY	SCAN

	lda	$c08b			     ;set $d000 bank 1
	lda	$c08b

	move	jumpto,#low(stamp)
	move	jumpto+1,#high(stamp)
	JSR	prmsec

	lda	$c083			     ;set $d000 bank 2
	lda	$c083

	CLC
	LDA	TDBL2
	ADC	#$02
	STA	TDBL2
	LDA	TDBL2+1
	ADC	#$00
	STA	TDBL2+1

	LDX	PRIMCNT
	DEX
	STX	PRIMCNT
	BEQ	NEXT_PRIM

	JMP	UNPK_COORD_LP

NEXT_PRIM
	LDX	FLAG_BIT_COUNT

	JMP	UNPK_LOOP_LOGIC





PRIM_OS  DS	1
PRIMCNT  DS	1
FLAG_BYTE_COUNT
	 DS	1
FLAG_BIT_COUNT
	 DS	1
VEG_OR_MET
	 DS	1
UNPK_FLAGS
	 DS	1
PRIMTAB  DB	00,01,02,03,04,05,06,07
	 DB	08,09,17,11,12,13,14,15
	 DB	24,25,16
	 DB	17,18,19,20,21,22,23,24
	 DB	25,26,27,28,29,30,31,00
	 DB	35,33,34,10,32,36

CURRENT_ROOM
         DS       1

ROOM_UNPK	  ENDPROC

	 END
