$chip(6502)
$paginate
$allpublic

	 %include macro.inc
	 %include secseg.inc
	 %include colorext.inc

	 seg	  graph

	 extern   secprm,random_vector,currently_active_beasties,norm
	 extern   rd_aux,rd_main,wr_aux,wr_main,net_x,headflag
	 extern   spr_6,spr_7,spr_8,special_creature_init_data
	 extern   stinger1,stinger2,stinger3,stinger4,netphase
	 extern   manowar1,manowar2,manowar3,manowar4,net_y
	 extern   column,scan,checkbackground,hero_x,hero_y
	 extern   freeray_iterative
	 extern   HOPPER1L
	 extern   HOPPER2L
	 extern   HOPPER3L
	 extern   HOPPER4L
	 extern   HOPPER1R
	 extern   HOPPER2R
	 extern   HOPPER3R
	 extern   HOPPER4R
	 extern   HOPFRNT1
	 extern   HOPFRNT2
	 extern   borhed1l
	 extern   borhed2l
	 extern   borhed1r
	 extern   borhed2r

	 extern   manowar_stun_flag

	 extern   click,tone,noise
	 extern   drain_state_3
	 extern   sec_temp1


free_beasties	  proc
;
; driver routine for calling the appropriate routines to animate
; all free beasties.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sta	  rd_aux
	 lda	  currently_active_beasties
	 sta	  rd_main
	 beq	  ..exit
	 sta	  sectemp1

	 ldx	  #$04
..iter_beastie_loop
	 rol	  sectemp1
	 bcc	  ..this_beastie_done

	 txa
	 asl	  a
	 tay
	 lda	  ..iter_beastie_vector,y
	 sta	  ..SMC01+1
	 lda	  ..iter_beastie_vector+1,y
	 sta	  ..SMC01+2

	 txa
	 pha

..SMC01  jsr	  ..dummy  ;<------ !!!!!!!!!! SELF MOD !!!!!!!!!!!!

	 pla
	 tax

..this_beastie_done
	 dex
	 bpl	  ..iter_beastie_loop

..exit
	 rts

..iter_beastie_vector
	 dw	  iterative_sting_or_man     ;man-o-war
	 dw	  iterative_borer	     ;big borer
	 dw	  freeray_iterative	     ;ray
	 dw	  iterative_free_hopper      ;rock hopper
	 dw	  iterative_sting_or_man     ;stinger

***********************************
..dummy
	 rts
***********************************

free_beasties	  endproc

***********************************************************************



init_stinger_or_manowar    proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 jsr	  call_random		     ;init x
	 and	  #$3f			     ;(rnd(0)*100)+37
	 sta	  ..secrandom
	 jsr	  call_random
	 and	  #$1f
	 clc
	 adc	  ..secrandom
	 sta	  ..secrandom
	 jsr	  call_random
	 and	  #$06
	 clc
	 adc	  ..secrandom
	 adc	  #37
	 sta	  free_stingman_x

	 jsr	  call_random		     ;init y
	 and	  #$3f			     ;(rnd(0)*80)+22
	 sta	  ..secrandom
	 jsr	  call_random
	 and	  #$11
	 clc
	 adc	  ..secrandom
	 adc	  #22
	 sta	  free_stingman_y


	 lda	  #$07			     ;init frame
	 sta	  free_stingman_frame

	 lda	  #$ff
	 sta	  off_screen_wait
	 sta	  dont_bounce_flag

	 jsr	  set_random_stingman_wait_x

	 jsr	  set_random_stingman_wait_y

	 jsr	  call_random
	 sta	  rd_aux
	 sta	  ..secrandom
	 bit	  currently_active_beasties
	 bmi	  ..for_stinger
	 lda	  #$01
	 bne	  ..ck_sign
..for_stinger
	 lda	  #$02
..ck_sign
	 bit	  ..secrandom
	 sta	  rd_main
	 bpl	  ..store_deltax
	 eor	  #$ff
	 tax
	 inx
	 txa
..store_deltax
	 sta	  free_stingman_delta_x

	 jsr	  call_random
	 bmi	  ..make_deltay_neg
	 lda	  #$01
	 bne	  ..store_deltay
..make_deltay_neg
	 lda	  #$ff
..store_deltay
	 sta	  free_stingman_delta_y

	 sta	  rd_aux
	 sta	  wr_aux

	 bit	  currently_active_beasties
	 bpl	  ..set_manowar

	 lda	  #green
	 sta	  spr_7+2
	 lda	  #norm
	 sta	  spr_7+3

	 lda	  #low( free_stinger_seq)
	 sta	  sectdbl1
	 lda	  #high(free_stinger_seq)
	 sta	  sectdbl1+1

	 jmp	  ..call_setbeastie

..set_manowar
	 lda	  #white
	 sta	  spr_7+2
	 lda	  #norm
	 sta	  spr_7+3

	 lda	  #low( free_manowar_seq)
	 sta	  sectdbl1
	 lda	  #high(free_manowar_seq)
	 sta	  sectdbl1+1

..call_setbeastie
	 sta	  rd_main
	 sta	  wr_main

	 lda	  free_stingman_frame
	 and	  #$fe
	 tay

	 jsr	  set_free_sting_or_man

	 lda	  #$ff
	 sta	  manowar_stun_flag

	 rts


..secrandom
	 ds	  1

init_stinger_or_manowar    endproc


*********************************************************************


set_random_stingman_wait_x proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sta	  rd_aux
	 bit	  currently_active_beasties
	 sta	  rd_main
	 bmi	  ..stinger

	 jsr	  call_random
	 and	  #$01
	 bne	  ..ok1
	 lda	  #$02
..ok1
	 sta	  stingman_x_wait
	 sta	  current_stingman_x_wait
	 jmp	  ..exit

..stinger
	 lda	  #$00
	 sta	  stingman_x_wait
	 sta	  current_stingman_x_wait

..exit
	 rts
set_random_stingman_wait_x endproc


******************************************


set_random_stingman_wait_y proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 jsr	  call_random
	 and	  #$01
	 bne	  ..ok1
	 lda	  #$02

..ok1
	 sta	  stingman_y_wait
	 sta	  current_stingman_y_wait

	 rts

set_random_stingman_wait_y endproc


*********************************************************************


init_hopper	  proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sta	  rd_aux

	 lda	  special_creature_init_data
	 and	  #$0f
	 asl	  a
	 tax
	 lda	  ..hopper_range_x_table+0,x
	 clc
	 adc	  #21
	 sta	  hopper_range_left
	 lda	  ..hopper_range_x_table+1,x
	 clc
	 adc	  #21
	 sta	  hopper_range_right

	 lda	  special_creature_init_data+1
	 sec
	 sbc	  #48-32
	 sta	  free_hopper_y

	 sta	  rd_main

	 lda	  hopper_range_right
	 sec
	 sbc	  hopper_range_left
	 sta	  ..hopper_range

	 jsr	  call_random
	 and	  ..hopper_range
	 clc
	 adc	  hopper_range_left
	 sta	  free_hopper_x

	 lda	  #low(free_hopper_run)
	 sta	  hopper_state
	 lda	  #high(free_hopper_run)
	 sta	  hopper_state+1

	 lda	  #$00
	 sta	  hopper_panic
	 sta	  hopper_delay
	 sta	  free_hopper_frame
	 sta	  hopper_updn_flag
	 sta	  run_flag
	 sta	  hopper_y_offset

	 lda	  #low(hopper_seq_left)
	 sta	  hopper_img
	 lda	  #high(hopper_seq_left)
	 sta	  hopper_img+1

	 lda	  free_hopper_frame
	 asl	  a
	 tay

	 jsr	  set_hopper


	 rts

*************************************

..hopper_range_x_table
	 db	  $0c,$13
	 db	  $12,$4d
	 db	  $0e,$65
	 db	  $2a,$77
	 db	  $5b,$85
	 db	  $07,$2d
	 db	  $62,$7e
	 db	  $0e,$7e

..hopper_range	  ds	   1

init_hopper	  endproc

*********************************************************************

init_free_borer   proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sta	  rd_aux

	 lda	  special_creature_init_data+1
	 lsr	  a
	 lsr	  a
	 lsr	  a
	 sta	  free_borer_x
	 lda	  special_creature_init_data+1
	 sec
	 sbc	  free_borer_x
	 clc
	 adc	  #(-10+21)
	 sta	  free_borer_x

	 lda	  special_creature_init_data+2

	 sta	  rd_main

	 asl	  a
	 tax
	 lda	  #$00
	 rol	  a
	 sta	  free_borer_facing
	 txa
	 sec
	 sbc	  #50
	 sta	  free_borer_y

	 lda	  #$00
	 sta	  borer_lure_flag
	 sta	  borer_offset
	 sta	  free_borer_frame

	 lda	  #$03
	 sta	  fast_animation_count

	 rts

***************************

free_borer_x	  ds	   1
free_borer_y	  ds	   1

free_borer_facing ds	   1

borer_lure_flag   ds	   1
borer_offset	  ds	   1

free_borer_frame  ds	   1

fast_animation_count	   ds		     1

***************************

init_free_borer   endproc

*********************************************************************

iterative_borer   proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 lda	  headflag
	 bne	  ..slow_animation

	 lda	  borer_lure_flag
	 bmi	  ..ck_for_fast_animation

	 beq	  ..ck_for_lure

..do_lure
	 lda	  free_borer_facing
	 beq	  ..hes_facing_left

	 ldx	  borer_offset
	 inx
	 cpx	  #$08
	 bcs	  ..done_luring
	 bcc	  ..store_offset

..hes_facing_left
	 ldx	  borer_offset
	 dex
	 cpx	  #$f9
	 bcc	  ..done_luring

..store_offset
	 stx	  borer_offset
	 jmp	  ..slow_animation

..done_luring
	 lda	  #$ff
	 sta	  borer_lure_flag
	 jmp	  ..slow_animation


..ck_for_lure
lure
	 lda	  free_borer_x
	 clc
	 adc	  #$06
	 sec
	 sbc	  hero_x
	 bpl	  ..xpos
	 eor	  #$ff
	 tax
	 inx
	 txa
..xpos
	 cmp	  #25
	 bcs	  ..no_lure
	 tay

	 lda	  hero_y
	 sec
	 sbc	  #$12
	 sbc	  free_borer_y
	 bpl	  ..ypos
	 eor	  #$ff
	 tax
	 inx
	 txa
..ypos
	 cmp	  #25
	 bcs	  ..no_lure

	 ldx	  #$01
	 stx	  borer_lure_flag

;
; check for biting here
;
	 cpy	  #20
	 bcs	  ..no_bite

..bite_him
	 lda	  #$12
	 sta	  drain_state_3

	 ldx	  #$30
	 ldy	  #$20
	 jsr	  tone

..no_bite
..no_lure
..slow_animation
	 jsr	  call_random
	 cmp	  #$15
	 bcs	  ..set_up_borer_sprite

	 lda	  free_borer_frame
	 eor	  #$01
	 sta	  free_borer_frame

	 jmp	  ..set_up_borer_sprite

..ck_for_fast_animation
	 lda	  hero_x
	 sec
	 sbc	  borer_offset
	 sbc	  #10
	 sbc	  free_borer_x
	 bpl	  ..xpos1
	 eor	  #$ff
	 tax
	 inx
	 txa
..xpos1
	 cmp	  #12
	 bcs	  ..slow_animation

	 lda	  hero_y
	 sec
	 sbc	  #$12
	 sbc	  free_borer_y
	 bpl	  ..ypos1
	 eor	  #$ff
	 tax
	 inx
	 txa
..ypos1
	 cmp	  #20
	 bcs	  ..slow_animation

	 dec	  fast_animation_count
	 bpl	  ..set_up_borer_sprite

	 lda	  #$02
	 sta	  fast_animation_count

	 lda	  free_borer_frame
	 eor	  #$01
	 sta	  free_borer_frame

..set_up_borer_sprite
	 lda	  free_borer_facing
	 beq	  ..setup_left

	 lda	  #low( free_borer_seq_right)
	 sta	  ..borer_img
	 lda	  #high(free_borer_seq_right)
	 sta	  ..borer_img+1
	 jmp	  ..set_index

..setup_left
	 lda	  #low( free_borer_seq_left )
	 sta	  ..borer_img
	 lda	  #high(free_borer_seq_left )
	 sta	  ..borer_img+1

..set_index
	 lda	  free_borer_frame
	 asl	  a
	 tay

	 sta	  wr_aux

	 lda	  free_borer_x
	 clc
	 adc	  borer_offset
	 sta	  spr_6

	 lda	  free_borer_y
	 sta	  spr_6+1

	 lda	  #orange
	 sta	  spr_6+2

	 lda	  #norm
	 sta	  spr_6+3

	 lda	  (..borer_img),y
	 sta	  spr_6+4
	 iny
	 lda	  (..borer_img),y
	 sta	  spr_6+5

	 sta	  wr_main


..exit
	 rts

*******************************

free_borer_seq_left
	 dw	  borhed1l
	 dw	  borhed2l

free_borer_seq_right
	 dw	  borhed1r
	 dw	  borhed2r

	 seg	  zpglobal
..borer_img	  ds	   2
	 seg	  graph

*******************************


iterative_borer   endproc

*********************************************************************

iterative_free_hopper	   proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 lda	  #$00
	 sta	  hopper_panic

	 lda	  headflag
	 beq	  ..ck_for_panic
	 jmp	  ..no_panic

..ck_for_panic
	 lda	  free_hopper_y
	 sec
	 sbc	  hero_y
	 bpl	  ..compare_y
	 eor	  #$ff
	 tax
	 inx
	 txa
..compare_y
	 cmp	  #40
	 bcs	  ..no_panic

..ck_droid_x_for_panic
	 lda	  free_hopper_x
	 clc
	 adc	  #$05
	 sec
	 sbc	  hero_x
	 bpl	  ..droid_is_left
	 eor	  #$ff
	 tax
	 inx
	 txa
..droid_is_left
	 cmp	  #30
	 bcc	  ..yes_panic

..ck_for_net
	 lda	  netphase
	 cmp	  #$04
	 bne	  ..no_panic

	 lda	  net_y
	 sec
	 sbc	  free_hopper_y
	 bpl	  ..no_panic

	 lda	  free_hopper_x
	 clc
	 adc	  #$05
	 sec
	 sbc	  net_x
	 bpl	  ..net_is_left
	 eor	  #$ff
	 tax
	 inx
	 txa
..net_is_left
	 cmp	  #16
	 bcs	  ..no_panic

..yes_panic
	 lda	  #$ff
	 sta	  hopper_panic

..process_logic
..no_panic
	 bit	  hopper_panic
	 bmi	  ..do_hopper
	 dec	  hopper_delay
	 lbpl	  ..exit

..do_hopper
	 lda	  #$02			     ;every so often
	 sta	  hopper_delay


..ck_for_new_random_state
	 jsr	  call_random
	 cmp	  #$05
	 bcc	  ..set_hop_front

	 cmp	  #$09
	 bcs	  ..ck_for_hide
	 and	  #$01
	 bne	  ..store_new_run_flag
	 lda	  #$ff
..store_new_run_flag
	 sta	  run_flag
	 jmp	  ..call_running_routine

..ck_for_hide
	 cmp	  #$20
	 bcc	  ..see_if_a_tree_available

	 jmp	  ..go_hopper_state

..see_if_a_tree_available
	 jsr	  ..hopper_tree_ck
	 cmp	  #$20
	 bne	  ..go_hopper_state

..set_hop_front
	 bit	  hopper_panic
	 bpl	  ..ok_to_hop_front
	 lda	  #$01
	 sta	  run_flag
	 jmp	  ..call_running_routine

..ok_to_hop_front
	 lda	  #low(free_hopper_front)
	 sta	  hopper_state
	 lda	  #high(free_hopper_front)
	 sta	  hopper_state+1

	 lda	  #$00
	 sta	  free_hopper_frame
	 sta	  run_flag

	 jmp	  ..go_hopper_state





..call_running_routine
	 lda	  #low( free_hopper_run)
	 sta	  hopper_state
	 lda	  #high(free_hopper_run)
	 sta	  hopper_state+1


..go_hopper_state
	 jmp	  (hopper_state)

***********************************

free_hopper_run
	 ldx	  run_flag
	 bmi	  ..hop_left
	 beq	  ..set_hop_front

	 lda	  free_hopper_x
	 cmp	  hopper_range_right
	 bcc	  ..keep_running
	 lda	  #$ff
	 sta	  run_flag
	 bmi	  ..keep_running

..hop_left
	 lda	  free_hopper_x
	 cmp	  hopper_range_left
	 bcs	  ..keep_running
	 lda	  #$01
	 sta	  run_flag

..keep_running
	 lda	  free_hopper_x
	 clc
	 adc	  run_flag
	 sta	  free_hopper_x


	 dec	  free_hopper_frame
	 bpl	  ..good_frame
	 lda	  #$03
	 sta	  free_hopper_frame

..good_frame
	 lda	  run_flag
	 bpl	  ..set_right_animation

	 lda	  #low(hopper_seq_left)
	 sta	  hopper_img
	 lda	  #high(hopper_seq_left)
	 sta	  hopper_img+1
	 jmp	  ..do_updn_stuff

..set_right_animation
	 lda	  #low(hopper_seq_right)
	 sta	  hopper_img
	 lda	  #high(hopper_seq_right)
	 sta	  hopper_img+1

..do_updn_stuff
	 lda	  free_hopper_frame
	 cmp	  #$02
	 bcs	  ..noupdn_left
	 ldx	  #$02
	 bne	  ..store_updn_left
..noupdn_left
	 ldx	  #$00
..store_updn_left
	 stx	  hopper_updn_flag
	 asl	  a
	 tay

	 jsr	  set_hopper

	 jmp	  ..exit


****************************


free_hopper_front
	 bit	  hopper_panic
	 lbmi	  ..ck_for_new_random_state

	 lda	  hopper_updn_flag
	 beq	  ..make_it_two
	 lda	  #00
	 beq	  ..store_it
..make_it_two
	 lda	  #$02
..store_it
	 sta	  hopper_updn_flag

	 lda	  #low(hopper_seq_front)
	 sta	  hopper_img
	 lda	  #high(hopper_seq_front)
	 sta	  hopper_img+1

	 lda	  #$05
	 sta	  hopper_y_offset

	 ldy	  #$00
	 jsr	  set_hopper



..exit
	 rts

***********************************

..hopper_tree_ck
	 sta	  rd_main

	 lda	  free_hopper_y
	 sec
	 sbc	  #10
	 sta	  scan
	 lda	  free_hopper_x
	 sta	  column
	 jsr	  checkbackground
	 cmp	  #$20
	 bne	  ..hopper_tree_ck_done

	 lda	  free_hopper_y
	 sec
	 sbc	  #13
	 sta	  scan
	 lda	  free_hopper_x
	 sta	  column
	 jsr	  checkbackground
	 cmp	  #$20
	 bne	  ..hopper_tree_ck_done

	 lda	  free_hopper_y
	 sec
	 sbc	  #16
	 sta	  scan
	 lda	  free_hopper_x
	 sta	  column
	 jsr	  checkbackground
	 cmp	  #$20
	 bne	  ..hopper_tree_ck_done

	 lda	  free_hopper_y
	 sec
	 sbc	  #20
	 sta	  scan
	 lda	  free_hopper_x
	 sta	  column
	 jsr	  checkbackground

..hopper_tree_ck_done
	 rts


***********************************
set_hopper
	 sta	  wr_aux

	 lda	  free_hopper_x
	 sec
	 sbc	  #$05
	 sta	  spr_6

	 lda	  free_hopper_y
	 sec
	 sbc	  hopper_updn_flag
	 sbc	  #32
	 clc
	 adc	  hopper_y_offset
	 sta	  spr_6+1

	 lda	  #orange
	 sta	  spr_6+2

	 lda	  #norm
	 sta	  spr_6+3

	 lda	  (hopper_img),y
	 sta	  spr_6+4
	 iny

	 lda	  (hopper_img),y
	 sta	  spr_6+5

	 sta	  wr_main

	 lda	  #$00
	 sta	  hopper_y_offset

	 rts

***********************************

hopper_seq_left
	 dw	  HOPPER4L
	 dw	  HOPPER3L
	 dw	  HOPPER2L
	 dw	  HOPPER1L

hopper_seq_right
	 dw	  HOPPER4R
	 dw	  HOPPER3R
	 dw	  HOPPER2R
	 dw	  HOPPER1R

hopper_seq_front
	 dw	  HOPFRNT1

hopper_range_left ds	   1
hopper_range_right	   ds		     1

free_hopper_x	  ds	   1
free_hopper_y	  ds	   1

free_hopper_facing	   ds		     1

hopper_state	  ds	   2

hopper_panic	  ds	   1

hopper_delay	  ds	   1

free_hopper_frame ds	   1

hopper_updn_flag  ds	   1

run_flag ds	  1
dist_left	  ds	   1
coinciding_flag   ds	   1

hopper_y_offset   ds	   1



	 seg	  zpglobal

hopper_img	  ds	   2

	 seg	  graph

iterative_free_hopper	   endproc

*********************************************************************

iterative_sting_or_man	   proc
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


off_screen_wait_time	  equ		    45

	 bit	  off_screen_wait
	 bmi	  ..ck_movement
	 dec	  off_screen_wait
	 lbpl	  ..exit

..ck_movement
	 dec	  current_stingman_x_wait
	 php
	 bpl	  ..ck_y_for_move
	 lda	  stingman_x_wait
	 sta	  current_stingman_x_wait

	 lda	  free_stingman_x
	 clc
	 adc	  free_stingman_delta_x
	 sta	  free_stingman_x

..ck_y_for_move
	 dec	  current_stingman_y_wait
	 bmi	  ..do_y_move
	 plp
	 bmi	  ..ck_for_sting
	 lbpl	  ..set_stingman_sprite

..do_y_move
	 pla
	 lda	  stingman_y_wait
	 sta	  current_stingman_y_wait

	 lda	  free_stingman_y
	 clc
	 adc	  free_stingman_delta_y
	 sta	  free_stingman_y




..ck_for_sting
	 lda	  headflag
	 bne	  ..ck_for_bounce

	 lda	  free_stingman_y
	 clc
	 adc	  #$09
	 sta	  sec_temp1

	 lda	  hero_y
	 sec
	 sbc	  #20
	 sbc	  sec_temp1
	 bpl	  ..sting_area_y_pos
	 eor	  #$ff
	 tax
	 inx
	 txa
..sting_area_y_pos
	 cmp	  #32
	 bcs	  ..ck_for_bounce


	 lda	  free_stingman_x
	 clc
	 adc	  #$05
	 sec
	 sbc	  hero_x
	 bpl	  ..sting_area_x_pos
	 eor	  #$ff
	 tax
	 inx
	 txa
..sting_area_x_pos
	 cmp	  #15
	 bcs	  ..ck_for_bounce

	 sta	  wr_main
	 lda	  #$01
	 sta	  drain_state_3

	 ldx	  #$30
	 ldy	  #$20
	 jsr	  tone


..ck_for_bounce
	 lda	  free_stingman_y
	 clc
	 adc	  #$20
	 cmp	  #$20
	 lbcc	  ..keep_going
	 cmp	  #$9c
	 bcc	  ..no_automatic_y_bounce
	 jmp	  ..bounce_y

..no_automatic_y_bounce
	 lda	  free_stingman_x
	 cmp	  #$17
	 lbcc	  ..keep_going
	 cmp	  #$95
	 lbcs	  ..keep_going

	 sta	  wr_main
	 lda	  free_stingman_x
	 clc
	 adc	  #$04
	 sta	  column
	 lda	  free_stingman_y
	 bmi	  ..force_top1
	 clc
	 adc	  #8
	 jmp	  ..store_scan1
..force_top1
	 lda	  #$03
..store_scan1
	 sta	  scan
	 jsr	  checkbackground
	 cmp	  #$20
	 bne	  ..something_there

	 lda	  free_stingman_x
	 clc
	 adc	  #$04
	 sta	  column
	 lda	  free_stingman_y
	 bmi	  ..force_top2
	 clc
	 adc	  #11
	 jmp	  ..store_scan2
..force_top2
	 lda	  #$04
..store_scan2
	 sta	  scan
	 jsr	  checkbackground
	 cmp	  #$20
	 lbeq	  ..keep_going

..something_there
	 bit	  dont_bounce_flag
	 bpl	  ..ck_for_y_bounce

..ck_for_x_bounce
	 lda	  free_stingman_x
	 cmp	  #($17+7)
	 lbcc	  ..bounce_x
	 cmp	  #($8c-6)
	 lbcs	  ..bounce_x

..ck_for_y_bounce
	 bit	  dont_bounce_flag
	 bvc	  ..keep_going

	 lda	  free_stingman_y
	 cmp	  #24
	 bcc	  ..bounce_y

	 jsr	  call_random
	 cmp	  #4
	 bcs	  ..keep_going





..bounce_y
	 lda	  free_stingman_y
	 bit	  free_stingman_delta_y
	 bmi	  ..ck_bottom_y
	 cmp	  #$40
	 bcc	  ..bounce_y_done
	 bcs	  ..do_bounce_y
..ck_bottom_y
	 clc
	 adc	  #$20
	 cmp	  #$60
	 bcs	  ..bounce_y_done

..do_bounce_y
	 jsr	  ..calculate_new_delta_y

..bounce_y_done
	 jmp	  ..set_stingman_sprite



..bounce_x
	 lda	  free_stingman_x
	 bit	  free_stingman_delta_x
	 bmi	  ..ck_right_x
	 cmp	  #90
	 bcc	  ..bounce_x_done
	 bcs	  ..do_bounce_x
..ck_right_x
	 cmp	  #90
	 bcs	  ..bounce_x_done

..do_bounce_x
	 jsr	  ..calculate_new_delta_x

..bounce_x_done
	 jmp	  ..set_stingman_sprite



..keep_going
	 lda	  free_stingman_x
	 cmp	  #47
	 bcc	  ..ck_for_reset_dont_bounce_y
	 cmp	  #127
	 lbcs	  ..ck_for_reset_dont_bounce_y

..reset_dont_bounce_x
	 lda	  dont_bounce_flag
	 ora	  #$80
	 sta	  dont_bounce_flag

..ck_for_reset_dont_bounce_y
	 lda	  free_stingman_y
	 clc
	 adc	  #$20
	 cmp	  #$60
	 bcc	  ..ck_x_offscreen

..reset_dont_bounce_y
	 lda	  dont_bounce_flag
	 ora	  #$40
	 sta	  dont_bounce_flag

..ck_x_offscreen
	 bit	  dont_bounce_flag
	 bpl	  ..ck_y_offscreen

	 ldx	  free_stingman_x
	 dex
	 bpl	  ..ck_y_offscreen
	 cpx	  #$a0
	 bcc	  ..ck_y_offscreen
	 cpx	  #$b0
	 bcs	  ..after_right_edge_patch
	 dec	  free_stingman_x

..after_right_edge_patch
	 lda	  #$00
	 sta	  wr_aux
	 sta	  spr_7
	 sta	  wr_main

	 lda	  dont_bounce_flag
	 and	  #$7f
	 sta	  dont_bounce_flag

	 lda	  #off_screen_wait_time
	 sta	  off_screen_wait
	 jsr	  ..calculate_new_delta_x
	 jmp	  ..exit

..ck_y_offscreen
	 bit	  dont_bounce_flag
	 bvc	  ..set_stingman_sprite

	 lda	  free_stingman_y
	 clc
	 adc	  #$20
	 cmp	  #$0b
	 bcs	  ..set_stingman_sprite

	 lda	  #off_screen_wait_time
	 sta	  off_screen_wait

	 lda	  dont_bounce_flag
	 and	  #$bf
	 sta	  dont_bounce_flag
	 jsr	  ..calculate_new_delta_y



..set_stingman_sprite
	 sta	  rd_aux
	 bit	  currently_active_beasties
	 sta	  rd_main
	 bpl	  ..do_manowar

	 lda	  #low( free_stinger_seq)
	 sta	  sectdbl1
	 lda	  #high(free_stinger_seq)
	 sta	  sectdbl1+1
	 jmp	  ..call_set_beastie

..do_manowar
	 lda	  #low( free_manowar_seq)
	 sta	  sectdbl1
	 lda	  #high(free_manowar_seq)
	 sta	  sectdbl1+1

..call_set_beastie
	 lda	  free_stingman_frame
	 and	  #$fe
	 tay

	 jsr	  set_free_sting_or_man

	 sta	  rd_aux
	 lda	  currently_active_beasties
	 sta	  rd_main

	 and	  #$08
	 beq	  ..not_manowar

;
;man-o-war "man-o-war-ing" sounds
;
	 lda	  free_stingman_frame
	 tay
	 and	  #$01
	 bne	  ..ck_for_dec_frame
	 tya
	 and	  #$04
	 beq	  ..just_click

	 ldx	  #$04
	 ldy	  #$ff
	 bmi	  ..call_manowar_sound

..just_click
	 ldx	  #$01
	 ldy	  #$01

..call_manowar_sound
	 jsr	  tone



..ck_for_dec_frame
	 bit	  manowar_stun_flag
	 bmi	  ..decrement_frame
	 dec	  manowar_stun_flag
	 bpl	  ..exit

..not_manowar
;
; stinger buzzing sounds
;
stinoise
	 lda	  free_stingman_frame
	 asl	  a
	 asl	  a
	 tay
	 iny

	 ldx	  #$28
	 jsr	  noise


..decrement_frame
	 dec	  free_stingman_frame
	 bpl	  ..exit
	 lda	  #$07
	 sta	  free_stingman_frame

..exit
	 rts

******************************************************

..calculate_new_delta_x
	 lda	  #$00
	 sec
	 sbc	  free_stingman_delta_x
	 sta	  free_stingman_delta_x
	 jsr	  set_random_stingman_wait_x
	 rts



..calculate_new_delta_y
	 lda	  #$00
	 sec
	 sbc	  free_stingman_delta_y
	 sta	  free_stingman_delta_y
	 jsr	  set_random_stingman_wait_y
	 rts

******************************************************

set_free_sting_or_man
	 sta	  wr_aux

	 lda	  (sectdbl1),y
	 sta	  spr_7+4
	 iny
	 lda	  (sectdbl1),y
	 sta	  spr_7+5

	 lda	  free_stingman_x
	 sta	  spr_7
	 lda	  free_stingman_y
	 sta	  spr_7+1

;	 sta	  rd_aux
;
;
;	 ldx	  spr_7+2
;	 inx
;	 txa
;	 and	  #$0f
;	 sta	  spr_7+2
;
;
;
;
;	 lda	  spr_7+0
;	 sta	  spr_8+0
;
;	 lda	  spr_7+1
;	 clc
;	 adc	  #$30
;	 sta	  spr_8+1
;
;	 lda	  #green
;	 sta	  spr_8+2
;
;	 lda	  spr_7+3
;	 sta	  spr_8+3
;
;	 lda	  spr_7+4
;	 sta	  spr_8+4
;
;	 lda	  spr_7+5
;	 sta	  spr_8+5
;
;	 sta	  rd_main
	 sta	  wr_main

	 rts

****************************************

off_screen_wait   ds	   1

current_stingman_x_wait    ds		     1

stingman_x_wait   ds	   1

current_stingman_y_wait    ds		     1

stingman_y_wait   ds	   1

dont_bounce_flag  ds	   1

****************************************

free_stingman_x
	 ds	  1

free_stingman_y
	 ds	  1

free_stingman_delta_x
	 ds	  1

free_stingman_delta_y
	 ds	  1

free_stingman_frame
	 ds	  1

free_stinger_seq
	 dw	  stinger4
	 dw	  stinger3
	 dw	  stinger2
	 dw	  stinger1

free_manowar_seq
	 dw	  manowar4
	 dw	  manowar3
	 dw	  manowar2
	 dw	  manowar1

	 seg	  zpglobal

sectemp1 ds    1
sectdbl1 ds    2

iterative_sting_or_man	   endproc

	 seg	  graph
call_random	  proc
	 long	  secprm,random_vector
	 rts
call_random	  endproc


	 end
