$CHIP(6502)
$PAGINATE

	 %INCLUDE secseg.inc


	 public   stick,setxt40,joycal,textout,wait_fire,set_dhires
	 public   keydir

	 public   click,tone,noise


	 extern   invert,invert_flag
	 EXTERN   ANRES,ANIN0,KEY_DOWN,KEY_DAT,fire0,fire1
	 extern   sec_temp1(page0),sec_temp2(page0)
	 extern   sec_tdbl1(page0),sec_tdbl2(page0)

	 extern   last_key,stkval,indent,max_stick_val,txtline

	 extern   soundflag

	 extern   wr_main,wr_aux,rd_main,rd_aux,scanlo,scanhi

	 SEG	  graph


;
; ASSORTED SUBROUTINES
;

JOYCAL	 PROC

;
; JOYSTICK CALIBRATION ROUTINE
;

	JSR	CLRTEXT

	LDX	#$00
	JSR	CAL_PRN
	LDX	#$01
	JSR	CAL_PRN
	LDX	#$02
	JSR	CAL_PRN

CLR_KEY
	LDA	KEY_DOWN	;CLEAR KEYBOARD STROBE

WAIT_FOR_KEY
	LDA	KEY_DAT
	BPL	WAIT_FOR_KEY

	CMP	#('Y' OR $80)	;WAS IT A CAPITAL "Y" ?
	BEQ	GO_CALIBRATE	;YEP
	CMP	#('y' OR $80)	;LOWER CASE "y" ?
	BEQ	GO_CALIBRATE	;YEP
	CMP	#('N' OR $80)	;CAP. "N" ?
	BEQ	GO_AWAY 	;YEP, SO GET OUT
	CMP	#('n' OR $80)	;"n" ?
	BNE	CLR_KEY 	;INVALID CHOICE
GO_AWAY
	LDA	#$80		;INDICATE NO JOYSTICK
	STA	STICK_FLAG

	JMP	FINI_CAL	;HE HAS NO JOYSTICK

GO_CALIBRATE
	LDA	#$00		;INDICATE JOYSTICK IN USE
	STA	STICK_FLAG

	JSR	CLRTEXT

	LDX	#$03
	JSR	CAL_PRN
	LDX	#$04
	JSR	CAL_PRN
	LDX	#$06
	JSR	CAL_PRN
	LDX	#$07
	JSR	CAL_PRN
	LDX	#$08
	JSR	CAL_PRN
	LDX	#$09
	JSR	CAL_PRN

	LDA	#$01
	STA	CAL_TEMP2

	JSR	WAIT_FIRE		;WAIT FOR FIRE BUTTON

	LDX	#$FF
	STX	POT0_MIN
	STX	POT1_MIN
	INX
	STX	POT0_MAX
	STX	POT1_MAX

CAL_BIGLP
	LDX	#$00

CAL_LOOP
	STX	CAL_TEMP1

	JSR	READ_STICK

	LDA	POTCNT
	LDY	POTCNT+1

	LDX	CAL_TEMP2
	BEQ	CAL_POT0_LR

CAL_POT0_UL
	CMP	POT0_MIN
	BCS	CAL_POT1_UL
	STA	POT0_MIN
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_POT1_UL

CAL_POT0_LR
	CMP	POT0_MAX
	BCC	CAL_POT1_LR
	BEQ	CAL_POT1_LR
	STA	POT0_MAX
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_POT1_LR

CAL_POT1_UL
	CPY	POT1_MIN
	BCS	CAL_LOOP_LOG
	STY	POT1_MIN
	LDX	#$00
	STX	CAL_TEMP1
	JMP	CAL_LOOP_LOG

CAL_POT1_LR
	CPY	POT1_MAX
	BCC	CAL_LOOP_LOG
	BEQ	CAL_LOOP_LOG
	STY	POT1_MAX
	LDX	#$00
	STX	CAL_TEMP1

CAL_LOOP_LOG
	LDX	CAL_TEMP1
	DEX
	BNE	CAL_LOOP

	LDY	CAL_TEMP2
	BNE	CAL_PR_UPERL
	JMP	CAL_THRESH

CAL_PR_UPERL
	LDX	#$05
	JSR	CAL_PRN

	JSR	WAIT_FIRE

	DEC	CAL_TEMP2
	JMP	CAL_BIGLP

;
; CALCULATE LOW-MIDDLE-HIGH RESISTANCE THRESHOLDS FOR CONVERSION TO "DIGITAL"
;
CAL_THRESH
	SEC				;CALCUALTE POT0 RANGE
	LDA	POT0_MAX
	SBC	POT0_MIN
	STA	POT0_RANGE

	SEC				;CALCULATE POT1 RANGE
	LDA	POT1_MAX
	SBC	POT1_MIN
	STA	POT1_RANGE

	LSR	A			;POT1_RANGE / 2
	LSR	A
	PHA
	STA	POT1_LO_THRESH

	SEC
	LDA	POT1_RANGE
	SBC	POT1_LO_THRESH
	CLC
	ADC	POT1_MIN
	STA	POT1_HI_THRESH

	CLC
	PLA
	LSR	A
	ADC	POT1_MIN
	STA	POT1_LO_THRESH

; NOW DO POT0 STUFF

	LDA	POT0_RANGE
	LSR	A
	LSR	A
	PHA
	STA	POT0_LO_THRESH

	SEC
	LDA	POT0_RANGE
	SBC	POT0_LO_THRESH
	CLC
	ADC	POT0_MIN
	STA	POT0_HI_THRESH

	CLC
	PLA
	LSR	A
	ADC	POT0_MIN
	STA	POT0_LO_THRESH


	LDA	POT0_MAX
	CMP	POT1_MAX
	BCS	CAL_STORE_MAX

	LDA	POT1_MAX

CAL_STORE_MAX
	STA	MAX_STICK_VAL

	LDA	MAX_STICK_VAL		;MAX_STICK_VAL * 0.75
	STA	SEC_TDBL1
	LDA	#$00
	STA	SEC_TDBL1+1

	ASL	SEC_TDBL1		;MAX_STICK_VAL * 4 ...
	ROL	SEC_TDBL1+1
	ASL	SEC_TDBL1
	ROL	SEC_TDBL1+1

	SEC				;... - MAX_STICK_VAL ...
	LDA	MAX_STICK_VAL
	SBC	SEC_TDBL1
	STA	SEC_TDBL1
	LDA	#$00
	SBC	SEC_TDBL1+1

	LSR	A			;... MAX_STICK_VAL / 4
	STA	SEC_TDBL1+1
	ROR	SEC_TDBL1
	LSR	SEC_TDBL1+1
	LDA	SEC_TDBL1
	ROR	A
	STA	MAX_STICK_VAL



FINI_CAL

	JSR	CLRTEXT
	RTS

CAL_PRN
	LDA	CAL_T_LIN,X
	STA	TXTLINE
	LDA	CAL_IND,X
	STA	INDENT

	TXA
	ASL	A
	TAX

	LDA	CAL_AD,X
	STA	SEC_TEMP1
	LDA	CAL_AD+1,X
	TAY
	TXA
	LSR	A
	TAX
	LDA	CAL_L,X
	LDX	SEC_TEMP1

	JSR	TEXTOUT

	RTS


STICK_FLAG	 DS	1
CAL_TEMP1	 DS	1
CAL_TEMP2	 DS	1

POT0_HI_THRESH	 DS	1
POT0_LO_THRESH	 DS	1
POT0_MAX	 DB	$FF
POT0_MIN	 DB	$00
POT0_RANGE	 DS	1

POT1_HI_THRESH	 DS	1
POT1_LO_THRESH	 DS	1
POT1_MAX	 DB	$FF
POT1_MIN	 DB	$00
POT1_RANGE	 DS	1




CAL_AD
	 DW	J_QUERY1,J_QUERY2,J_QUERY3
	 DW	J_CAL1,J_CAL2,J_CAL3,J_CAL4,J_CAL5,J_CAL6,J_CAL7
CAL_L
	 DB	L_J_QUERY1,L_J_QUERY2,L_J_QUERY3
	 DB	L_J_CAL1,L_J_CAL2,L_J_CAL3,L_J_CAL4
	 DB	L_J_CAL5,L_J_CAL6,L_J_CAL7

CAL_T_LIN
	 DB	10,12,13,2,10,10,19,20,21,22

CAL_IND
	 DB	7,16,16,6,14,14,2,2,2,2



J_QUERY1
	 DB	"DO YOU HAVE A JOYSTICK ?"	;INDENT TO 8
L_J_QUERY1	 EQU	$-J_QUERY1

J_QUERY2
	 DB	"Y) YES"			;INDENT TO 17
L_J_QUERY2	 EQU	$-J_QUERY2

J_QUERY3
	 DB	"N) NO" 			;INDENT TO 17
L_J_QUERY3	 EQU	$-J_QUERY3

J_CAL1
	 DB	"** JOYSTICK CALIBRATION **"
L_J_CAL1	 EQU	$-J_CAL1

J_CAL2
	 DB	"UPPER LEFT"
L_J_CAL2	 EQU	$-J_CAL2

J_CAL3
	 DB	"LOWER RIGHT"
L_J_CAL3	 EQU	$-J_CAL3

J_CAL4
	 DB	"Please hold stick in position shown."
L_J_CAL4	 EQU	$-J_CAL4

J_CAL5
	 DB	"Push action button and then release."
L_J_CAL5	 EQU	$-J_CAL5

J_CAL6
	 DB	"Hold stick at this position until"
L_J_CAL6	 EQU	$-J_CAL6

J_CAL7
	 DB	"position request changes."
L_J_CAL7	 EQU	$-J_CAL7

JOYCAL	 ENDPROC









CLRTEXT  PROC

;
; CLEAR THE 40 COLUMN TEXT SCREEN
;

	LDA	#$00
	STA	TXTLINE
	STA	INDENT
T_CLRLP
	LDX	#LOW T_SPACES
	LDY	#HIGH T_SPACES
	LDA	#L_T_SPACES
	JSR	TEXTOUT

	LDX	TXTLINE
	INX
	STX	TXTLINE
	CPX	#24
	BCC	T_CLRLP

	RTS

T_SPACES  DB	 "                                        "
L_T_SPACES	   EQU	  $-T_SPACES


CLRTEXT  ENDPROC



READ_STICK	  PROC

	LDA	#$00		;RESET ALL POT COUNTERS
	STA	POTCNT
	STA	POTCNT+1

	LDY	MAX_STICK_VAL	;LOOP FOR MAXIMUM STICK VAL*0.6666666
				;(INITIALLY SET TO 256 ITERATIONS)

	LDA	ANRES		;RESET ALL POT TIMERS

JOYLOOP
	LDX	#$01		;97 CLOCK CYCLES
CKIN
	LDA	ANIN0,X 	;TEST FOR CAP DISCHARGE
	BPL	INLOW		;THIS ONE'S DONE
	INC	POTCNT,X	;INC THE COUNT VALUE
	JMP	JLPDONE 	;BRANCH TO LOOP LOGIC
INLOW
	NOP			;WAIT 10 CYCLES TO MAKE TIMING THE SAME
	NOP
	NOP
	NOP
	NOP

JLPDONE
	DEX			;DEC THE POT POINTER
	BPL	CKIN

	DEY
	BNE	JOYLOOP

	RTS

JOY_TEMP1	 DS	1
POTCNT	 DS	2

READ_STICK	  ENDPROC

WAIT_FIRE	  PROC
;
; WAIT FOR RISING EDGE OF FIRE BUTTON PRESS
;
	JSR	STICK		;READ & DEBOUNCED FIRE BUTTONS
	LDA	STKVAL
	AND	#$F0		;CHECK FOR VALIDITY
	BNE	WAIT_FIRE	;NOT VALID
WF_PRESS
	JSR	STICK
	LDA	STKVAL
	AND	#$30
	BNE	WF_PRESS
	BIT	STKVAL
	BMI	WF_DONE
	BVC	WF_PRESS
WF_DONE
	RTS

WAIT_FIRE	  ENDPROC



;
; Pseudo digital joystick routine for the apple (for analog joysticks)
; By Richard T. Unruh
;


STICK	 PROC

	lda	  stkval
	sta	  oldstkval

	LDA	FIRE0
	AND	#$80
	STA	STKVAL
	LDA	FIRE1
	AND	#$80
	LSR	A
	ORA	STKVAL
	STA	STKVAL
;
; CHECK TO SEE IF HE PRESSED A KEY
;
;This patch added by HES, so bug him if it doesn't work.
;
	 LDA	  LAST_KEY    ;See if we're processing a repeated key.
	 BNE	  HAHA01      ;Jump if yes.
;
	 LDA	  KEY_DAT     ;Check KEY_DAT to see if they've hit
	 BPL	  HAHA02      ; a new key.  Jump if no.
;
	 and	  #$7f	      ; strip hi bit
	 STA	  LAST_KEY    ; and store the key in LAST_KEY to flag
			      ; that we have a key that may repeat.
	 STA	  KEY_DOWN    ;Clr the strobe flag.
	 JMP	  HAHA03      ;Jump to the end of the patch.
;
HAHA01			   ;This section processes repeated keys.
	 LDA	  KEY_DOWN    ;Are they still holding down a key?
	 BPL	  HAHA02      ;Jump if no.
	 LDA	  KEY_DAT     ;If so, get the key they're pressing.
	 CMP	  LAST_KEY    ;Is it the same key as last time?
	 BEQ	  HAHA03      ;If yes, jump to the end of the patch.
HAHA02
	 LDA	  #0	      ;Flag that there is no repeated key.
	 STA	  LAST_KEY
HAHA03
;
;End of patch.
;
;	LDA	KEY_DAT
;	LDX	KEY_DOWN
;	BPL	DO_J_READ

;	lda	$c000
;	bpl	do_j_read
;	bit	$c010

	JSR	KEYDIR			;GET "STICK" VALUE
	BMI	DO_J_READ		;IF NEG, NOT VALID
	ORA	STKVAL			;MASK THE "STICK" VALUE IN
	STA	STKVAL

FAKE_J_READ
	 JMP	  FIRE_DEBOUN
	LDX	#$C2			;WAIT TO SIMULATE A "REAL" STICK READ
KWLP
	JSR	J_WAIT
	DEX
	BNE	KWLP

	JMP	FIRE_DEBOUN

J_WAIT
	JSR	$+3
	JSR	$+3
	RTS

DO_J_READ
	LDA	STICK_FLAG		;JOYSTICK PRESENT ?
	BMI	FIRE_DEBOUN		;NO, SO DON'T CALL THE STICK ROUTINE

	JSR	READ_STICK

;
; AT THIS POINT, THE "DIGITIZED" VALUES FOR THE POT INPUTS ARE IN POTCNT0-3.
; THE VALUES ARE NOT USABLE BY A ROUTINE NEEDING THE FULL ANALOG CONTROL
; DUE TO THE ROUTINE RUNNING FOR ONLY 2 MICROSECONDS (A "FULL" READ TAKES 3).
;

;
; ANALOG TO DIGITAL CONVERSION:
; RETURNED IN stkval LIKE THIS: (IN ALL CASES, LOGIC LEVEL 1 IS ACTIVE)
;
;	7 6 5 4 3 2 1 0
;	X				FIRE BUTTON 0
;	  X				FIRE BUTTON 1
;	    ?				DON'T CARE
;	      ? 			DON'T CARE
;		X			JOYSTICK RIGHT
;		  X			JOYSTICK LEFT
;		    X			JOYSTICK DOWN
;		      X 		JOYSTICK UP
;
;
;

	LDA	POTCNT
	CMP	POT0_LO_THRESH
	BCC	ITSLOW0
	CMP	POT0_HI_THRESH
	BCC	ITSMID0
	LDA	#$08
	BNE	SETSTICK0
ITSLOW0
	LDA	#$04
	BNE	SETSTICK0
ITSMID0
	LDA	#$00
SETSTICK0
	ORA	STKVAL
	STA	STKVAL


	LDA	POTCNT+1
	CMP	POT1_LO_THRESH
	BCC	ITSLOW1
	CMP	POT1_HI_THRESH
	BCC	ITSMID1
	LDA	#$02
	BNE	SETSTICK1
ITSLOW1
	LDA	#$01
	BNE	SETSTICK1
ITSMID1
	LDA	#$00
SETSTICK1
	ORA	STKVAL
	STA	STKVAL

;
; DEBOUNCE THE FIRE BUTTONS
;
FIRE_DEBOUN
	LDA	FIRE0		;CHECK FOR FIRE0 DEBOUNCE
	AND	#$80
	STA	JOY_TEMP
	LDA	STKVAL
	AND	#$80
	EOR	JOY_TEMP
	BEQ	CK_FIRE1

	LDA	STKVAL		;FIRE0 IS INVALID
	AND	#$4F
	STA	STKVAL
CK_FIRE1
	LDA	FIRE1		;CHECK FOR FIRE1 DEBOUNCE
	AND	#$80
	LSR	A
	STA	JOY_TEMP
	LDA	STKVAL
	AND	#$40
	EOR	JOY_TEMP
	BEQ	JOY_DONE

	LDA	STKVAL		;FIRE1 IS INVALID
	AND	#$8F
	STA	STKVAL

JOY_DONE
	lda	invert_flag
	cmp	#invert
	bne	..non_inverted

	lda	stkval
	tay
	and	#$03
	beq	..non_inverted
	tya
	eor	#$03
	sta	stkval

..non_inverted
	RTS

JOY_TEMP	 DS	1

oldstkval	ds	 1

STICK	 ENDPROC

KEYDIR	 PROC

	AND	#$7F
	STA	SEC_TEMP1

	LDX	#$08
KEY_LP
	LDA	KEYASC_TAB,X
	CMP	SEC_TEMP1
	BEQ	KEY_FOUND
	DEX
	BPL	KEY_LP
	RTS
KEY_FOUND
	LDA	KEYVAL_TAB,X
	cmp	#$10
	beq	..toggle_sound
	ldx	  #$00
	rts
..toggle_sound
	lda	oldstkval
	and	#$10
	bne	  ..same_as_last_time
	lda	  #$80
	eor	soundflag
	sta	soundflag

..same_as_last_time
	 lda	  #$10
	RTS


KEYASC_TAB
	 DB	$13,"I K M J "			;^S FOR SOUND TOGGLER

KEYVAL_TAB
	 DB	$10,1,0,8,00,2,0,4,0

KEYDIR	 ENDPROC






;
; Text output subroutine
;
;	variable dictionary:
;
;		SEC_TDBL1	2 byte zero page, temporary
;		SEC_TDBL2	2 byte zero page, temporary
;
;	variables/registers passed :
;
;		TXTLINE 	1 byte absolute, passed from caller.
;				indicates what text line to print on.
;		INDENT		1 byte absolute, passed from caller.
;				indicates how far to indent.
;		"A"		length of string to be printed.
;		"X"		LSB of beginning address of string.
;		"Y"		MSB of beginning address of string.
;
;	BE WARNED !!!:
;	This routine does not wrap a string from the right edge of the
;	screen correctly !!! (no address checking)
;


TEXTOUT  PROC

	DEX
	STX	SEC_TDBL1	;LSB OF ADDRESS OF STRING
	CPX	#$FF
	BNE	ADROK
	DEY
ADROK
	STY	SEC_TDBL1+1	;MSB
	TAY			;LENGTH

	LDA	TXTLINE 	;TEXT LINE TO PRINT ON (0-23)
	ASL	A
	ASL	A
	ASL	A
	TAX
	sta	rd_aux
	LDA	scanhi,X
	clc
	adc	#$04
	STA	SEC_TDBL2+1
	LDA	scanlo,X
	sta	rd_main
	CLC
	ADC	INDENT
	SEC
	SBC	#$01
	STA	SEC_TDBL2
	LDA	SEC_TDBL2+1
	SBC	#$00
	STA	SEC_TDBL2+1


TOLP
	LDA	(SEC_TDBL1),Y
	ora	  #$80
	STA	(SEC_TDBL2),Y
	DEY
	BNE	TOLP

	RTS



TEXTOUT  ENDPROC

SET_DHIRES	  PROC

	STA	$C05E
	STA	$C057
	STA	$C050
	STA	$C00D
	STA	$C000
	RTS

SET_DHIRES	  ENDPROC

SETXT40 	  PROC

	STA	$C000
	STA	$C05F
	STA	$C056
	STA	$C051
	STA	$C00C
	STA	$C052
	STA	$C054
	RTS

SETXT40 	  ENDPROC



click	proc
	 bit	  soundflag
	 bmi	  ..exit

	sta	$c030

..exit
	 rts

click	endproc



tone	 proc
	 bit	  soundflag
	 bmi	  ..exit

;
; x is duration
; y is freq
;
	sty	..smc01+1

..outerloop
	sta	$c030
..smc01 ldy	#$ff
..innerloop
	pha
	pla
	dey
	bne	..innerloop
	dex
	bne	..outerloop

..exit
	 rts

tone	 endproc


noise	 proc
	 bit	  soundflag
	 bmi	  ..exit

;
; x is duration
; y is freq
;
	sty	..smc01+1

..outerloop
	sec
	lda	..noisepad+1
	adc	..noisepad+4
	adc	..noisepad+5
	sta	..noisepad
	ldy	#$04
..noiseloop
	lda	..noisepad,y
	sta	..noisepad+1,y
	dey
	bpl	..noiseloop

	bit	..noisepad
	bpl	..smc01

	sta	$c030

..smc01 ldy	#$ff
..innerloop
	dey
	bne	..innerloop
	dex
	bne	..outerloop

..exit
	 rts

..noisepad	  ds	   6

noise	 endproc

	 end
