$chip(6502)
$title(Spider Bot)
$subtitle(Stamp primitives routine)
$paginate
$indent=8

**********************************************
*					     *
*		Setup Room		     *
*					     *
**********************************************

	%include macro.inc
;	%include extern.asm
	%include prmseg.inc

	EXTERN	room_unpk,grdinit
	EXTERN	jumpto, prmsec
	EXTERN	masktb, clear
	EXTERN	display, workon
	EXTERN	page1, page2, rd_aux, rd_main, wr_aux, wr_main
	EXTERN ClrPseudoScreen,ClrScreenEdges
	extern	current_room,beastie_flag
	 extern spr_1, spr_2, spr_3, spr_4, spr_5, spr_6, spr_7, spr_8
	 extern spr_9, spr_10, spr_11, spr_12, spr_13

	EXTERN	prmsec, panel1	,room_percent_decimal		;23-Apr-88  HES
	extern	headflag,creature_number,spark_display		;kam 5-4-88
	extern	prim,column,scan,stamp,clock_flag		;kam 5-9-88

	extern	 boltphase,netphase

	extern	fist,botbod,fist_y_pos,fist_x_pos
	extern	current_room_second,check_legs
	extern	clock_everything_flag


	PUBLIC	SetRoom,SetRoom_B,SetRoom_C,SetRoom_D		;23-Apr-88  HES

	SEG	maincode

setroom PROC
;
; display a new room
; (stamp to erase screen then copy to both displayable screens)
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;
	 sta	  wr_aux

	 ldx	  #$00
	 stx	  spr_1+3
	 stx	  spr_2+3
	 stx	  spr_3+3
	 stx	  spr_4+3
	 stx	  spr_5+3
	 stx	  spr_6+3
	 stx	  spr_7+3
	 stx	  spr_8+3
	 stx	  spr_9+3
	 stx	  spr_10+3
	 stx	  spr_11+3
	 stx	  spr_12+3
	 stx	  spr_13+3

	sta	rd_main
	sta	wr_main

	lda	current_room			;put room% to options screen
	sta	current_room_second

	 lda	  #$ff
	 sta	  netphase
	 sta	  boltphase


	sta	page2
	move	display,#0
	move	workon,#$20
	long	prmsec,clear
	sta	page1

	long	prmsec,ClrPseudoScreen	       ;HES patch.

	call	room_unpk


;*********************** kam mod ******************************
	lda	current_room			;put room% to options screen
	cmp	#101
	bne	..done
	lda	room_percent_decimal
	sta	..temp1
	and	#$f0
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	ldx	#$55
	ldy	#$10
	jsr	..display
	lda	..temp1
	and	#$0f
	ldx	#$5c
	ldy	#$10
	jsr	..display
	jmp	..done
..display
	clc
	adc	#45
	sta	prim
	stx	column
	sty	scan
	long	prmsec,stamp
	jsr	prmsec
	rts
..temp1 db	0
..done
	lda	current_room
	cmp	#8
	bne	..no_fist
	long	prmsec,fist		;put fist to screen if in fist roo	m
;set up part of sprite block for bot part
	sta	 wr_aux
	lda	#high(botbod)
	sta	spr_1+23
	lda	#low(botbod)
	sta	spr_1+22
;	 lda	 #$e6
;	 sta	 spr_1+21
	lda	#$01
	sta	spr_1+20
	lda	fist_y_pos
	sta	spr_1+19
	lda	fist_x_pos
	sta	spr_1+18
	sta	wr_main

..no_fist

	long	prmsec,check_legs
;******************************************************************


	 ldx	  #$00
	 lda	  beastie_flag
	 tay
	 and	  #$04
	 beq	  ..no_hopper
	 stx	  beastie_flag
	 bne	  ..continue

..no_hopper
	 tya
	 and	  #$10
	 beq	  ..no_borer
	 stx	  beastie_flag
..no_borer
..continue
	lda	current_room
	cmp	#101
	beq	..no_edge_cleanup

SetRoom_C							;23-Apr-88  HES
	clc							;23-Apr-88  HES
	long	prmsec,panel1					;23-Apr-88  HES
SetRoom_D							;23-Apr-88  HES
	lda	clock_flag
	beq	setroom_b
	lda	#$ff
	sta	clock_everything_flag
	sec
	long	prmsec,panel1					;23-Apr-88  HES
	lda	#0						;23-Apr-88  HES
	sta	clock_everything_flag

SetRoom_B							;23-Apr-88  HES
	long	prmsec,ClrScreenEdges	       ;HES patch.

..no_edge_cleanup
	jsr	grdinit 		     ;!!!!!!!!RTU!!!!!!!!!

	move	__gets1+2,#$60
	sta	__gets2+2
	move	__puts1+2,#$40
	sta	__puts2+2
	sta	__gets3+2
	sta	__gets4+2
	move	__puts3+2,#$20
	sta	__puts4+2

**********************************************
* Copy erase screen to page2

	ldy	#0
	ldx	#$20

__gets1 lda	$f00,y
__puts1 sta	$f00,y
	iny
	bne	__gets1
	inc	__gets1+2
	inc	__puts1+2
	dex
	bne	__gets1

;	ldx	#0

;__eras1 lda	 scanlo,x
;	 sta	 __err1a+1
;	 sta	 __err1b+1
;	 lda	 scanhi,x
;	 ora	 #$40
;	 sta	 __err1a+2
;	 sta	 __err1b+2
;__err1a lda	 $ffff
;	 and	 #$e0
;__err1b sta	 $ffff
;	 inx
;	 cpx	 #192
;	 bcc	 __eras1

**********************************************

	sta	rd_aux
	sta	wr_aux
	ldx	#$20

__gets2 lda	$f00,y
__puts2 sta	$f00,y
	iny
	bne	__gets2
	inc	__gets2+2
	inc	__puts2+2
	dex
	bne	__gets2

       ;ldx	#0

;__eras2 lda	 scanlo,x
;	 sta	 __err2+1
;	 lda	 scanhi,x
;	 ora	 #$40
;	 sta	 __err2+2
;	 lda	 #$00
;__err2  sta	 $ffff
;	 inx
;	 cpx	 #192
;	 bcc	 __eras2

**********************************************
* copy page2 to page1

	sta	page2

	ldx	#$20

__gets3 lda	$f00,y
__puts3 sta	$f00,y
	iny
	bne	__gets3
	inc	__gets3+2
	inc	__puts3+2
	dex
	bne	__gets3

	sta	rd_main
	sta	wr_main

	ldx	#$20

__gets4 lda	$f00,y
__puts4 sta	$f00,y
	iny
	bne	__gets4
	inc	__gets4+2
	inc	__puts4+2
	dex
	bne	__gets4

;**********************************************
;* copy permanent mask to screen mask
;
;	 lda	 #high(masktb)
;	 sta	 __getm+2
;	 sta	 __putm+2
;	 ldx	 #$20
;	 ldy	 #0
;
;__getm  lda	 $f00,y
;__putm  sta	 $f01,y
;	 iny
;	 iny
;	 bne	 __getm
;	 inc	 __getm+2
;	 inc	 __putm+2
;	 dex
;	 bne	 __getm



;********************** kam mod ******************* 5-4-88
	lda	current_room
	cmp	#101
	beq	..kamsetroom1		;skip if options screen
	lda	headflag
	beq	..kamsetroom1
	lda	creature_number
	cmp	#3
	beq	..kamsetroom1
	lda	clock_flag
	bmi	..kamsetroom1
	long	prmsec,spark_display		       ;show sparks
..kamsetroom1
;***************************************************

	rts


setroom ENDPROC

	END

