$chip(6502)
$title(Spider Bot)
$subtitle(Sprite routines)
$paginate
$indent=8
$allpublic

**********************************************
*					     *
*		Sprite routines 	     *
*					     *
**********************************************

	%include macro.inc
	%include secseg.inc

	EXTERN	scanlo, scanhi
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sprtab, msktab, masktb, Shift0Lo
	EXTERN	colt, pixt
	EXTERN	sp_xpos, sp_ypos, sp_colr, sp_flag, sp_poin
	EXTERN	erbuff, workon

	PUBLIC	draw, erasp

	SEG	temps

	double	screen1
	double	screen2
	double	point
	double	mold

	single	xp
	single	yp
	single	counts
	single	spnum
	single	dtacnt
	single	wko
	single	erpoin

buf	ds	3

	SEG	graph

draw	PROC
;
; The MAGNIFICENT, AMAZING 3D (Douglas D. Dragin) SPRITE ROUTINE !!!!!
;
; I (rich unruh) don't know how it works, but I can tell that:
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;
;
;

	move	wko,workon
	and	#$40
	sta	erpoin

	sta	rd_aux
	sta	wr_aux

	ldy	#0
	sty	spnum
	jmp	__skip

__nxspr add	erpoin,4
	add	spnum,6
	tay

__skip	ldx	erpoin
	lda	sp_flag,y
	sta	erbuff+3,x
	beq	__nxspr
	bmi	__goon

	sta	rd_main
	sta	wr_main
	rts

__goon	sta	__smod

	lda	sp_ypos,y

****************************
*    RICH UNRUH PATCH	   *

	 pha
	 clc
	 adc	  #30
	 cmp	  #160+30
	 bcc	  ..not_panel
	 pla
	 clc
	 adc	  #$04
	 jmp	  ..after_patch

..not_panel

	 pla

..after_patch

*    RICH UNRUH PATCH	   *
****************************


	sta	erbuff+1,x
	sta	yp

	lda	sp_poin,y
	sta	point
	lda	sp_poin+1,y
	sta	point+1

	lda	sp_colr,y
	and	#$7f
	ora	#high(sprtab)
	sta	__nr1f+2
	sta	__nr2f+2
	sta	__nr3f+2
	sta	__nr4f+2

	lda	sp_colr,y
	bpl	__left

	move	__bf2+1,#buf
	move	__bf1+1,#buf+2

	lda	sp_xpos,y

****************************
*    RICH UNRUH PATCH	   *

	 cmp	  #140+21
	 bcs	  __nxspr

*    RICH UNRUH PATCH	   *
****************************

	tax
	lda	pixt,x
	clc
	adc	#high(Shift0Lo)
	clc
	adc	#7
	jmp	__rom

__left	move	__bf1+1,#buf
	move	__bf2+1,#buf+2

	lda	sp_xpos,y

****************************
*    RICH UNRUH PATCH	   *

	 cmp	  #140+21
	 lbcs	  __nxspr

*    RICH UNRUH PATCH	   *
****************************

	tax
	lda	pixt,x
	clc
	adc	#high(Shift0Lo)

__rom	sta	__sft1+2
	sta	__sft2+2
	sta	__sft3+2
	sta	__sft4+2

	lda	colt,x
	sta	xp
	move	dtacnt,#1

	ldx	erpoin	; put info in erase buffer

	ldy	#0
	lda	(point),y
	sta	counts
	sta	erbuff+2,x
	lda	xp
	sta	erbuff+0,x

__loops ldy	yp
	cpy	#196
	lbcs	__nxscn

rtusmc01 lda	 scanlo-4,y  ;<--------- !!!!!!! self mod !!!!!!!!
	sta	screen1
	sta	mold
rtusmc02 lda	 scanhi-4,y  ;<--------- !!!!!!! self mod !!!!!!!!
	 bpl	  ..normal_offset1
	 sta	  screen1+1
	 sta	  mold+1
	 jmp	  ..after_normal_offset1

..normal_offset1
	ora	wko		;workon
	sta	screen1+1
	and	#$1f
	ora	#high(masktb)
	sta	mold+1

..after_normal_offset1
	ldy	dtacnt
	lda	(point),y
	tax
__sft1	lda	$ff00,x
__bf1	sta	buf
__sft2	lda	$ff80,x
	sta	buf+1
	iny
	lda	(point),y
	tax
__sft3	lda	$ff00,x
	ora	buf+1
	sta	buf+1
__sft4	lda	$ff80,x
__bf2	sta	buf+2

	move	__ldata+1,#buf
	ldy	xp

__lpm	cpy	#40
	bcs	__exits

__ldata lda	buf
	and	(mold),y
	beq	__exits
	tax

	lda	(screen1),y
	and	msktab,x
__nr1f	ora	sprtab+$f00,x
	sta	(screen1),y
	iny
	lda	(screen1),y
	and	msktab+$80,x
__nr2f	ora	sprtab+$f80,x
	sta	(screen1),y

	sta	wr_main
	sta	rd_main

	lda	(screen1),y
	and	msktab+$80,x
__nr3f	ora	sprtab+$f80,x
	sta	(screen1),y
	dey
	lda	(screen1),y
	and	msktab,x
__nr4f	ora	sprtab+$f00,x
	sta	(screen1),y

	sta	wr_aux
	sta	rd_aux

__exits iny
	iny
	inc	__ldata+1
	lda	__ldata+1
	cmp	#buf+3
	bcc	__lpm

__nxscn lda	dtacnt
	clc
	adc	#2
	sta	dtacnt

__smod	inc	yp
	dec	counts
	lbne	__loops

	jmp	__nxspr

draw	ENDPROC

erasp	PROC

	move	wko,workon
	and	#$40
	tax

	sta	rd_aux
	sta	wr_aux

..nxspr lda	erbuff+3,x
	bmi	..goon
	bne	..out

	jmp	..donxt

..out	sta	rd_main
	sta	wr_main
	rts

*******************************

..goon	sta	..smod

	lda	erbuff+1,x
	sta	yp
	lda	erbuff+0,x
	bpl	..ok1

	lda	#0

..ok1	cmp	#36
	bcc	..ok2

	lda	#34

..ok2	sta	xp
	lda	erbuff+2,x
	sta	counts

..loops ldy	yp
	cpy	#196
	bcs	..nxscn

rtusmc03 lda	 scanlo-4,y  ;<--------- !!!!!!! self mod !!!!!!!!
	sta	screen1
	sta	screen2
rtusmc04 lda	 scanhi-4,y  ;<--------- !!!!!!! self mod !!!!!!!!
	 bpl	  ..normal_offset2
	 sta	  screen1+1
	 sta	  screen2+1
	 jmp	  ..after_normal_offset2

..normal_offset2
	ora	#$60
	sta	screen1+1
	and	#$1f
	ora	wko
	sta	screen2+1

..after_normal_offset2
	ldy	xp
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y
	iny
	lda	(screen1),y
	sta	(screen2),y

	sta	rd_main
	sta	wr_main

	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y
	dey
	lda	(screen1),y
	sta	(screen2),y

	sta	rd_aux
	sta	wr_aux

..nxscn
..smod	inc	yp
	dec	counts
	bne	..loops

..donxt inx
	inx
	inx
	inx
	jmp	..nxspr

erasp	ENDPROC

	END

