$chip(6502)
$title(Spider Bot)
$subtitle(Stamp primitives routine)
$paginate
$indent=8
$allpublic

**********************************************
*					     *
*		Stamp routine		     *
*					     *
**********************************************

	%include macro.inc
;	%include extern.asm
	%include secseg.inc

	EXTERN	masktb, sprtab, msktab
	EXTERN	scanlo, scanhi, primlo, primhi, primxs
	EXTERN	rd_aux, wr_aux, rd_main, wr_main, pixt, colt
;	EXTERN	source,dest,ptr
	EXTERN	prim, scan, column

	PUBLIC	stamp

	SEG	temps

	double	pdata
	double	screen
	double	mask

	double	ptrx

	single	charcolumn
	single	char
	single	counths

	single	tscan
	single	col
	single	count
	single	coun2
	single	maxcol
	single	color

	SEG	second_lookatdk

stamp	PROC
;
; Stamp primitives to the erase screen
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

****************************
* START RICH UNRUH PATCH   *

	lda	$c083	   ;switch to $d000 RAM bank 2
	lda	$c083

*   END RICH UNRUH PATCH   *
****************************

	move	tscan,scan
;
;****************************
;* START RICH UNRUH PATCH   *
;
;	  lda	   tscan
;	  cmp	   #160
;	  bcc	   ..rtu_normal
;	  clc
;	  adc	   #$04
;	  sta	   tscan
;..rtu_normal
;
;*   END RICH UNRUH PATCH   *
;****************************


	ldy	prim		; set data pointer
	lda	primlo,y
	sta	pdata
	lda	primhi,y
	sta	pdata+1

	sta	rd_aux
	sta	wr_aux

**********************************************

setscpt ldy	tscan	   ; set screen pointer
	lda	scanlo-4,y
	sta	screen
	sta	mask
	lda	scanhi-4,y
	bpl	  ..normal_offset1
	sta	  screen+1
	sta	  mask+1
	jmp	  ..after_normal_offset1
..normal_offset1
	ora	#$60		;!!!!
	sta	screen+1
	eor	#$e0
	sta	mask+1
..after_normal_offset1

	sta	rd_main
	ldy	prim
	lda	primxs,y
	sta	maxcol
	lda	column
	sta	col
	sta	rd_aux

**********************************************
; This patch added by HES 05-Feb-88
;  This section will mark on the Pseudo-Screen where
;  where the primitives are being drawn.

	sta	rd_main
	sta	wr_main


****************************
* START RICH UNRUH PATCH   *

;	lda	tscan		;Is this scan line number divisible by 8?

	 lda	  scan			     ;don't build pseudo screen
	 cmp	  #164			     ;for bottom panel
	 lbcs	  ..pseudostampend

	 lda	  tscan
	 sec
	 sbc	  #$04
	 and	  #$07
	 php
	 clc
	 adc	  #$04
	 plp

;	and	#$07


*   END RICH UNRUH PATCH   *
****************************


	beq	..PseudoStamp1	 ;Continue if yes.
	jmp	..PseudoStampEnd ;Jump if no.

..PseudoStamp1
	lda	screen		;Set up PTRX to point to where on
	sta	ptrx		; the Pseudo-Screen we want to write.
	lda	screen+1
	and	#$03
	ora	#$04
	sta	ptrx+1		;Now ptrx points to the start of the row.

	ldx	column		;Get the column that this prim starts in.

	sta	rd_aux		;Remember that 'Colt' and 'Pixt' are in Aux.
	lda	colt+21,x	   ;Find out which character this is.
	ldy	pixt+21,x
	sta	rd_main

	cpy	#3
	adc	#0
	sta	charcolumn	;Save the character column for later.

	ldx	prim
	lda	primxs,x	;Look up how wide this primitive is
	tax			; in pixels and figure out how wide

	sta	rd_aux
	ldy	colt+21,x	   ; that is in characters.
	lda	pixt+21,x	   ;That will be how many characters
	sta	rd_main

	cmp	#3		; we have to write.
	bcc	..PseudoStamp2
	iny
..PseudoStamp2
;	lda	#$A0		;If it's a regular object, use $A0.
;	ldx	prim
;	bne	..PseudoStamp3	 ;If it's a Borer Wall (Prim #0),
;	lda	#$C0		; use $C0.
;	jmp	..PseudoStamp3

	lda	prim		;Figure out which value we
				; should use for this prim.

	ldx	#((..ListOfSpecialValues - ..ListOfSpecialPrims) - 1)
..Loop
	cmp	..ListOfSpecialPrims,x	;Is this one in list?
	beq	..FoundIt		; Go if yes.
	dex				;Point to next item.
	bpl	..Loop			;Loop back if more items.

	lda	#$A0			;Use $A0 if it's not
	jmp	..PseudoStamp3		; in the list.

..FoundIt
	lda	..ListOfSpecialValues,x ;Get the value for this guy.

..PseudoStamp3
	sta	char		;Save the byte to write.
	sty	counths 	;Save the number of bytes to write.
	sta	wr_main

	ldy	charcolumn	;Get the character column to start in.
..PseudoStamp4
	lda	char		;Get the character to write.
..PseudoStamp5
	sta	(ptrx),y	 ;Store out a byte.
	dec	counths 	;Dec the byte count.
	beq	..PseudoStampEnd ;Are we done?	Go if yes.
	iny			;Move to the byte to the right.
	cpy	#40		;Is this off the edge of the screen?
	bne	..PseudoStamp5	 ;Go if no.

	sta	rd_aux
	ldy	tscan		;We're off the screen, so...
	lda	scanlo-4+8,y	; ...find out the starting address of...
	sta	ptrx		 ; ...the next row...
	lda	scanhi-4+8,y
	sta	rd_main

	ora	#$20
	and	#$3F
	sec
	sbc	#$1C
	sta	ptrx+1		 ; ...and put it in ptrx (two bytes)...
	ldy	#0		;Start at the beginning of that row.
	jmp	..PseudoStamp4	 ;Loop back.

..PseudoStampEnd
	sta	rd_aux
	sta	wr_aux

****************************************************************

nxbyte	ldy	#0		; read packed data
	sta	rd_main
	lda	(pdata),y
	sta	rd_aux
	bne	.09

	jmp	out

.09	cmp	#$10
	bne	.08

	lda	maxcol
	sta	count
	sta	coun2
	move	color,#0
	jmp	doit

.08	and	#$0f
	sta	count
	sta	coun2

	sta	rd_main
	lda	(pdata),y
	sta	rd_aux
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	sta	color

doit	ora	#high(sprtab)	; set-up column information
	sta	norm1+2
	sta	simple1+2
	sta	norm2+2
	sta	simple2+2
	sta	norm3+2
	sta	simple3+2
	sta	norm4+2
	sta	simple4+2
	sta	color
	cmp	#high(sprtab)
	bne	__noblk

	move	color,#$80

__noblk ldx	col		; get column
	lda	pixt+21,x	; get pixel number
	clc
	adc	count
	cmp	#7
	bcc	__once

	sta	count		; preapare for the loop
	ldy	pixt+21,x
	lda	st_bit,y
	ldy	colt+21,x
	tax
	bit	color
	bmi	..black_nom1

	and	(mask),y
	sta	(mask),y
	jmp	__nom1

..black_nom1
	eor	#$7f
	ora	(mask),y
	sta	(mask),y
__nom1
	call	stomp

__lp	iny
	iny
	cpy	#40
	bcc	__nwrp

	ldy	tscan		 ;wrap
	lda	scanlo-4+8,y
	sta	screen
	sta	mask
	lda	scanhi-4+8,y
	ora	#$60
	sta	screen+1
	eor	#$e0
	sta	mask+1
	ldy	#0

__nwrp	lda	count
	sec
	sbc	#7
	sta	count
	cmp	#7
	bcc	__done

	lda	#$00
	tax
	bit	color
	bpl	..notblack_nom2

	lda	#$7f

..notblack_nom2
	sta	(mask),y

__nom2
	call	stomp
	jmp	__lp

__once	tay
	lda	en_bit,y
	ldy	pixt+21,x
	ora	st_bit,y
	ldy	colt+21,x
	tax
	bit	color
	bmi	..black_nom3

	and	(mask),y
	sta	(mask),y
	jmp	__nom3

..black_nom3
	eor	#$7f
	ora	(mask),y
	sta	(mask),y

__nom3
	call	stomp
	jmp	__exit

__done	tax
	lda	en_bit,x
	tax
	bit	color
	bmi	..black_nom4

	and	(mask),y
	sta	(mask),y
	jmp	__nom4

..black_nom4
	eor	#$7f
	ora	(mask),y
	sta	(mask),y

__nom4
	call	stomp

__exit	lda	maxcol		  ; increment x_position
	sec
	sbc	coun2
	sta	maxcol
	beq	nx_sc
	bcs	cont

nx_sc	ldy	#0
	sta	rd_main

nex2	lda	(pdata),y
	beq	out
	iny
	cmp	#$10
	bne	nex2

	sta	rd_aux
	tya
	clc
	adc	pdata
	sta	pdata
	lda	pdata+1
	adc	#0
	sta	pdata+1
	inc	tscan
	jmp	setscpt

cont	lda	col
	clc
	adc	coun2
	sta	col

	cmp	#140
	bcc	.53
	ldy	tscan
	lda	scanlo-4+8,y
	sta	screen
	sta	mask
	lda	scanhi-4+8,y
	ora	#$60
	sta	screen+1
	eor	#$e0
	sta	mask+1
	sub	col,140

.53	inc	pdata
	bne	.54
	inc	pdata+1
.54	jmp	nxbyte

out
****************************
* START RICH UNRUH PATCH   *

	lda	$c08b	   ;switch back to $d000 RAM bank 1
	lda	$c08b

* END RICH UNRUH PATCH	   *
****************************

	sta	rd_main
	sta	wr_main
	rts


..ListOfSpecialPrims
	db	0,3,4,5,7,9,11,17,18

..ListOfSpecialValues
	db	$C0,$B0,$B0,$B0,$B0,$B0,$B0,$B0,$20

stamp	ENDPROC

stomp	PROC
	txa
	eor	#$7f
	and	#$7f
	tax
	cpx	#$7f
	beq	__simpl



	lda	(screen),y
	and	msktab,x

;	lda	sprtab+$f00,x
;	eor	#$ff
;	and	(screen),y
norm1	ora	$f00,x
	sta	(screen),y
	iny

	lda	(screen),y
	and	msktab+$80,x

;	lda	sprtab+$f80,x
;	eor	#$ff
;	and	(screen),y
norm2	ora	$f80,x
	sta	(screen),y
	sta	wr_main
	sta	rd_main

	lda	(screen),y
	and	msktab+$80,x

;	lda	sprtab+$f80,x
;	eor	#$ff
;	and	(screen),y
norm3	ora	$f80,x
	sta	(screen),y
	dey

	lda	(screen),y
	and	msktab,x

;	lda	sprtab+$f00,x
;	eor	#$ff
;	and	(screen),y
norm4	ora	$f00,x
	sta	(screen),y
	sta	wr_aux
	sta	rd_aux
	rts

__simpl

simple1 lda	$1e00,x
	sta	(screen),y
	iny
simple2 lda	$1e80,x
	sta	(screen),y
	sta	wr_main
	sta	rd_main
simple3 lda	$1f80,x
	sta	(screen),y
	dey
simple4 lda	$1f00,x
	sta	(screen),y

	sta	wr_aux
	sta	rd_aux
	rts

stomp	ENDPROC

	SEG	vidtabs

st_bit	db	$00, $01, $03, $07, $0f, $1f, $3f, $7f
en_bit	db	$7f, $7e, $7c, $78, $70, $60, $40, $00

	END

