$CHIP(6502)
$TITLE(Spider Bot)
$PAGINATE
$INDENT=20
$ALLPUBLIC

**********************************************
*					     *
*	      State functions		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc

check	%MACRO	state
	bne	$+5
	jmp	state
	%ENDM

cstat	%MACRO	immed
	lda	#low(immed)
	sta	state
	lda	#high(immed)
	sta	state+1
	%ENDM

	EXTERN	stkval, go_on
	EXTERN	column,scan
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sp_xpos, sp_ypos, sp_colr, sp_poin
	EXTERN	droidc_l, droidc_lf, droidc_f, droidc_rf, droidc_r
	EXTERN	botc_l, botc_lf, botc_f, botc_rf, botc_r
	EXTERN	hero_x, hero_y

	EXTERN	dr_stand, dr_sq1, dr_sq2, dr_sq3
	EXTERN	dr_lean_l,dr_lean_r
	EXTERN	bot_squat1_l,bot_squat2_l,bot_squat1_r,bot_squat2_r
	EXTERN	bot_walk2,bot_walk3

	EXTERN	state(PAGE0),stat_i,counter,seq(PAGE0),img(PAGE0),facing
	EXTERN	invert_flag,invert,walk_pos

	EXTERN	CheckBackground,Sethero,Check_Next_Room
	EXTERN	bstat_i

	EXTERN	prmsec

;	EXTERN	PrintNum
	extern	sparks_gone_flag,trbck_i ,sparks_end
	extern	coin_ck 		     ;25-apr-88    RTU

	extern	  net_adjust_for_hero_movement

	 extern   drain_state_3

	 extern   tone

	extern	gate_room,gate_flag,current_room
	extern	bot_falling_flag,droid_falling_flag
	extern	spark_delay,spark_level,gate_flag
	extern	creature_number,gate_x,gate_on

	 extern   bot_walk_seq

	 extern   spark_delay_2
	extern	sparks_end_1

	PUBLIC	bfall_i

right_boundry_droid	equ	136
left_boundry_droid	equ	32

**********************************************

HeroDetectXOffsetLeft	equ	-5
HeroDetectXOffsetRight	equ	5
HeroDetectXOffsetCenter equ	0

HeroDetectXOffsetMoveLeft   equ     -1		;-2
HeroDetectXOffsetMoveRight  equ     -1		;0

HeroDetectYOffsetTop	equ	23
HeroDetectYOffsetBottom equ	0

HeroScreenEdgeLeft	equ	27+7	 ;(6+21)+7
HeroScreenEdgeRight	equ	154-6	 ;(123+21)-6
HeroScreenExitLeft	equ	22	 ;(0+21)
HeroScreenExitRight	equ	160	 ;(139+21)
HeroScreenEdgeTop	equ	3	 ;25
HeroScreenEdgeBottom	equ	165

DroidXMovement		equ	2
DroidFallYMovement	equ	4
BotFallYMovement	equ	4

**********************************************

	SEG	maincode

**************************************************************

lean_l_i PROC	 ;Handles the droid leaning left.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	cstat	lean_l		;Enter here to change to this state.

	lda	#low(leanseq)
	sta	seq
	lda	#high(leanseq)
	sta	seq+1
	ldy	#0
	jsr	sethero

lean_l				;Enter here on subsequent executions.

;	Check if there is anything blocking him to the left.
;	bne	..Blocked		;Go if we're blocked,
	jmp	dmove_l_i		; else start moving left.

..Blocked
	jmp	go_on

lean_l_i ENDPROC

	SEG	MAINDATA

leanseq
	dw	dr_lean_l
	dw	dr_lean_r

	SEG	MAINCODE

**************************************************************

lean_r_i PROC	 ;Handles the droid leaning right.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat	lean_r		;Enter here to change to this state.

	lda	#low(leanseq)
	sta	seq
	lda	#high(leanseq)
	sta	seq+1
	ldy	#2
	jsr	sethero

lean_r				;Enter here on subsequent executions.

;	Check if there is anything blocking him to the right.
;	bne	..Blocked		;Go if we're blocked,
	jmp	dmove_r_i		; else start moving right.

..Blocked
	jmp	go_on

lean_r_i ENDPROC


**************************************************************

dmove_l_i PROC	 ;Handles moving the droid left.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat dmove_l		;Enter here to change to this state.

dmove_l 			;Enter here on subsequent executions.
	 sta	  wr_main
	 lda	  #$00
	 sta	  net_adjust_for_hero_movement

	lda	stkval			;Check if they're still holding
	and	#$04			; the joystick left.
	bne	..JoystickStillLeft	;Go if yes,
	jmp	stat_i			; else go back to stationary.

..JoystickStillLeft
	lda	hero_x		;Check ahead of him to see
	clc			; if there's stuff in his way.
	adc	#HeroDetectXOffsetLeft
	sta	column

	lda	hero_y
	sec
	sbc	#9		;kam mod 5-9-88 (was 8)
	sta	scan
	 jsr	  coin_ck		     ;26-apr-88  RTU

	cmp	#$C0		;Is there a Borer wall there?
;************************************************ kam mod 5-9-88
	bne	..exitkammodleft1
	lda	hero_x
	cmp	#right_boundry_droid
	bcs	..exitkammodleft1
	jmp	..blocked
..exitkammodleft1
;************************************************ borer wall unstick check
;	 beq	 ..Blocked

	ldx	Hero_x
	cpx	#HeroScreenEdgeLeft  ;Is he near the edge of the screen?
	bcs	..NotBlocked	;Go if no.

	cmp	#$20		;Is there ANY object there?
	bne	..Blocked	;Go if yes.

	ldx	Hero_x
	cpx	#HeroScreenExitLeft  ;Is it time to exit this screen?
	bcs	..NotBlocked	;Go if no.

	ldy	#1
	jsr	check_next_room ;Check if we can switch rooms.

..Blocked
	cstat	lean_l_i	;He's blocked; revert to leaning status.
	jmp	go_on

..NotBlocked
	 sta	  wr_main
	 lda	#-DroidXMovement
	 sta	  net_adjust_for_hero_movement

	lda	hero_x		;Move the droid.
	sec
	sbc	#DroidXMovement
	sta	hero_x

	jsr	CheckUnderDroid
	cmp	#$20
	bne	..ThereIsGround ;Go if yes.

	jmp	dhang_l_i	;Else change to hanging status.

..ThereIsGround
	lda	#low(leanseq)	;Re-do the image at the new coords.
	sta	seq
	lda	#high(leanseq)
	sta	seq+1
	ldy	#0
	jsr	sethero

..End
	jmp	go_on

***********************************************

CheckUnderDroid
;
; A,X,Y,P - nothing passed
;
; A - coincidence check value returned (see CheckBackGround for ex-
;     planation of values returned)
;
; X,Y,P - scrambled
;

	lda	hero_x		;Put the coords of the point
	clc
	adc	#HeroDetectXOffsetMoveLeft
	sta	column		; underneath him into
	lda	hero_y		; (column, scan).
	sta	scan

	 jsr	  coin_ck		     ;26-apr-88  RTU
	cmp	#$20
	bne	..FoundGround	;Go if yes.

	lda	hero_x		;Put the coords of the point
	clc
	adc	#HeroDetectXOffsetMoveRight
	sta	column		; underneath him into
	lda	hero_y		; (column, scan).
	sta	scan

	 jsr	  coin_ck		     ;26-apr-88  RTU
..FoundGround
	rts

************************************************
;
; A,X,Y,P - nothing passed
;
; A - coincidence check value returned (see CheckBackGround for ex-
;     planation of values returned)
;
; X,Y,P - scrambled
;


CheckUnderBot
	lda	hero_x		;Put the coords of the point
	ldx	walk_pos	; underneath his left foot
	sec			; into (column, scan).
	sbc	BotLeftLegCheckOffset,x
	sta	column
	lda	hero_y
	sta	scan

	 jsr	  coin_ck		     ;26-apr-88  RTU
	cmp	#$20
	beq	..NoGround	;Go if no.

	lda	hero_x		;Put the coords of the point
	ldx	walk_pos	; underneath his right foot
	clc			; into (column, scan).
	adc	BotRightLegCheckOffset,x
	sta	column
	lda	hero_y
	sta	scan

	 jsr	  coin_ck		     ;26-apr-88  RTU
..NoGround
	rts


********************************************


	SEG	MAINDATA
BotLeftLegCheckOffset
	db	7,13,11,9

BotRightLegCheckOffset
	db	8,10,12,6


	SEG	MAINCODE

dmove_l_i ENDPROC


**************************************************************

dmove_r_i PROC			;Enter here to change to this state.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat dmove_r

dmove_r 			;Enter here on subsequent executions.
	 lda	  #$00
	 sta	  net_adjust_for_hero_movement


	lda	stkval			;Check if they're still holding
	and	#$08			; the joystick right.
	bne	..JoystickStillRight	;Go if yes,
	jmp	stat_i			; else go back to stationary.

..JoystickStillRight
	lda	hero_x		;Check ahead of him to see
	clc
	adc	#HeroDetectXOffsetRight
	sta	column		; if there's stuff in his way.

	lda	hero_y
	sec
	sbc	#9		;kam mod 5-9-88 (was 8)
	sta	scan
	 jsr	  coin_ck		     ;26-apr-88  RTU

	cmp	#$C0		;Is there a Borer wall there?
;************************************************ kam mod 5-9-88
	bne	..exitkammodright1
	lda	hero_x
	cmp	#left_boundry_droid
	bcc	..exitkammodright1
	jmp	..blocked
..exitkammodright1
;************************************************ borer wall unstick check
;	 beq	 ..Blocked

	ldx	Hero_x
	cpx	#HeroScreenEdgeRight  ;Is he near the edge of the screen?
	bcc	..NotBlocked	;Go if no.

	cmp	#$20		;Is there ANY object there?
	bne	..Blocked	;Go if yes.

	ldx	Hero_x
	cpx	#HeroScreenExitRight  ;Is it time to exit this screen?
	bcc	..NotBlocked	;Go if no.

	ldy	#0
	jsr	check_next_room ;Check if we can switch rooms.

..Blocked
	cstat	lean_r_i	;He's blocked; revert to leaning status.
	jmp	go_on

..NotBlocked
	 sta	  wr_main
	 lda	#DroidXMovement
	 sta	  net_adjust_for_hero_movement

	lda	hero_x		;Move the droid.
	clc
	adc	#DroidXMovement
	sta	hero_x

	jsr	CheckUnderDroid
	cmp	#$20
	bne	..ThereIsGround ;Go if yes.

	jmp	dhang_r_i	;Else change to hanging status.

..ThereIsGround
	lda	#low(leanseq)	;Re-do the image at the new coords.
	sta	seq
	lda	#high(leanseq)
	sta	seq+1
	ldy	#2
	jsr	sethero

..End
	jmp	go_on

dmove_r_i ENDPROC


**************************************************************

dhang_l_i PROC	;Handles the droid hanging left.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat dhang_l		;Enter here to change to this state.
	lda   #0
	sta   counter

	lda	#low(leanseq)	;Set up leaning RIGHT image of hero.
	sta	seq
	lda	#high(leanseq)
	sta	seq+1

dhang_l 			;Enter here on subsequent executions.
	inc	counter 	;Inc the frame counter.
	lda	counter
	cmp	#5		;Is this frame 5?
	beq	..frame5	;Go if yes.
	bcs	..frame6	;Go now if it's frame 6.

	dec	hero_x		;For frames 1-4, just move hero left.
	ldy	#2		;This is for the sethero routine.
	jmp	..End

..frame5
	lda	hero_y		;For frame 5, put him in the
	cmp	#$30
	bcc	..no_kickup_left
	sec			; fully crouched position and
	sbc	#6		; move him up 6 scan lines.
	sta	hero_y

..no_kickup_left
	lda	#low(crouchseq) ;Set up fully crouched image of hero.
	sta	seq
	lda	#high(crouchseq)
	sta	seq+1
	ldy	#6

	jmp	..End

..frame6
	jmp	dfall_i 	;For frame 6, start him falling.

..End
	jsr	sethero
	jmp	go_on

dhang_l_i ENDPROC

	SEG	MAINDATA

crouchseq
	dw	dr_stand
	dw	dr_sq1
	dw	dr_sq2
	dw	dr_sq3

	SEG	MAINCODE


**************************************************************

dhang_r_i PROC	;Handles the droid hanging right.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat dhang_r		;Enter here to change to this state.
	lda   #0
	sta   counter

	lda	#low(leanseq)	;Set up leaning LEFT image of hero.
	sta	seq
	lda	#high(leanseq)
	sta	seq+1

dhang_r 			;Enter here on subsequent executions.
	inc	counter 	;Inc the frame counter.
	lda	counter
	cmp	#5		;Is this frame 5?
	beq	..frame5	;Go if yes.
	bcs	..frame6	;Go now if it's frame 6.

	inc	hero_x		;For frames 1-4, just move hero right.
	ldy	#0		;This is for the sethero routine.
	jmp	..End

..frame5
	lda	hero_y		;For frame 5, put him in the
	cmp	#$30
	bcc	..no_kickup_right
	sec			; fully crouched position and
	sbc	#6		; move him up 6 scan lines.
	sta	hero_y

..no_kickup_right
	lda	#low(crouchseq) ;Set up fully crouched image of hero.
	sta	seq
	lda	#high(crouchseq)
	sta	seq+1
	ldy	#6

	jmp	..End

..frame6
	jmp	dfall_i 	;For frame 7, start him falling.

..End
	jsr	sethero
	jmp	go_on

dhang_r_i ENDPROC


**************************************************************

	SEG	TEMPS

FallingDistance ds	1

	SEG	MAINCODE


dfall_i PROC	;Handles the droid when falling.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat dfall		;Enter here to change to this state.
	ldx   #0
	stx   FallingDistance
	dex
	stx   droid_falling_flag

dfall				;Enter here on subsequent executions.
	 lda	FallingDistance
	 cmp	#$f8
	 bcs	  ..no_more_inc
	 clc
	 adc	#DroidFallYMovement
	 sta	FallingDistance
..no_more_inc

	lda	#DroidFallYMovement
	sta	counter

..FallAnotherScanline
	jsr	CheckUnderDroid
	cmp	#$20
	bne	..Ground      ;Go if yes.

	inc	hero_y
	lda	hero_y

	cmp	#HeroScreenEdgeBottom ;Is he near the bottom of the screen?
	bcc	..HesNotNearTheBottom	;Go if no.

	ldy	#2		;Check if he can fall into
	jsr	check_next_room ; the next room.

..HesNotNearTheBottom
	dec	counter
	bne	..FallAnotherScanline

..NoGround
	lda	#low(crouchseq) ;Set up crouching image of hero.
	sta	seq
	lda	#high(crouchseq)
	sta	seq+1
	ldy	#6
	jsr	sethero

	jmp	go_on

..Ground
	 lda	  fallingdistance
	 cmp	  #140
	 bcc	  ..no_drain
	 sta	  wr_main
	 lda	  #24
	 sta	  drain_state_3

	 ldx	  #$30
	 ldy	  #$20
	 long	  prmsec,tone
..no_drain



;  Use 'FallingDistance' to determine how much energy the fall used.

;****************** kam mod ************************* 5-9-88
	lda   #0
	sta	droid_falling_flag		;kam mod 5-17-88
	lda	sparks_gone_flag
	beq	..kamdfall1
	jmp	sparks_end		   ;sparks just ran out
..kamdfall1
;****************************************************



;	jmp	standup_i	;Goto standing up status.
	jmp	stat_i		;Goto stationary status for now.

dfall_i ENDPROC


**************************************************************

bfall_i PROC	;Handles the bot when falling.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat bfall		;Enter here to change to this state.
	dmovi	  seq,bot_walk_seq
	lda   #0
	sta   FallingDistance
	lda	#$0f
	sta	bot_falling_flag		;kam mod 5-17-88


	 jmp	  go_on

bfall				;Enter here on subsequent executions.
	inc	FallingDistance

	lda	#BotFallYMovement
	sta	counter

..FallAnotherScanline
	lda	invert_flag
	cmp	#invert
	beq	..FallUp
	inc	hero_y
	lda	hero_y

	cmp	#HeroScreenEdgeBottom ;Is he near the bottom of the screen?
	lbcc	..HesNotNearTheTopOrBottom   ;Go if no.

	ldy	#2		;Check if he can fall into
	jsr	check_next_room ; the next room.
	jmp	..HesNotNearTheTopOrBottom

..FallUp
;***************************************************************
	lda	#$ff
	sta	bot_falling_flag		;kam mod 5-17-88
	lda	gate_flag
	bne	..skipgatestuff
	ldy	hero_y				;red laser gate
	cpy	#$08
	bcs	..skipgatestuff
	ldy	creature_number
	cpy	#3
	beq	..skipgatestuff
	ldy	spark_level
	beq	..skipgatestuff
	ldy	#2
	sty	spark_delay
	dey
	sty	spark_level			;kam mod 5-17-88
	sty	spark_delay_2
..skipgatestuff

	dec	hero_y
	lda	hero_y


	ldx	gate_room			;kam mod 5-16-88
	bne	..skipthisstuff
	ldx	gate_x
	ldy	gate_on,x
	cpy	#$40
	beq	..skipthisstuff 		;this gate turned off
	ldx	gate_flag
	beq	..skipthisstuff
	ldx	current_room
	cpx	#$37
	bne	..funnylaserroom
	cmp	#08
	bcc	..changeypos
	bcs	..funnylaserroom+4
..funnylaserroom
	cmp	#16
	bcc	..changeypos
	cmp	#200
	bcs	..changeypos
	bcc	..skipthisstuff
..changeypos
	lda	#39
	sta	hero_y
	lda	#$e6
	sta	invert_flag
	lda	#$0f
	sta	bot_falling_flag
	jmp	..HesNotNearTheTopOrBottom
..skipthisstuff 				;kam mod 5-16-88


	cmp	#HeroScreenEdgeTop ;Is he near the bottom of the screen?
	bcs	..HesNotNearTheTopOrBottom   ;Go if no.

	ldy	#3		;Check if he can fall up into
	jsr	check_next_room ; the next room.
	jmp	..HesNotNearTheTopOrBottom


..HesNotNearTheTopOrBottom
	jsr	CheckUnderBot
	cmp	#$20
	bne	..Ground      ;Go if yes.

	dec	counter
	lbne	..FallAnotherScanline

..NoGround
	lda	walk_pos	;Set up the correct image.
	asl	a
	tay
	iny
	jsr	sethero

	jmp	go_on

..Ground


	ldx	bot_falling_flag
	lda	#0
	sta	bot_falling_flag		;kam mod 5-17-88
;****************** kam mod ************************* 5-3-88
	lda	sparks_gone_flag
	beq	..kambfall1
	cpx	#$ff
	lbeq	sparks_end_1
	jmp	trbck_i 		;sparks just ran out
..kambfall1
;****************************************************

	lda	walk_pos	;Set up the correct image.
	asl	a
	tay
	iny
	jsr	sethero

	lda	FallingDistance ;Did he fall more than one
	cmp	#2		; group of scan lines?
	bcc	..DontBounce	;Go if no.
	jmp	bbounce_i	;Goto bounce status.

..DontBounce
	jmp	bstat_i 	;Goto stationary status.

bfall_i ENDPROC


**************************************************************

bbounce_i	proc		;Handle the Bot bouncing.
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	cstat	bbounce
	lda	#-2			;Set up the counter.
	sta	counter

	lda	 walk_pos		;Figure out if this is
	cmp	 #$02			; a 'Left' bounce or
	beq	 ..set_bounce_l 	; a 'Right' bounce,

	dmovi	 seq,..bounce_r_seq	; and set up the correct
	jmp	 bbounce		; sequence of images.

..set_bounce_l
	dmovi	 seq,..bounce_l_seq

bbounce
	inc	counter 		;Goto the next image.
	inc	counter
	ldy	counter 		;Get image # into Y.
	cpy	#8			;Are we done bouncing?
	bcs	..End			;Go if yes.
	iny
	jsr	sethero 		; else set hero image
	jmp	go_on			; and go on.

..End
	 jmp	  bstat_i		;Go to stationary status.


	 seg	  maindata
..bounce_l_seq
	db	4
	dw	 bot_squat1_l
	dw	 bot_squat2_l
	dw	 bot_squat1_l
	dw	 bot_walk3

..bounce_r_seq
	db	4
	dw	 bot_squat1_r
	dw	 bot_squat2_r
	dw	 bot_squat1_r
	dw	 bot_walk2

bbounce_i     endproc


**************************************************************

	END

