$CHIP(6502)
$TITLE(Spider Bot)
$PAGINATE
$INDENT=20
$ALLPUBLIC


cstat	%MACRO	immed
	lda	#low(immed)
	sta	state
	lda	#high(immed)
	sta	state+1
	%ENDM

**********************************************
*					     *
*	      State functions		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc
	%include zpext.inc

	EXTERN	stkval, go_on
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sp_xpos, sp_ypos, sp_colr, sp_poin, sp_flag
	EXTERN	droidc_l, droidc_lf, droidc_f, droidc_rf, droidc_r
	EXTERN	botc_l, botc_lf, botc_f, botc_rf, botc_r
	EXTERN	hero_x, hero_y,spr_10, spr_11, spr_12
	EXTERN	dr_stand, dr_sq1, dr_sq2, dr_sq3
	extern	state(PAGE0), seq(PAGE0), img(PAGE0), facing
	extern	sethero,stat_i,check_next_room,column,scan
	extern	checkbackground,dfall_i,trans_i,impseq,sp_ypos
	extern	game_start
	extern	bot_walk1,bot_walk_seq,walk_pos
	extern	bot_squat1_l,bot_squat2_l
	extern	bot_squat1_r,bot_squat2_r
	extern	bstat_i,panel_i,invert,bfall_i
	extern	  beastie_flag,spr_9,invert_flag
	 extern   coin_ck
	EXTERN	prmsec						;23-Apr-88  HES
	extern	jump_height_flag				;kam 5-9-88

	 extern   boltphase,netphase

	 extern   click,tone,noise

	extern	gate_room,gate_flag,hero_y,gate_x,gate_x_table
	extern	gate_on,hero_x


left_boundry_bot	equ	32
right_boundry_bot	equ	136

	seg	 maincode


*************************************
*				    *
*				    *
*     droid crouch animation	    *
*				    *
*				    *
*************************************


crouch_p proc
;
; animate droid "crouching"
;
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 seg	  statvars
..crouch_count	  ds	   1
..crouch_frame	  ds	   1
..jump_delay	  ds	   1


	 seg	  maincode

crouch_i
	 cstat	  crouch		     ;set state=crouch
	 dmovi	  seq,crouch_seq	     ;seq sequence = crouch

	 lda	  ..crouch_timing	     ;set count for correct...
	 sta	  ..crouch_count	     ;..."tempo"

	 ldy	  #$00			     ;init frame count
	 sty	  ..crouch_frame

	 iny
	 jsr	  sethero		     ;display initial frame

	lda	#2		;<<<<---- kam mod 5-9-88
	sta	jump_height_flag

	 jmp	  go_on

crouch
	 dec	  ..crouch_count	     ;dec "tempo" count
	 beq	  ..check_next_frame	     ;if 0 then next frame

	 lda	  ..crouch_frame	     ;index to current frame
	 asl	  a
	 tay
	 iny				     ;inc past nent
	 jsr	  sethero		     ;display current frame
	 jmp	  go_on

..check_next_frame
	 inc	  ..crouch_frame	     ;next frame
	 ldy	  ..crouch_frame
	 cpy	  crouch_seq
	 bne	  ..good_next_frame

	 lda	  #$05
	 sta	  ..jump_delay
	 cstat	  ..crouched_down
	 ldy	  #$05			     ;point to last frame
	 jsr	  sethero
	 jmp	  go_on

..good_next_frame
	 lda	  ..crouch_timing,y	     ;set new "tempo"
	 sta	  ..crouch_count

	 tya				     ;point to next frame
	 asl	  a
	 tay
	 iny
	 jsr	  sethero		     ;display him
	 jmp	  go_on


..crouched_down
	ldx	jump_height_flag
	bmi	..kamjumphigh
	dex
	stx	jump_height_flag
..kamjumphigh
	 lda	  stkval		     ;stay in crouched if stick
	 and	  #$02			     ;is down
	 bne	  ..no_change

	 cstat	  ..jump_wait
	 jmp	  ..no_change

..jump_wait
	 dec	  ..jump_delay
	 bne	  ..ck_jmp
	 jmp	  dr_standup_i

..ck_jmp
	 lda	  stkval
	 and	  #$01
	 bne	  ..do_jump

..no_change
	 lda	  #$c0
	 bit	  stkval
	 beq	  ..nopanel

	 bit	  boltphase
	 lbpl	  ..nopanel
	 bit	  netphase
	 lbpl	  ..nopanel

	 jmp	  panel_i

..nopanel
	 ldy	  #$05
	 jsr	  sethero

	 jmp	  go_on

..do_jump
	 jmp	  dr_begjmp_i


	 seg	  seqdata

crouch_seq
	 db	  3
	 dw	  dr_sq1
	 dw	  dr_sq2
	 dw	  dr_sq3

..crouch_timing
	 db	  1,2,3

crouch_p endproc


*************************************
*				    *
*				    *
*    droid stand-up animation	    *
*				    *
*				    *
*************************************


dr_standup	  proc
;
; animate droid "standing up"
;
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	 seg	  statvars
..standup_frame   ds	   1


	 seg	  maincode

dr_standup_i
	 cstat	  ..standup
	 dmovi	  seq,..standup_seq

	 ldy	  #$00
	 sty	  ..standup_frame

	 iny
	 jsr	  sethero
	 jmp	  go_on

..standup
	 inc	  ..standup_frame
	 lda	  ..standup_frame
	 cmp	  ..standup_seq
	 bne	  ..next_frame

	 jmp	  stat_i

..next_frame
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 jmp	  go_on


	 seg	  seqdata

..standup_seq
	 db	  2
	 dw	  dr_sq2
	 dw	  dr_sq1

dr_standup	  endproc


*************************************
*				    *
*				    *
*	 droid begin jump	    *
*				    *
*				    *
*************************************


dr_begjmp	  proc
;
; animate droid during beginning jump
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	 seg	  statvars
..bj_count	  ds	   1
..bj_frame	  ds	   1

	 seg	  maincode

dr_begjmp_i
	 cstat	  dr_bj
	 dmovi	  seq,..bj_seq

	 lda	  ..bj_timing
	 sta	  ..bj_count

	 ldy	  #$00
	 sty	  ..bj_frame

	 iny
	 jsr	  sethero

	 jmp	  go_on

dr_bj
	 dec	  ..bj_count
	 beq	  ..check_next_frame

	 lda	  ..bj_frame
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 jmp	  go_on

..check_next_frame
	 inc	  ..bj_frame
	 ldy	  ..bj_frame
	 cpy	  ..bj_seq
	 beq	  ..do_jump_logic

	 lda	  ..bj_timing,y
	 sta	  ..bj_count

	 tya
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 jmp	  go_on


..do_jump_logic
	 lda	  hero_y
head_ck1
	 cmp	  #$3c
	 bcs	  ..do_jump

	 jsr	  ck_tos
	 beq	  $+5
	 jmp	  dr_jmpx_i

..do_jump
	lda	#23			;<<<<<----- kam mod 5-9-88
	sta	..kammod1+1
	lda	jump_height_flag
	bmi	..kamjumphigh
	lda	#17
	sta	..kammod1+1
..kamjumphigh
	  lda	   hero_y
	  sec
..kammod1 sbc	   #23			 ;<<<<<<---- SELF MOD
	  sta	   hero_y

	 lda	  beastie_flag
	 and	  #$01
	 beq	  ..no_stinger
	 jmp	  dr_jmphigh_i

..no_stinger
	 jmp	  dr_jmpfini_i


	 seg	  seqdata
..bj_seq
	 db	  4
	 dw	  dr_sq2
	 dw	  dr_sq1
	 dw	  dr_stand
	 dw	  dr_sq3

..bj_timing
	 db	  2,1,2,1


dr_begjmp	  endproc


*************************************
*				    *
*				    *
*	 droid jump apex	    *
*				    *
*				    *
*************************************


dr_jmpapex	  proc
;
; handle droid logic for jump apex
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	 seg	  maincode

dr_jmpx_i
	 cstat	  ..dr_jmpapex
	 dmovi	  seq,dr_jmpapex_seq

	 ldy	  #$01
	 jsr	  sethero
	 jmp	  go_on

..dr_jmpapex
	 lda	  beastie_flag
	 and	  #$03
	 lbeq	  ..no_head_bug

	 sta	  rd_aux

	 lda	  spr_9
	 clc
	 adc	  #$05
	 sta	  column

	 lda	  spr_9+1
	 clc
	 adc	  #$06
	 sta	  scan

	 sta	  rd_main

	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..leave_him

	 lda	  scan
	 clc
	 adc	  #$04
	 sta	  scan

	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..leave_him


	 lda	  beastie_flag
	 and	  #$02
	 bne	  ..no_head_bug

..leave_him
;*******************************************************
	lda	gate_room		;kam mod 5-17-88
	bne	..exit
	lda	gate_flag
   beq	    ..exit
   lda	    beastie_flag
	and	#2
   beq	    ..exit
   lda	    hero_y
	cmp	#64
	bcs	..exit
	lda	gate_x
   asl	    a
   tax
	lda	gate_x_table,x
	jsr	..kamroutine
	bcs	..second
	ldx	gate_x
	lda	gate_on,x
	and	#$bf
   beq	    ..exit
	lda	#5
	sta	gate_on,x			;turn off laser gate
	bne	..exit
..second
	lda	gate_x_table+1,x
	jsr	..kamroutine
	bcs	..exit
	ldx	gate_x
	lda	gate_on,x
	and	#$bf
   beq	    ..exit
	lda	#5
	sta	gate_on,x
	bne	..exit
..kamroutine
    sec
	sbc	hero_x
	bpl	..skip1
	eor	#$ff
..skip1
	cmp	#$5
	rts				;kam mod 5-17-88
..exit
;*******************************************************
	 lda	  beastie_flag
	 and	  #$fc
	 sta	  beastie_flag

..no_head_bug
	 jmp	  dfall_i

	 seg	  seqdata
dr_jmpapex_seq
	 db	  1
	 dw	  dr_sq3

dr_jmpapex	  endproc



*************************************
*				    *
*				    *
*	 droid jump finish	    *
*				    *
*				    *
*************************************



dr_jmpfini	  proc
;
; logic for handling droid for finishing his jump
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	 seg	  statvars
..jmpfini_count   ds	   1


	 seg	  maincode

dr_jmpfini_i
	 cstat	  ..jmpfini
	 dmovi	  seq,dr_jmpapex_seq


	 lda	  ..num_frames
	 sta	  ..jmpfini_count

	 ldy	  #$01
	 jsr	  sethero

..jmpfini
	 dec	  ..jmpfini_count
	 bmi	  ..finidone

	 lda	  hero_y
	 bpl	  ..not_off_screen
	 cmp	  #196
	 bcc	  ..not_off_screen

	 ldy	  #$03
	 jsr	  check_next_room
	 beq	  ..bad_room
	 inc	  ..jmpfini_count
	 jmp	  go_on

..not_off_screen
head_ck2
	 lda	  beastie_flag
	 and	  #$01
	 beq	  ..normal_tos_ck
	 lda	  #$40
	 sta	  ..smc00+1
	 bne	  ..check_the_stuff
..normal_tos_ck
	 lda	  #$3c
	 sta	  ..smc00+1

..check_the_stuff
	 lda	  hero_y
..smc00  cmp	  #$40
	 bcs	  ..not_near_top

	 jsr	  ck_tos
	 bne	  ..head_hit

	 lda	  hero_y

..not_near_top
	 ldx	  ..jmpfini_count
	 sec
	 sbc	  ..delta_y,x
	 sta	  hero_y



	ldx	gate_room		;kam mod 5-16-88
	bne	..skipthisstuff
	ldx	gate_flag
	beq	..skipthisstuff
	ldx	gate_x
	ldy	gate_on,x
	cpy	#$40
	beq	..skipthisstuff
	cmp	#46
	bcc	..changeypos
	cmp	#200
	bcs	..changeypos
	bcc	..skipthisstuff
..changeypos
	lda	#46
    sta      hero_y
	jmp	..head_hit		;kam mod 5-16-88
..skipthisstuff




	 ldy	  #$01
	 jsr	  sethero
	 jmp	  go_on

..bad_room

..head_hit

..finidone
	 jmp	  dr_jmpx_i


	 seg	  seqdata

..num_frames	  db	   9
..delta_y
	 db	  0,1,2,3,3,5,7,8,13

dr_jmpfini	  endproc




*************************************
*				    *
*				    *
*	 droid high jump	    *
*				    *
*				    *
*************************************



dr_jmphigh	  proc
;
; logic for handling droid during "high" jump (jump with stinger on
; his head)
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	 seg	  statvars
..jmphigh_count   ds	   1


	 seg	  maincode

dr_jmphigh_i
	 cstat	  ..jmphigh
	 dmovi	  seq,dr_jmpapex_seq


	 lda	  #12
	 sta	  ..jmphigh_count

	 ldy	  #$01
	 jsr	  sethero
	 jmp	  go_on

..jmphigh
	 dec	  ..jmphigh_count
	 bmi	  ..highdone

	 lda	  hero_y

	ldx	gate_room		;kam mod 5-16-88
	bne	..skipthisstuff
	ldx	gate_flag
	beq	..skipthisstuff
	ldx	gate_x
	ldy	gate_on,x
	cpy	#$40
	beq	..skipthisstuff 	  ;gate off
	cmp	#46
	bcc	..changeypos
	cmp	#200
	bcs	..changeypos
	bcc	..skipthisstuff
..changeypos
	lda	#46
    sta      hero_y
	jmp	dr_jmpx_i		;kam mod 5-16-88
..skipthisstuff

	 cmp	  #low (-23)		     ;
	 bcc	  ..not_off_screen

	 ldy	  #$03
	 jsr	  check_next_room
	 beq	  ..bad_room
	 inc	  ..jmphigh_count
	 jmp	  go_on

..not_off_screen
head_ck3
	 cmp	  #$58
	 bcs	  ..not_near_top

	 jsr	  ck_tos
	 bne	  ..head_hit

	 lda	  hero_y

..not_near_top
	 sec
	 sbc	  #$13
	 sta	  hero_y
	 ldy	  #$01
	 jsr	  sethero
	 jmp	  go_on

..bad_room

..head_hit

..highdone
	 jmp	  dr_jmpfini_i

dr_jmphigh	  endproc









ck_tos	 proc
;
; check spots at the top of the screen above the droids position and
; return the coincidence check code to the caller (in "A"). See
; "CheckBackGround" for detailed information concerning the signif-
; icance of the values returned to the caller from it.
;
; A,X,Y,P - nothing passed
;
; X,Y,P - scrambled
;


	 lda	  hero_x
	 sec
	 sbc	  #$04
	 sta	  column
	 lda	  #$07
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..hithead

	 lda	  hero_x
	 clc
	 adc	  #$02
	 sta	  column
	 lda	  #$07
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..hithead

	 lda	  hero_x
	 sec
	 sbc	  #$04
	 sta	  column
	 lda	  #$0b
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..hithead

	 lda	  hero_x
	 clc
	 adc	  #$02
	 sta	  column
	 lda	  #$0b
	 sta	  scan
	 jsr	  coin_ck
	 cmp	  #$20
	 beq	  ..no_impact

..hithead
	 rts

..no_impact
	 lda	  #$00
	 rts

ck_tos	 endproc

********************************************************

die_p	 proc
;
; logic for animation of the droid dieing
;
; A,X,Y,P - nothing passed
;
; X,Y,P - scrambled
;


	 seg	  statvars
..die_count
	 ds	  1

	 seg	  maincode

die_i

	 cstat	  die
	 dmovi	  seq,impseq

	 lda	  #$00
	 sta	  ..die_count

	 ldy	  #$01
	 jsr	  sethero

	 jmp	  go_on

die
	 inc	  ..die_count
	 lda	  ..die_count
	 cmp	  #16
	 bcc	  $+5
	 jmp	  game_start

	 asl	  a
	 asl	  a
	 asl	  a
	 tay
	 ldx	  #$20
	 long	  prmsec,noise


	 sta	  rd_aux
	 sta	  wr_aux

	 lda	  spr_10+1
	 cmp	  #193+21-$10
	 bcc	  ..ok1
	 lda	  #$00
	 sta	  spr_10+3
	 beq	  ..next1
..ok1
	 sec
	 sbc	  #$10
	 sta	  spr_10+1

..next1
	 lda	  spr_11+1
	 cmp	  #193+21-$10
	 bcc	  ..ok2
	 lda	  #$00
	 sta	  spr_11+3
	 beq	  ..next2
..ok2
	 sec
	 sbc	  #$10
	 sta	  spr_11+1

..next2
	 lda	  spr_12+1
	 cmp	  #193+21-$10
	 bcc	  ..ok3
	 lda	  #$00
	 sta	  spr_12+3
	 beq	  ..done
..ok3
	 sec
	 sbc	  #$10
	 sta	  spr_12+1

..done
	 sta	  rd_main
	 sta	  wr_main

	 jmp	  go_on

die_p	 endproc



****************************
*			   *
*			   *
*      bot walking	   *
*			   *
*			   *
****************************

bot_walk_l_i	  proc
;
; A,X,Y,P - nothing passed
;
; X,Y,P - scrambled
;


	 cstat	  bot_walk_left
	 dmovi	  seq,bot_walk_seq

	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 jmp	  go_on

bot_walk_left
	 lda	  stkval
	 and	  #$0f
	 bne	  ..ck_walk
	 jmp	  bstat_i

..ck_walk
	 lda	  hero_x
	 cmp	  #28			;HES  (was 20).
	 bcs	  ..no_edge

**************** This is a HES patch. ****************

	 lda	  hero_x	;HES patch.
	 sec
	 sbc	  #$07
	 sta	  column

	 lda	  hero_y
	 ldx	  invert_flag
	 cpx	  #invert
	 beq	  ..addhes

	 sec
	 sbc	  #$09			;kam mod 5-9-88  (was 8)
	 sta	  scan
	 jmp	  ..set_scanhes

..addhes
	 clc
	 adc	  #$09			;kam mod 5-9-88  (was 8)

..set_scanhes
	 sta	  scan

;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$20
	 lbne	  ..exit		     ;blocked

	 lda	  hero_x
	 cmp	  #20
	 bcs	  ..no_edge

****************   End of HES patch.  ****************

	 ldy	  #$01
	 jsr	  check_next_room
	 lbeq	  ..exit

..no_edge
	 lda	  walk_pos
	 bne	  ..ck_trailing_foot

	 lda	  hero_x
	 sec
	 sbc	  #15	   ;12
	 sta	  column
	 jmp	  ..do_coincidence_ck

..ck_trailing_foot
	 cmp	  #$02
	 bne	  ..ck_borer_wall

	 lda	  hero_x
	 clc
	 adc	  #04	   ;09
	 sta	  column

..do_coincidence_ck
	 lda	  hero_y
	 sta	  scan
;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..ck_borer_wall

	 jsr	  hop_check		     ;set jump_flag
	 jmp	  ..move_him

..ck_borer_wall
	 lda	  hero_x
	 sec
	 sbc	  #$07
	 sta	  column

	 lda	  hero_y
	 ldx	  invert_flag
	 cpx	  #invert
	 beq	  ..add

	 sec
	 sbc	  #$08
	 sta	  scan
	 jmp	  ..set_scan

..add
	 clc
	 adc	  #$08

..set_scan
	 sta	  scan

;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$c0
;************************************************ kam mod 5-9-88
	bne	..exitkammodleft1
	lda	hero_x
	cmp	#right_boundry_bot
	bcs	..exitkammodleft1
	jmp	..exit
..exitkammodleft1
;************************************************ borer wall unstick check
;	  beq	   ..exit		      ;blocked


	 lda	  #$00
	 sta	  jump_flag

..move_him
	 inc	  walk_pos
	 lda	  walk_pos
	 cmp	  #$04
	 bcc	  ..nowrap
	 lda	  #$00
	 sta	  walk_pos

..nowrap
	 lda	  hero_x
	 sec
	 sbc	  #$02
	 sta	  hero_x


	 lda	  #$c0
	 bit	  jump_flag
	 beq	  ..exit

	 php
	 lda	  facing
	 beq	  ..setwideleft

	 lda	  #$01
	 bne	  ..setwide

..setwideleft
	 lda	  #$02

..setwide
	 sta	  walk_pos

	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 plp
	 bpl	  ..ck_fall

	 jmp	  bot_jump_i

..ck_fall
	 bvc	  ..exit
	 jmp	  bfall_i		     ;shoudl be fall_i


..exit
	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 jmp	  go_on

bot_walk_l_i	  endproc


	 seg	  statvars
jump_flag	  ds	   1

	 seg	  maincode



bot_walk_r_i	  proc

	 cstat	  bot_walk_right
	 dmovi	  seq,bot_walk_seq

	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 jmp	  go_on

bot_walk_right
	 lda	  stkval
	 and	  #$0f
	 bne	  ..ck_walk
	 jmp	  bstat_i

..ck_walk
	 lda	  hero_x
	 cmp	  #156			;HES (was 164)
	 bcc	  ..no_edge

**************** This is a HES patch. ****************

	 lda	  hero_x	;HES patch.
	 clc
	 adc	  #$05
	 sta	  column

	 lda	  hero_y
	 ldx	  invert_flag
	 cpx	  #invert
	 beq	  ..addhes

	 sec

	 sbc	  #$09			;kam mod 5-9-88  (was 8)
	 sta	  scan
	 jmp	  ..set_scanhes

..addhes
	 clc
	 adc	  #$09			;kam mod 5-9-88  (was 8)

..set_scanhes
	 sta	  scan

;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$20
	 lbne	  ..exit		     ;blocked

	 lda	  hero_x
	 cmp	  #164
	 bcc	  ..no_edge

****************   End of HES patch.  ****************

	 ldy	  #$00
	 jsr	  check_next_room
	 lbeq	  ..exit

..no_edge
	 lda	  walk_pos
	 cmp	  #$03
	 bne	  ..ck_trailing_foot

	 lda	  hero_x
	 clc
	 adc	  #14	   ;12
	 sta	  column
	 jmp	  ..do_coincidence_ck

..ck_trailing_foot
	 cmp	  #$01
	 bne	  ..ck_borer_wall

	 lda	  hero_x
	 sec
	 sbc	  #05	   ;09
	 sta	  column

..do_coincidence_ck
	 lda	  hero_y
	 sta	  scan
;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$20
	 bne	  ..ck_borer_wall

	 jsr	  hop_check		     ;set jump_flag
	 jmp	  ..move_him

..ck_borer_wall
	 lda	  hero_x
	 clc
	 adc	  #$05
	 sta	  column

	 lda	  hero_y
	 ldx	  invert_flag
	 cpx	  #invert
	 beq	  ..add

	 sec
	 sbc	  #$08
	 jmp	  ..set_scan

..add
	 clc
	 adc	  #$08

..set_scan
	 sta	  scan

;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck
	 cmp	  #$c0
;************************************************ kam mod 5-9-88
	bne	..exitkammodright1
	lda	hero_x
	cmp	#left_boundry_bot
	bcc	..exitkammodright1
	jmp	..exit
..exitkammodright1
;************************************************ borer wall unstick check
;	  beq	   ..exit		      ;blocked

	 lda	  #$00
	 sta	  jump_flag

..move_him
	 dec	  walk_pos
	 bpl	  ..nowrap
	 lda	  #$03
	 sta	  walk_pos

..nowrap
	 lda	  hero_x
	 clc
	 adc	  #$02
	 sta	  hero_x



	 lda	  #$c0
	 bit	  jump_flag
	 beq	  ..exit

	 php
	 lda	  facing
	 beq	  ..setwideleft

	 lda	  #$01
	 bne	  ..setwide

..setwideleft
	 lda	  #$02

..setwide
	 sta	  walk_pos

	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 plp
	 bpl	  ..ck_fall

	 jmp	  bot_jump_i

..ck_fall
	 bvc	  ..exit
	 jmp	  bfall_i		     ;should be fall_i


..exit
	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 jmp	  go_on

bot_walk_r_i	  endproc






hop_check	  proc

	 ldx	  #$01
..level_lp
	 txa
	 pha

	 cpx	  #$00
	 beq	  ..upper

	 lda	  hero_y
	 clc
	 adc	  #$08
	 sta	  temp2
	 jmp	  ..setup

..upper
	 lda	  hero_y
	 sec
	 sbc	  #$08
	 sta	  temp2

..setup
	 lda	  facing
	 bne	  ..set_ck_right

	 lda	  hero_x
	 sec
	 sbc	  #15
	 sta	  temp1
	 sta	  column
	 jmp	  ..pl_setup

..set_ck_right
	 lda	  hero_x
	 clc
	 adc	  #14
	 sta	  column
	 sta	  temp1

..pl_setup
	 ldy	  #14
..pixel_lp
	 tya
	 pha

	 sta	  tdbl1

	 ldy	  facing
	 beq	  ..ck_left

	 clc
	 adc	  temp1
	 jmp	  ..set_column

..ck_left
	 lda	  temp1
	 sec
	 sbc	  tdbl1

..set_column
	 sta	  column
	 lda	  temp2

	 cmp	  #168
	 bcc	  ..its_on_screen
	 lda	  #$20
	 bne	  ..after_check

..its_on_screen
	 sta	  scan
;	 long	  prmsec,CheckBackground       ;23-Apr-88  HES
	 jsr	  coin_ck

..after_check
	 cmp	  #$20
	 beq	  ..keep_checking

	 pla
	 pla
	 jmp	  ..no_jump

..keep_checking
	 pla
	 tay
	 dey
	 dey
	 dey
	 bpl	  ..pixel_lp

	 pla
	 tax
	 dex
	 bpl	  ..level_lp

	 lda	  #$80
	 sta	  jump_flag
	 bmi	  ..exit

..no_jump
	 lda	  #$40
	 sta	  jump_flag
	 bpl	  ..exit

..no_problem
	 lda	  #$00
	 sta	  jump_flag

..exit
	 rts

hop_check	  endproc










****************************
*			   *
*			   *
*      bot squating	   *
*			   *
*			   *
****************************




bot_squat_i	  proc
;
; A,X,Y,P - nothing passed
;
; X,Y,P - scrambled
;

	 lda	  walk_pos
	 cmp	  #$02
	 beq	  ..set_squat_l

	 dmovi	  seq,..bot_sq_r_seq
	 jmp	  ..finish_squat_init

..set_squat_l
	 dmovi	  seq,..bot_sq_l_seq

..finish_squat_init
	 cstat	  bot_squat
	 ldy	  #$01
	 sty	  squat_pos
	 jsr	  sethero
	 jmp	  go_on

bot_squat
	 ldy	  #$03
	 jsr	  sethero

	 jmp	  bstat_i		     ;should be sq_stat_i




	 seg	  seqdata
squat_pos	  ds	   1

..bot_sq_l_seq
	 db	  2
	 dw	  bot_squat1_l
	 dw	  bot_squat2_l

..bot_sq_r_seq
	 db	  2
	 dw	  bot_squat1_r
	 dw	  bot_squat2_r







	 seg	  maincode

bot_squat_i	  endproc


bot_standup_i	  proc
;
; A,X,Y,P - nothing passed
;
; X,Y,P - scrambled
;

	 cstat	  ..bot_standup
	 ldy	  #$01
	 jsr	  sethero
	 jmp	  go_on

..bot_standup
	 dmovi	  seq,bot_walk_seq
	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero
	 lda	  #$00
	 sta	  squat_pos
	 jmp	  bstat_i

bot_standup_i	  endproc




****************************
*			   *
*			   *
*      bot jumping	   *
*			   *
*			   *
****************************



bot_jump_i	  proc
	 cstat	  ..bot_jump
	 lda	  #$06
	 sta	  ..jmp_count
	 lda	  #$01
	 sta	  ..jmp_slow

..bot_jump
	 dec	  ..jmp_slow
	 bpl	  ..exit

	 lda	  #$01
	 sta	  ..jmp_slow

	 dec	  ..jmp_count
	 bpl	  ..do_more

	 jmp	  bfall_i

..do_more
	 ldx	  ..jmp_count
	 lda	  ..jmp_delta_y,x
	 sta	  temp1

	 lda	  invert_flag
	 cmp	  #invert
	 bne	  ..rightside_up

	 lda	  hero_y
	 sec
	 sbc	  temp1
	 sta	  hero_y
	 jmp	  ..adjust_x

..rightside_up
	 lda	  hero_y
	 clc
	 adc	  temp1
	 sta	  hero_y

..adjust_x
	 lda	  facing
	 bne	  ..going_right

	 lda	  hero_x
	 sec
	 sbc	  #$04
	 sta	  hero_x
	 jmp	  ..exit

..going_right
	 lda	  hero_x
	 clc
	 adc	  #$04
	 sta	  hero_x

..exit
	 lda	  walk_pos
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 jmp	  go_on



	 seg	  statvars
..jmp_count	  ds	   1
..jmp_slow	  ds	   1

	 seg	  seqdata
..jmp_delta_y
	 db	  4,4,4,-4,-4,-4

	 seg	  maincode

bot_jump_i	  endproc


	END
