$CHIP(6502)
$TITLE(Spider Bot)
$PAGINATE
$INDENT=20
$ALLPUBLIC

**********************************************
*					     *
*	      State functions		     *
*					     *
**********************************************

	%include macro.inc
	%include prmseg.inc
	%include zpext.asm

cstat	%MACRO	immed
	lda	#low(immed)
	sta	state
	lda	#high(immed)
	sta	state+1
	%ENDM

	EXTERN	stkval, go_on
	EXTERN	rd_aux, wr_aux, rd_main, wr_main
	EXTERN	sp_xpos, sp_ypos, sp_colr, sp_poin
	EXTERN	droidc_l, droidc_lf, droidc_f, droidc_rf, droidc_r
	EXTERN	botc_l, botc_lf, botc_f, botc_rf, botc_r
	EXTERN	trans1, trans2, trans3, trans4, trans5, trans6
	EXTERN	spr_1,spr_2,spr_3,spr_4,spr_5,spr_6,spr_7
	EXTERN	spr_8,spr_9,spr_10,spr_11,spr_12,spr_13
	EXTERN	dr_stand, dr_sq1, dr_sq2, dr_sq3
	EXTERN	dr_standup_i, die_i, hero_x,hero_y
	EXTERN	lean_l_i, lean_r_i, crouch_i
	EXTERN	xform1a_l, xform2a_l, xform3a_l, xform4_l, xform5_l
	EXTERN	xform1a_r, xform2a_r, xform3a_r, xform4_r, xform5_r
	EXTERN	bot_squat1_l, bot_squat2_l, bot_squat1_r, bot_squat2_r
	EXTERN	bot_walk1, bot_walk2, bot_walk3, bot_walk4
	extern	bot_walk_l_i,bot_walk_r_i,bot_squat_i,squat_pos
	extern	bot_standup_i,crouch_seq,speaker,stick,invert_flag
	extern	norm,invert,null,sp_flag,bfall_i,dfall_i
	extern	checkunderdroid,checkunderbot
	extern	  manowar1,manowar2,manowar3,manowar4
	extern	  stinger1,stinger2,stinger3,stinger4
	extern	hopper_x,hopper_y,hopper_frame,hopfrnt1,hopfrnt2
	extern	init_hopper_sprite
	extern	borer_x,borer_y,borer_frame,borer_seq,borer_facing
	extern	  display,page1,workon,erasp,draw,prmsec
	extern	  sarrow,bar

	EXTERN	Headflag,Facing 				;23-Apr-88  HES
	EXTERN	Panel2,SetRoom_C,Spr_1		   ;23-Apr-88  HES
	extern	onevaluememorywrite,table_onevaluememorywrite	;kam 4-27-88
	extern	sparks_gone_flag,sparks_end_2,creature_number	  ;kam 5-3-88
	extern	spark_display,clock_flag,call_sprite_routine

	 extern   call_the_sprite_routine,creature_flag
	 extern   panel1,clrscreenedges,panelcopy
	extern	impatient,energy_level,transform_energy,end_game

	 extern   beastie_flag

	 extern   boltphase

	 extern   net_adjust_for_hero_movement

	 extern   netphase
	%include colorext.inc

	 extern   headlo,headhi,impdat,manowar_seq,stinger_seq

	 extern   last_seq_index

	PUBLIC	state, stat_i, trans_i	;, facing	       ;23-Apr-88  HES
	public	walk_pos

	SEG	zpglobal

	double	state
	double	seq
	double	img

;	single	facing						;23-Apr-88  HES
;	single	headflag					;23-Apr-88  HES

	SEG	statvars

	single	counter
	single	savface
	single	waste

**********************************************

	SEG	maincode

stat_i	PROC
;
; droid "static" (motionless) state logic
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	sta	rd_main
	sta	wr_main

	 lda	  #$00
	 sta	  net_adjust_for_hero_movement

	lda	  panel_flag
	bpl	  ..normal
	jmp	  (state)

..normal
	cstat	stat
	move	counter,#0
	dmovi	seq,impseq
	ldy	#1
	call	sethero

stat	inc	counter
	lbeq	imp_i

	lda	stkval
	bit	left
	lbne	turnl_i
	bit	right
	lbne	turnr_i
	bit	down
	lbne	crouch_i

	bit	up		;HES patch to stop the
	bne	..no_imp	; droid from getting

	bit	stkval
	bvs	..no_imp
	bpl	..label1

..no_imp
	ldx	#0		; impatient when you're
	stx	counter 	; pressing the 'Up' key
..Label1

;	dmovi	seq,impseq
	ldy	#1
	call	sethero

	jmp	go_on

stat_i	ENDPROC

turnl_i PROC
;
; spin heros head to the left
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat	turnl

	lda	headflag
	bne	..itsbot

	lda	facing
	bne	..fixhead
	jmp	lean_l_i

..itsbot
	lda	facing
	lbeq	bot_walk_l_i
	cmp	#$02
	beq	turnl

..fixhead
	lda	invert_flag
	ora	#$08	   ;change INC/DEC zero page into absolute
	eor	#$20	   ;change inc to dec/dec to inc
	sta	..smc01

	sta	rd_aux
	sta	wr_aux
..smc01 dec	spr_11+1	;!!!!!!!self modifying!!!!!!!!!
	sta	rd_main
	sta	wr_main

turnl	ldx	facing
	beq	..turnd
	cpx	#$02
	bne	..do_turn
	lda	headflag
	beq	..do_turn
	lda	stkval
	and	#$04
	beq	..bot_centered

..do_turn
	dex
	stx	facing
	txa
	tay
	clc
	adc	headflag
	tax
	sta	wr_aux
	lda	headlo,x
	sta	spr_11+4
	lda	headhi,x
	sta	spr_11+5
	sta	wr_main
	cpy	#0
	bne	..skip

	lda	invert_flag
	ora	#$08	   ;change INC/DEC zero page into absolute
	sta	..smc02

	sta	rd_aux
	sta	wr_aux
..smc02 inc	spr_11+1	;!!!!!!!self modifying!!!!!!!!!
	sta	rd_main
	sta	wr_main

..skip	sta	wr_main
	jsr	setbeastie
	jmp	go_on

..turnd
	lda	headflag
	bne	..bot_turnd

	lda	stkval
	bit	left
	lbne	lean_l_i
	jmp	stat_i

..bot_turnd
	lda	stkval
	bit	left
	lbne	bot_walk_l_i
	jmp	bstat_i

..bot_centered
	lda	stkval
	bit	left
	lbne	go_on
	jmp	bstat_i


turnl_i ENDPROC

**************************************

turnr_i PROC
;
; spin heros head to the right
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat	turnr
	lda	headflag
	bne	..its_bot

	ldx	facing
	cpx	#4
	bne	..fixhead
	jmp	lean_r_i

..its_bot
	ldx	facing
	cpx	#$04
	lbeq	bot_walk_r_i
	cpx	#$02
	beq	turnr

..fixhead
	lda	invert_flag
	ora	#$08	   ;change INC/DEC zero page into absolute
	eor	#$20	   ;change inc to dec/dec to inc
	sta	..smc03

	sta	rd_aux
	sta	wr_aux
..smc03 dec	spr_11+1	;!!!!!!!self modifying!!!!!!!!!
	sta	rd_main
	sta	wr_main

turnr
	ldx	facing
	cpx	#$02
	bne	..do_turn
	lda	headflag
	beq	..do_turn
	lda	stkval
	and	#$08
	beq	..bot_centered

..do_turn
	cpx	#4
	beq	..turnd
	inx
	stx	facing

	txa
	tay
	clc
	adc	headflag
	tax

	sta	rd_main
	sta	wr_aux
	lda	headlo,x
	sta	spr_11+4
	lda	headhi,x
	sta	spr_11+5
	sta	wr_main

	cpy	#4
	bne	..skip

	lda	invert_flag
	ora	#$08	   ;change INC/DEC zero page into absolute
	sta	..smc04

	sta	rd_aux
	sta	wr_aux
..smc04 inc	spr_11+1	;!!!!!!!self modifying!!!!!!!!!
	sta	rd_main
	sta	wr_main

..skip
	jsr	setbeastie
	jmp	go_on

..turnd
	lda	headflag
	bne	..bot_turnd

	lda	stkval
	bit	right
	lbne	lean_r_i
	jmp	stat_i

..bot_turnd
	lda	stkval
	bit	right
	lbne	bot_walk_r_i
	jmp	bstat_i

..bot_centered
	lda	stkval
	bit	right
	lbne	go_on
	jmp	bstat_i


turnr_i ENDPROC

*****************************************************

imp_i	PROC
;
; impatience state (droid)
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat	imp
	dmovi	seq,impseq
	move	counter,#0

;************************************
	lda	#1		;<-------kam patch
	sta	impatient
;************************************
	 lda	  #$80
	 sta	  netphase

imp	inc	counter
	ldx	counter
	cpx	#9
	bcs	..skip1

	sta	rd_main
	ldy	impdat,x
	beq	..exit

	call	sethero

..exit	jmp	go_on

..skip1 dec	hero_y
	dec	hero_y
	ldy	#1
	call	sethero
	inc	hero_y
	inc	hero_y
	move	counter,#$ff

	lda	stkval
	and	#$cf
	beq	..exit

;**************************************
	lda	#0		;<-----------kam patch
	sta	impatient
;**************************************

	 lda	  #$ff
	 sta	  netphase

	jmp	stat_i

imp_i	ENDPROC




****************************
*			   *
*			   *
*	bot stuff	   *
*			   *
*			   *
****************************

	 seg	  zpglobal
walk_pos ds	  1



	 seg	  maincode

trans_i PROC
;
; transform from the droid to the bot
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	sta	rd_aux		;HES patch.
	lda	spr_10
	sec			;HES patch.
	sbc	spr_11		;HES patch.
	sta	rd_main 	;HES patch.

	sta	wr_aux
	lda	#null
	sta	spr_8+3
	sta	spr_9+3
	sta	wr_main 					;23-Apr-88  HES

	sta	sav_droid_eye

	cstat	trans
	move	headflag,#5
	dmovi	seq,trnseq
	move	counter,#0
	lda	facing
	bne	..rght
	sta	savface
	lda	#$05
	sta	facing
	jmp	trans

..rght
	lda	#$04
	sta	savface
	move	facing,#11

trans	inc	waste
	lda	waste
	cmp	#3
	bcc	..exit
	move	waste,#0

	ldy	counter
	cpy	#12
	bcs	..done

	call	sethero
	inc	facing
	inc	counter
	inc	counter

..exit
	jsr	  do_sprites

	jmp	(state)


..done
	move	facing,savface
	dmovi	seq,bot_walk_seq

	ldy	#$00
	sty	squat_pos

	iny
	sty	walk_pos

	ldy	#$03
	call	sethero

	jsr	  do_sprites

;************************* kam patch 4-15-88 **********************
	lda	energy_level
	cmp	#28
	bcs	..kam10 		;e.l. >= 28 units
	sta	transform_energy
	lda	#0
	sta	energy_level
	jmp	panel_i
..kam10
	lda	#28
	sta	transform_energy
	lda	energy_level
	sec
	sbc	#28
	sta	energy_level
;******************************************************************


	jmp	panel_i

trans_i ENDPROC

	 seg	  maindata
sav_droid_eye	  ds	   1

	 seg	  maincode

trbck_i PROC
;
; transform from the bot to the droid
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	cstat	trbck
	dmovi	seq,trnseq
	move	counter,#10
	lda	facing
	bne	..rght

	lda	#$00
	sta	savface
	move	facing,#10
	jmp	trbck

..rght	move	savface,#4
	move	facing,#16

trbck	inc	waste
	lda	waste
	cmp	#3
	bcc	..exit
	move	waste,#0

	ldy	counter
	bmi	..done

	call	sethero
	dec	facing
	dec	counter
	dec	counter

..exit
	 lda	  #$ff
	 sta	  boltphase

	 lda	  #$00
	 sta	  wr_aux
	 sta	  spr_8+3
	 sta	  wr_main

	jsr	  do_sprites

	jmp	(state)

..done	move	facing,savface
	move	headflag,#0
	dmovi	seq,crouch_seq
	ldy	#$05
	jsr	sethero

	lda	sav_droid_eye

	sta	rd_aux		;HES patch.
	sta	wr_aux		;HES patch.
	clc			;HES patch.
	adc	spr_11		;HES patch.
	sta	spr_10
	sta	rd_main 	;HES patch.
	sta	wr_main 	;HES patch.

	lda	beastie_flag
	and	  #$04
	beq	  ..no_hopper
	jsr	  init_hopper_sprite
..no_hopper
	jsr	  setbeastie

	jsr	  do_sprites

;********************  kam mod ************************ 5-3-88
	lda	sparks_gone_flag
	beq	..kamtrbck1
	jmp	sparks_end_2		  ;sparks just ran out
..kamtrbck1
;******************************************************
;************************ kam patch 4-15-88 ***********************8
	clc
	lda	transform_energy
	adc	energy_level
	sta	energy_level
	bne	..kam20
;	 lda	 #1
;	 sta	 energy_level	 ;<-----temporary
	jmp	end_game
..kam20
;******************************************************************

	jmp	panel_i

trbck_i ENDPROC

bstat_i PROC
;
; Bot static state
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	lda	  panel_flag
	bpl	  ..not_in_panel
	jmp	  (state)

..not_in_panel
	cstat	bstat
	jmp	go_on

..upsidedown_offset equ      33


bstat
	lda	stkval
	tay
	and	#$c0
	beq	..ck_stick

	tya
	and	  #$02
	lbeq	  ..ck_stick

..panel_stuff
	 bit	  boltphase
	 lbpl	  ..exit

	 lda	  invert_flag
	 cmp	  #invert
	 lbeq	  ..exit

	jmp	panel_i

..ck_stick
	 tya
	 and	  #$01
	 beq	  ..not_up
	 lda	  squat_pos
	 bne	  ..set_standup

	 lda	  invert_flag
	 eor	  #$20
	 sta	  invert_flag
	 and	  #$20
	 bne	  ..normal

	 lda	  hero_y
	 sec
	 sbc	  #..upsidedown_offset
	 sta	  hero_y
	 jmp	  ..set_inversion

..normal
	 lda	  hero_y
	 clc
	 adc	  #..upsidedown_offset
	 sta	  hero_y
	 jmp	  ..set_inversion

..set_inversion
	 lda	  walk_pos
	 beq	  ..set_wide_left
	 cmp	  #$03
	 bne	  ..ok
	 lda	  #$01
	 bne	  ..set_walk_pos

..set_wide_left
	 lda	  #$02

..set_walk_pos
	 sta	  walk_pos

..ok
	 asl	  a
	 tay
	 iny
	 jsr	  sethero

	 jmp	  bfall_i

..set_standup
	 jmp	  bot_standup_i

..not_up
	 tya
	 and	  #$02
	 beq	  ..not_down

	 lda	  squat_pos
	 bne	  ..exit

	 lda	  walk_pos
	 beq	  ..exit
	 cmp	  #$03
	 beq	  ..exit

	 jmp	  bot_squat_i

..not_down
	 tya
	 and	  #04			     ;check for left
	 beq	  ..not_left
	 lda	  squat_pos
	 lbeq	  turnl_i
	 jmp	  bot_standup_i

..not_left
	 tya
	 and	  #$08			     ;check for right
	 beq	  ..exit
	 lda	  squat_pos
	 lbeq	  turnr_i
	 jmp	  bot_standup_i

..exit	jmp	go_on

bstat_i ENDPROC

**************************



panel_i  proc
;
; panel state
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 lda	  #$00
	 sta	  stkval

	 cstat	  panel

panel
;******************************************** kam mod
	jsr	call_sprite_routine	;fix after a transformation
;********************************************

	lda	panel_flag		     ;is panel up ?
	bmi	..ck_for_trans		     ;yes

;******************************************** kam mod
	lda	creature_flag
	cmp	#3
	beq	..kampanelcreaturefix
	lda	beastie_flag
	bne	..kampanelcreaturefix
	sta	creature_number
	sta	creature_flag
..kampanelcreaturefix
	long	prmsec,panel2		     ;!!!!!display panel!!!!!!	 HES
;**********************************************

	lda	#$80						;23-Apr-88  HES
	sta	panel_flag
..ck_for_trans
	bit	panel_flag		     ;has he released the fire
	bvs	..ck_trans		     ;button ?

	lda	stkval			     ;no, so keep checking
	and	#$c0
	bne	..get_out_hoser 	     ;still hasn't
	lda	#$c0
	sta	panel_flag
	bne	..ck_trans

..get_out_hoser
	long	prmsec,stick
	jmp	(state) 		     ;because this is "pause"



..ck_trans
	lda	stkval
	tay
	and	#$c0
	beq	..ck_for_exit

;
; check for creature release here
;

	jsr	bar
	bcs	..kam1
	jmp	..get_out_hoser
..kam1
	lda	headflag
	beq	..fromdroid


	jmp	trbck_i

..fromdroid
	jmp	trans_i

..ck_for_exit
	tya
	and	#$01
	bne	remove_panel

;
; move arrow here
;
	clc
	jsr	sarrow


	long	prmsec,stick
	jmp	(state) 		     ;because this is "pause"

remove_panel
	lda	#$00
	sta	panel_flag
;************************************************************
;the following clears the panel then stamps the images, uses
;  edge cleanup,  then copies to the other screens
	sta	wr_aux						;kam
	lda	#0						;kam
	sta	spr_1+6 					;kam
	sta	Spr_1+9 					;kam
	sta	table_onevaluememorywrite+4			;kam
	lda	#$5e						;kam
	sta	table_onevaluememorywrite			;kam
	sta	table_onevaluememorywrite+1			;kam
	sta	rd_main 					; Fudge.
	sta	wr_main 					; Fudge
	jsr	call_sprite_routine
	clc							;kam
	long	prmsec,onevaluememorywrite			;kam
	sta	wr_main
;	 sta	 page1
	sec							;kam 4-27-88
	long	prmsec,onevaluememorywrite			;
	clc						;kam 4-30-88
	long	prmsec,panel1				;kam 4-30-88
	lda	clock_flag			;is time being shown
	bpl	..clockskip			;   no
	sec						;kam 4-30-88
	long	prmsec,panel1				;kam 4-30-88
..clockskip
	long	prmsec,clrscreenedges		       ;kam 4-30-88
	clc
	long	prmsec,panelcopy			;kam 4-30-88
	lda	headflag
	beq	..kamremovepanel1
	lda	creature_number
	cmp	#3
	beq	..kamremovepanel1
	lda	clock_flag
	bmi	..kamremovepanel1
	lda	#0
	sta	clock_flag
	long	prmsec,spark_display		       ;show sparks
..kamremovepanel1
;	jsr	SetRoom_C					;
;  end of modifications to this section of code

	lda	headflag
	beq	..droid_exit

	cstat	..panel_exit_delay
	jmp	go_on

..panel_exit_delay
	lda	stkval
	and	#$01
	bne	..not_yet
	jsr	checkunderbot
	cmp	#$20
	bne	..terra_firma
	jmp	bfall_i

..terra_firma
	jmp	bstat_i

..not_yet
	jmp	go_on

..droid_exit
	jsr	checkunderdroid
	cmp	#$20
	bne	..terra_haute
	jmp	dfall_i

..terra_haute
	jmp	dr_standup_i

	 seg	  statvars
..panel_delay	  ds	   1

	 seg	  maincode


panel_i  endproc



do_sprites	  proc
	jsr	 call_the_sprite_routine

	ldx	  display
	sta	  page1,x
	txa
	eor	  #$01
	sta	  display
	lda	  workon
	eor	  #$60
	sta	  workon

	rts

do_sprites	  endproc





**************************

	SEG	maindata
panel_flag	  ds	   1
sting_man_frame   ds	   1

up	db	$01
down	db	$02
left	db	$04
right	db	$08



impseq	db	4
	dw	dr_stand
	dw	dr_sq1
	dw	dr_sq2
	dw	dr_sq3

trnseq	dw	trans1
	dw	trans2
	dw	trans3
	dw	trans4
	dw	trans5
	dw	trans6
	dw	bot_walk2

bot_walk_seq
	 db	  4
	 dw	  bot_walk1
	 dw	  bot_walk2
	 dw	  bot_walk3
	 dw	  bot_walk4



	SEG	maincode

sethero PROC
;
; set sprite x,y,color,flag(indicating normal or inverted),pointer
;
; A,X,P - nothing passed
;
; Y - index into word sized address table indicating which frame to
; display
;
;
; A,X,Y,P - scrambled
;

	 sta	  rd_main
	 sta	  wr_main

	 sty	  last_seq_index

	lda	(seq),y
	sta	img
	iny
	lda	(seq),y
	sta	img+1

	sta	rd_aux
	sta	wr_aux

	ldy	#23

..loop
	lda	(img),y 	;high pointer
	sta	spr_10,y
	dey
	lda	(img),y 	;low pointer
	sta	spr_10,y
	dey

	lda	(img),y 	;flag
	beq	..disabled

	sta	rd_main
	lda	invert_flag		     ;rtu 3-5-88
	sta	rd_aux

..disabled
	sta	spr_10,y
	dey
	cmp	#$e6

	lda	(img),y 	;color
	sta	spr_10,y
	dey

	sta	rd_main 					;23-Apr-88  HES
	lda	hero_y	       ;ypos
	sta	rd_aux						;23-Apr-88  HES

	bcc	..updwn

	clc
	adc	(img),y
	jmp	..skp66

..updwn sec
	sbc	(img),y



..skp66
	 tax
	 bpl	  ..after_skp66
	 cmp #196
	 bcc ..after_skp66
	 cmp	  #$ed
	 bcs ..after_skp66

	  tya
	 pha
	 clc
	 adc #$02
	 tay
	 lda #null
	 sta spr_10,y
	 pla
	 tay
	 jmp ..store_hero_sprite_y

..after_skp66
	 txa

..store_hero_sprite_y
  sta	  spr_10,y




	dey

	lda	(img),y 	;xpos
	clc

	sta	rd_main 					;23-Apr-88  HES
	adc	hero_x
	sta	rd_aux						;23-Apr-88  HES

	cmp	#$a0			     ;rtu
	bcc	..itsok 		     ;rtu
					     ;rtu
	lda	#$00			     ;rtu
					     ;rtu
..itsok 				     ;rtu
	sta	spr_10,y
	dey

	bpl	..loop

	sta	rd_main 					;23-Apr-88  HES

	lda	facing
	clc
	adc	headflag    ;hero is = bot if 5; droid if 0
	tay
	lda	headlo,y
	sta	spr_11+4
	lda	headhi,y
	sta	spr_11+5

	sta	wr_main


	rts


sethero ENDPROC

setbeastie	  proc
;
; set sprites for all released creatures
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sta	  rd_main
	 sta	  wr_main

	 lda	  headflag
	 lbne	  ..exit

	 lda	  beastie_flag
	 lbeq	  ..exit
	 tax
	 and	  #$03
	 beq	  sethopper

;
; do the beasties that ride on his head
;

	 txa
	 and	  #$01
	 bne	  ..set_stinger

..set_man_o_war
	 lda	  #low manowar_seq
	 sta	  tdbl1
	 lda	  #high manowar_seq
	 sta	  tdbl1+1

	 sta	  wr_aux

	 lda	  #white
	 sta	  spr_9+2

	 jmp	  ..set_head_beastie_pntr

..set_stinger
	 lda	  #low stinger_seq
	 sta	  tdbl1
	 lda	  #high stinger_seq
	 sta	  tdbl1+1

	 sta	  wr_aux

	 lda	  #green
	 sta	  spr_9+2


..set_head_beastie_pntr
	 lda	  sting_man_frame
	 asl	  a
	 tay
	 lda	  (tdbl1),y
	 sta	  spr_9+4
	 iny
	 lda	  (tdbl1),y
	 sta	  spr_9+5

	 sta	  rd_aux

	 lda	  spr_11
	 clc
	 adc	  #$02
	 sta	  spr_9

	 lda	  spr_10+1
	 sec
	 sbc	  #25
	 sta	  spr_9+1

	 lda	  #norm
	 sta	  spr_9+3

	 lda	  #$00
	 sta	  spr_8+3

	 jmp	  ..exit




sethopper
	 txa
	 and	  #$04
	 beq	  ..ck_for_borer

	 sta	  rd_main
	 sta	  wr_aux

..display_hopper
	 lda	  hopper_x
	 sta	  spr_9

	 ldx	  hopper_frame
	 lda	  hopper_y
	 sec
	 sbc	  ..hopper_offset_y_tab,x
	 sta	  spr_9+1

	 lda	  #orange
	 sta	  spr_9+2

	 lda	  #norm
	 sta	  spr_9+3

	 lda	  #$00
	 sta	  spr_8+3

	 cpx	  #6
	 bcc	  ..hopper1
	 cpx	  #23
	 bcc	  ..hopper2

..hopper1
	 lda	  #low hopfrnt1
	 sta	  spr_9+4
	 lda	  #high hopfrnt1
	 sta	  spr_9+5
	 jmp	  ..exit

..hopper2
	 lda	  #low hopfrnt2
	 sta	  spr_9+4
	 lda	  #high hopfrnt2
	 sta	  spr_9+5
	 jmp	  ..exit




..ck_for_borer
	 txa
	 and	  #$10
	 beq	  ..exit

	 lda	  borer_facing
	 asl	  a
	 ora	  borer_frame
	 asl	  a
	 tax

	 lda	  borer_seq,x
	 sta	  tdbl1
	 lda	  borer_seq+1,x
	 sta	  tdbl1+1

	 ldy	  #11

	 sta	  wr_aux
	 sta	  rd_aux


..load_borer_sprites_loop
	 lda	  (tdbl1),y		     ;pointer
	 sta	  spr_8,y
	 dey
	 lda	  (tdbl1),y
	 sta	  spr_8,y
	 dey

	 lda	  (tdbl1),y		     ;flag
	 sta	  spr_8,y
	 dey

	 lda	  (tdbl1),y		     ;color
	 sta	  spr_8,y
	 dey

	 lda	  borer_y		     ;y
	 clc
	 adc	  (tdbl1),y
	 sta	  spr_8,y
	 dey

	 lda	  borer_x		     ;x
	 clc
	 adc	  (tdbl1),y
	 cmp	  #20+140
	 bcc	  ..spr_x_ok
	 lda	  #$00
..spr_x_ok
	 sta	  spr_8,y
	 dey

	 bpl	  ..load_borer_sprites_loop




..exit
	sta	rd_main
	sta	wr_main
	rts


	 seg	  maindata

..hopper_offset_y_tab
	 db	  0,0,0,0,0,0,5,9,13,16,19,22,24,26,28,29,30,31,31,31
	 db	  31,31,30,29,28,26,24,22,19,16,13,9,5

	 seg	  maincode

setbeastie     endproc

	END

