$CHIP(6502)
$PAGINATE
;$ERRONLY

	 %INCLUDE prmseg.inc
	 %INCLUDE ZPEXT.ASM

	 SEG	  maincode

	 public   set_room_pointer,random,randomize
;
; ASSORTED SUBROUTINES
;
	 EXTERN   TXTLINE,INDENT,RD_OS_TAB,RD_MAIN
	 EXTERN   ANRES,ANIN0,STICK,max_stick_val


random	 proc
;
; generate pseudo-random number
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

	 sec
	 lda	  rnd_pad+1
	 adc	  rnd_pad+4
	 adc	  rnd_pad+5
	 sta	  rnd_pad

	 ldx	  #$04
..rnd_loop
	 lda	  rnd_pad,x
	 sta	  rnd_pad+1,x
	 dex
	 bpl	  ..rnd_loop

	 rts

	 seg	  richtemp
rnd_pad 	  ds	   6

	 seg	  maincode
random	 endproc

randomize	  proc
;
; initialize random scratch-pad
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;

..vblnk  equ	  $c019

	 ldx	  #$10
..outer_loop
	 ldy	  #$00
..inner_loop
	 lda	  ..vblnk
	 asl	  a
	 adc	  rnd_pad+4
	 ror	  rnd_pad+2
	 adc	  rnd_pad+1
	 sta	  rnd_pad+3
	 lda	  ..vblnk
	 adc	  rnd_pad
	 sta	  rnd_pad
	 adc	  rnd_pad+4
	 sta	  rnd_pad+4
	 lda	  ..vblnk
	 eor	  rnd_pad+2
	 sta	  rnd_pad+1
	 eor	  rnd_pad+3
	 sta	  rnd_pad+2
	 dey
	 bne	  ..inner_loop
	 dex
	 bne	  ..outer_loop

	 rts

randomize	  endproc

set_room_pointer  proc
;
; X,Y,P - nothing passed
;
; A - current_room
;
; A,X,Y,P - scrambled
;

	sta	rd_main

	ASL	A
	TAX
	LDA	RD_OS_TAB-2,X
	STA	TDBL1
	LDA	RD_OS_TAB-1,X
	STA	TDBL1+1

	CPX	#$BC
	BCC	..ITS_AT_D000

	LDA	TDBL1
	CLC
	ADC	#LOW ($0CC7)
	STA	TDBL1
	LDA	TDBL1+1
	and	#$0f
	ADC	#HIGH ($0CC7)
	STA	TDBL1+1
	BNE	..exit

..ITS_AT_D000
	LDA	TDBL1
	CLC
	ADC	#LOW ($D000)
	STA	TDBL1
	LDA	TDBL1+1
	ADC	#HIGH ($D000)
	STA	TDBL1+1

..exit
	 rts

set_room_pointer  endproc

	 END
